CHANGES
=======

14.0.4
------

* RBD: fix volume reference handling in clone logic
* [Unity] Fix TypeError for test case test\_delete\_host\_wo\_lock
* Add new license scheme for Flashsystem9000 series
* NEC driver: fix an undefined variable
* ChunkedBackupDriver: Freeing memory on restore
* Cinder backup export broken
* PowerMax Docs -  corrections and improvements
* Tell reno to ignore the kilo branch
* Fix: Create new cache entry when xtremio reaches snap limit
* Support Incremental Backup Completion In RBD
* Make volume soft delete more thorough
* Cap sphinx for py2 to match global reqs
* PowerMax Driver - Volume group delete failure

14.0.3
------

* Fix service\_uuid migration for volumes with no host
* Pure Storage - Fix disconnect error in clustered environments
* PowerMax Driver - PowerMax Formatted Vols Fix
* Increase cpu limit for image conversion
* Fix VxFlexOS documentation
* Switch to opensuse-15 nodeset
* Pure: Ensure generated volume name does not exceed 63 characters
* NEC Driver: Python3 compatibility
* VNX: delete the LUN from VNX backend
* Rollback the volume\_types table when failed to update quota\_usages
* Make backup\_compression\_algorithm case insensitive
* Fix code-block JSON format issues
* Refresh the Service.service\_id after re-spawning children

14.0.2
------

* Google backup: correct string encoding between py 2 and 3
* Fix up test\_snapshot notify tests
* Add context to cloning snapshots in remotefs driver
* Don't allow retype to encrypted+multiattach type
* Dell EMC SC: Handle the mappings of multiattached volume
* 3PAR: Add config for NSP single path attach
* Fix NFS volume retype with migrate
* Fix LVM IPv6 target portals
* NetApp ONTAP: Fix JSON serialization error on EMS logs
* PowerMax Docs Stein - clarifying information
* Fix ceph: only close rbd image after snapshot iteration is finished
* Move DotHill release note to correct location
* Fixing 404's and broken links
* Fix DetachedInstanceError for VolumeAttachment
* Prevent double-attachment race in attachment\_reserve
* doc: Fix rbd driver marked support multiattach

14.0.1
------

* Fix assertion methods in a unit test
* PowerMax docs - add information on new and existing functionality
* Add OS-SCH-HNT in extensions list
* Remove Sheepdog tests from zuul config
* [VNX] Fix test case issue
* Add Upgrade Check for Drivers Removed in Stein
* Add upgrade check for Windows iSCSI driver
* Add upgrade check for presence of policy.json file
* Fix "connector=None" issue in Kaminario drivers
* lvm: Only use initiators when comparing connector dicts
* Make sure we install cinder requirements during the correct tox phase
* 3PAR: Provide an option duing creation of volume from snapshot
* Fix swift backup driver crashing during service startup
* OpenDev Migration Patch
* NetApp: Return all iSCSI targets-portals
* Add upgrade checker for backup driver path
* Remove scanning upgrade checker from opts generation
* Add NetApp E-Series Driver to Removal List

14.0.0
------

* Handling filters in Generalized Filtering API
* Replace openstack.org git:// URLs with https://
* Update UPPER\_CONSTRAINTS\_FILE for stable/stein
* Update .gitreview for stable/stein

14.0.0.0rc1
-----------

* Fix Support Matrix - Pure does support Multiattach
* Gate Fix: Bumping versions in lower-constraints.txt
* Fix VolumeAttachment is not bound to a Session
* Modify the configuration mode of FusionStorage Cinder Driver
* Automate generation of snapshots api-ref samples
* Adds revert to snapshot feature to support matrix
* PowerMax docs -  changing cinder tags to powermax
* Use excutils.save\_and\_reraise\_exception instead of reraise
* PowerMax driver -  test fixes for \_sanity\_port\_group\_check
* NetApp SolidFire: Fix misbehavior on account creation
* Add get\_driver\_options method
* docs: mark rbd driver support for extending an in-use volume
* Revert "Remove truncate from rootwrap filters"
* Revert "Use native python truncate for privsep"
* NetApp SolidFire: Fix multi-attach volume deletion
* Update required version of taskflow
* Update minimal acceptable glanceclient
* Create volume attachments status check
* Add project\_id in group snapshots list and show API
* Use 'target\_helper' config opt in linstor driver
* Update oslo.privsep minimum requirement
* Use new target\_\* options in documentation
* Remove py35 from setup.cfg
* Add oslo.privsep to config-generator list
* Fix typo in the comment
* Use config-table for dynamic config documentation
* Drop py35 jobs
* VNX: update sg in cache
* Disable etcd3 for lio-barbican job
* Extend timeout for database migration tests
* Improve documentation of goodness/filter function
* api-ref: add qos\_specs\_id to show default volume type response
* Update support matrix of Huawei driver
* Define single place for irrelevant-files
* Fix Snapshot object metadata loading
* Use native python truncate for privsep
* Fix python3 compatibility of rbd get\_fsid
* Remove truncate from rootwrap filters
* Trim test list for lio-barbican job
* Tests: Fix up migrate notify tests
* Pylint: Filter out cinder.objects and requests E1101
* Fix version return incorrect when endpoint url end without /
* Update section 'When do i need a new Microversion?'
* docs: Add os-migrate\_volume\_completion api-ref
* Doc8: Stop skipping D001: Line too long
* Include .inc files in doc8 linting
* NetApp SolidFire: Thin provisioning scheduler support
* REST connector for Brocade zone driver
* Fix for auth version change in Brcd HTTP
* Remove drbdadm from filters
* Replace 'lvconvert' from rootwrap
* PowerMax Driver - Unmanage Snapshot Improvements
* PowerMax driver - performance improvements
* PowerMax Driver - Unit Test Refactoring
* PowerMax driver - do an rdf\_group check earlier
* Limit RBD discard to 32 bit chunks
* Fix incorrect replication info for RBD
* Remove LOCI publishing from the post pipeline
* Add empty check before using zone driver
* VNX Driver: delete\_hba() instead of remove\_hba()
* PowerMax driver - handle special case where IG exists
* PowerMax driver -  move pagination code to request
* PowerMax driver - do the portgroup check earlier
* PowerMax driver - solve issue of concurrent snapvx operations
* Compact DB migrations to Ocata
* Automate generation of volume actions api-ref samples
* Fix some miscapitalizations of VMware
* RBD: add support for multiattach
* PowerMax Driver - Storage-assisted in-use retype support
* Use oslo.privsep for 'lvcreate'
* Add Python 3.6 version in setup.cfg
* Update install docs to match default NFS config
* Update rbd thin-provisioning in support-matrix
* Remove legacy-tempest-dsvm-full-drbd-devstack job
* Drop nova-multiattach job
* Declare multiattach support for HPE MSA
* Remove 'tgtadm' from rootwrap
* Huawei driver refactor(2/10)
* Adding microversion in releasenote "project\_id response in groups"
* Support transfer pagination
* Switch tempest-slow to be run on python 3
* Remove LIO multiattach release note
* Fix HPE3PAR not returning cached stats
* Add project\_id in group list and show API
* Return WWN for validation in Pure Storage drivers
* PowerMax Driver - Replication Settings Fix
* PowerMax driver -  code cleanup and minor improvements
* QNAP: Add support for QTS 4.4.0
* api-ref: Add cipher to update an encryption type interface
* VMAX driver doc - clarify PowerMax rebrand release note
* Fix keystone auth config in install doc
* Fix "import xxx as xxx" grammar
* Add missing ws seperator between words
* Add check\_encryption\_provider to volume utils
* fast8 improvements
* Huawei driver refactor(1/10)
* Cleanup rootwrap filters
* Fix gigabytes usage error when deleting snapshot group
* Report msg error when cannot revert to snapshot
* Fix for HPE MSA 2050 login failures
* Pass image\_id to ImageDownloadFailed
* Update FusionStorage Cinder Driver by using REST API
* Move Fujitsu ETERNUS DX related file
* Correct default policy\_file in the sample config
* Remove 'lvrename' from rootwrap
* LinstorDrv : Fix wrong key using when getting device path
* Create new image volume cache entry when cloning fails
* Refactor on policy in code
* Add policy test for volume extend/retype/update\_ro policy
* Add policy test for volume metadata policy
* Add policy test for volume action policy
* Add policy test for volume update/del policy
* VMware: Implement retype
* VMware: Release notes for vmware\_storage\_profile
* Temporary solution for fixing gate test\_tpool\_size
* Improve volume transfer records
* PowerMax driver -  changing from 8.4 to 9.0 REST endpoints
* Handle 'is\_public' filter in volume-type list
* Automate generation of volumes api-ref samples
* Imported Translations from Zanata
* Implement volume capacity stats for VMware
* Switch ietadm to use olso.privsep
* Enable some tests in the cinder.tests.unit.test\_cmd module for MacOS
* Initiating Cinder Volume Manager with large number of volumes
* Avoid using 'truncate' on Windows
* PowerMax driver - rebranding VMAX to PowerMax
* [Doc] Fix typos
* Fix for CI information in SPDK volume driver
* Add test case: extend non-exist volume
* Reset snapshot status available
* Add test case: retype volume when driver not initialized
* Add test case: delete snapshot when driver not initialized
* Automate generation of API versions api-ref samples
* NetApp Doc: Enhance 'netapp\_storage\_protocol' description
* SPDK drivers documentation
* Fixup some issues of Inspur AS13000 cinder driver
* add resource filters to the included data\_files
* LINBIT DRBDManage driver moves to maintenance mode
* Fix Xtremio driver configuration ordering
* Support deferred deletion in RBD
* Remove those copy words occured twice times in dell-emc-vmax-driver.rst
* Add new LINSTOR volume driver
* Hedvig Cinder driver implementation
* cinder-volume: Stop masking IOError different than ENOSPC
* Add missing backup status in API doc
* Using wrong parameter in test\_backup\_ceph
* Move 'attach.end' notify to attachment\_complete
* Mask passwords in utils.trace for func params
* Fix CI failed: test\_get\_volume\_filter\_options\_using\_config
* QNAP: Support QES FW on TDS series NAS
* ScaleIO: Fix Extra Spec parameter name in driver doc
* Remove support for NetApp E-Series systems
* Adding SPDK volume driver
* Delete related encryption provider when a volume type is deleting
* Fix retype notifier test case (BackupNFSTestCase)
* [api-ref] Fix the parameter of image metadata
* Handle string status codes in logging
* VMAX Driver - Failover Unisphere Support
* Remove vgc-cluster
* Remove 'ln' command from rootwrap filter
* Add policy configuration howto
* Remove umount from volume.filters
* Refactor for Veritas iSCSI driver
* Add x\_project\_id, accepted to transfers
* Add policy test for volume create policy
* Ignore migration 127 error on MariaDB
* [Unity] Storage-assisted migration support
* Use renamed template 'integrated-gate-py3'
* Allow to use \_max qos option together with per\_gb
* Driver reinitialization after failure
* Correct the use of assertTrue
* Revert "Synchronize all LVM operations"
* Update IBM storwise svc driver doc
* api-ref: volume\_type\_access should be array instead of object
* Fix \_per\_gb\_min usage with \_per\_gb
* Set message property in ImageDownloadFailed
* Fix A/A 'resource\_backend' when scheduling volumes
* Add irrelevant-files for integrated test jobs
* Handle image download and conversion errors
* Synchronize all LVM operations
* Rename BackupNFSSwiftBasedTestCase
* Cinder volume driver for Inspur AS13000 series
* Add user\_id in backup list and show API
* Fix permissions with NFS-backed snapshots and backups
* VMware: Storage policy support
* VMware: Add support for vStorageObject snapshots
* Make policy config docs consistent
* Revert "Ceph driver should respect the \`--incremental\` option for backups"
* api-ref: add response body for set-image-metadata-for-a-volume
* Revert "Move check\_encryption\_provider to volume utils"
* VMAX Driver - VMAX OS Upgrade Bug
* PowerMax driver doc - clarifying SE and Unisphere support
* Doc: Remove unnecessary note
* Extract copy\_image\_to\_volume into volume utils
* Ensure image utils don't block greenthreads
* Adding missing Volume states to VolumeStatus enum
* Automate generation of api-ref samples
* Add policy test for TENANT\_ATTRIBUTE\_POLICY
* Imported Translations from Zanata
* Add missing ws seperator between words
* Change a function name of swift backup
* Tests : notifier problem with backup
* Change openstack-dev to openstack-discuss
* Add secret=true to fixed\_key configuration parameter
* Cleanup code duplication in cinder.cmd.backup module
* Fix the problem of the scheduler status
* Check Volume Status on attahcment create/update
* Stop cleaning images to be deleted in remotefs driver
* Retry on DBDeadLock affecting worker updates
* Add test case: clone volume with bad size
* Remove deprecated query\_volume\_filters config option
* Correct default policy file
* VMAX Driver - Place volume in SG as part of unmanage volume
* PowerMax driver doc - removing support for VMAX2
* Ceph driver should respect the \`--incremental\` option for backups
* api-ref: fix some issues in volumes interfaces
* VMware: Check empty provider location
* Ignore updated stable release note
* [Doc] Fix status and parameters of vol connection api
* Imported Translations from Zanata
* An alternate way to fix retype notifier test case
* api-ref: document encryption type provider choices
* Imported Translations from Zanata
* api-ref: volume summary is available from v3.12
* Revert "Remove mount from volume.filters"
* Adding SPDK NVMe-oF target driver
* doc: Change variable name DEFAULT\_API\_VERSION to \_MIN\_API\_VERSION
* Block broken requests 2.20.0
* [api-ref] Fix the value of project\_id
* NetApp SolidFire: Revert volume to snapshot
* lvm: Avoid premature calls to terminate\_connection for muiltiattach vols
* api-ref: fix succeed code and add field for update-backup
* api-ref: add missing volumes\_links in list-volume interfaces
* api-ref: Adding backup create response example
* Add policy test for volume GET\_ALL\_POLICY
* Imported Translations from Zanata
* Set right attach mode after migration
* api-ref: fix response example of list-backups
* Make lower constraints CI works well
* api-ref: fix response code and data type for volume interfaces
* Imported Translations from Zanata
* Improve/Clean api-ref parameters
* [Trivial Fix] Correct spelling error of "bandwidth"
* Add test coverage to manage existing flow
* VMAX driver - allow for a clean system with no initiator groups
* Drop simplejson usage
* Remove Babel from requirements
* Update docs landing page to follow guideline
* api-ref: Correct response body type for show host details
* Increase the length of resource property in quota\_usages
* Remove DeprecationWarning of "decodestring()"
* VMAX Driver - Fix for invalid device id length
* Remove out-of-date configurations in setup.cfg
* Add policy test for volume:force\_delete
* add missing comma
* Simplify the policy test case
* Fix a typo in multiattach doc
* Remove setup.py check from pep8 job
* [Trivial] Fix typo in comment in delete\_volume
* Update backup flow for CephBackupDriver
* Imported Translations from Zanata
* Handle rbd.OSError on broken RBD image
* Fix non iSCSI attach serialization
* Set user message on volume create failure
* Imported Translations from Zanata
* Raise the ImageTooBig exception when found it
* Move tgt targets to privsep
* Fix and Optimize : retype tests
* hpe 3par driver initialization failure
* api-ref: cleanup status conditions for backup/restore APIs
* PY3: Ensure rados.Object.read/write use byte data
* Forbidden to revert volume to a different size snapshot
* Fix debug message for \_copy\_volume\_data
* Remove scstadmin from rootwrap
* [Trivial] Replace 'action' with 'command' in cinder-status doc
* Allow using forward slashes in metadata
* Fix unexpected behavior in \_clone\_image\_volume
* Remove scsi\_id from rootwrap filter
* Remove mount from volume.filters
* Drop drv\_cfg from rootwrap filters
* Remove touch command from volume.filters
* Imported Translations from Zanata
* cinder-manage online\_data\_migrations fixes
* Handling unexpected python error "NoneType object is not iterable"
* Base framework for cinder-status upgrade check
* api-ref: add missing fields in volume group types
* Huawei: Simplify wait\_for\_condition calls
* Update sphinx extension logging
* Restructure Huawei driver
* VMAX: set faked max\_oversubscription\_ratio
* Move cinder-manage page to cli doc subtree
* api-ref: fix some inconsistencies in snapshot API
* Add test-requirements to pylint reqs
* Rename cinder.privsep.utils to cinder.privsep.path
* Adding regression test for update\_group
* DS8K: correct the usage for ssl method(SSLContext.wrap\_socket)
* Fix: storage\_pools key in Huawei Driver
* Imported Translations from Zanata
* Fix for field type error
* fix misspelling of available
* Imported Translations from Zanata
* Increment versioning with pbr instruction
* Mark Veritas HyperScale Driver Unsupported
* Cinder Backup: object\_count value incorrect
* Extract volume image metadata into volume utils
* Extract \_get\_image\_metadata into volume utils
* Use tempest-pg-full
* Remove the ITRI DISCO driver
* NFS Backup: Avoid TypeError in os-brick when not configured
* [minifix] Update reno formatting on Quobyte driver defaults change
* api-ref: totalSnapshotsUsed in limits response should be integer
* Add column only when it doesn't exist
* VNX: Add constraints for async migration
* Remove volume:get policy from test policy file
* Replace openSUSE experimental check with newer version
* Fix for cinder-manage db purge
* Follow Up: Generalizing is\_replicated\_str to is\_boolean\_str
* api-ref: Add response fields and response example for snapshot manage
* api-ref: remove created\_at from response example of list-transfer
* Handle drivers that do not support list manageable
* Fix doc output examples
* Fix: UnboundLocalError variable referenced before assignment
* api-ref: Add response fields and response example for volume manage
* api\_ref: total\_capacity and free\_capacity can be float
* Stop using deprecated rpc\_backend option
* Don't quote {posargs} in tox.ini
* Imported Translations from Zanata
* api-ref: qos and extra\_spec are optional in types view
* Fix wrong uuid recognized when create group
* api-ref: Fix namespace parameter for backend capabilities
* Imported Translations from Zanata
* SF ensure the correct volume is deleted
* Mark the Nexenta Edge driver unsupported
* Mark the Tintri driver unsupported
* Remove source\_replica info from api-ref
* Remove sg\_scan
* Update unit test debug instructions
* API-REF:os-quota-sets v2 API reference has the wrong parameters
* VMAX docs - Replace serial\_number
* Remove the HGST Flash Storage Driver
* Add missing 'is\_public' volume type parameter
* nimble storage: support for force detach
* nimble storage: retype support
* Use Tempest slow job to run all slow tests
* api-ref: Change extensions updated type to updated\_at
* api-ref: remove encryption from Show-an-encryption-type
* hosts api ref: all fields should be of type string
* Remove systool from rootwrap
* Add tests for multiattach check in cinder.objects
* Clean up the deprecated description in doc
* Fix wrong NotFound in get\_by\_name\_or\_id
* api-ref: add missing response body for groups
* Fix CLI output examples
* Fix multiattach set to false after retype
* Update Dell EMC Driver's multi-attach Support
* Fix backup driver configuration examples in the documetation
* api-ref: add missing fields in volume types
* api-ref: total/free\_capacity should be with postfix \_gb
* api-ref: namespace in extensions is optional
* Fix pylint warning
* Exclude disabled API versions from listing
* Enable split logging for cinder-keystoneclient interaction
* Remove unecessary pass
* VMAX Driver - Fix for manage volume if volume is part of SG
* api-ref: clarify volume\_type param in volume create API
* api-ref: fix req/resp params for v3 os-quota-class-sets
* api-ref: mark name as optional in volume create API
* Fix DRBD volume driver creating a 2-volume resource
* ZFSSA iSCSI implement get\_manageable\_volumes()
* Get rid of keys() usage
* Imported Translations from Zanata
* Fix bug of renaming volume with same name
* Fix some inconsistencies in qos-specs api ref
* Propose example volume protection tests
* services api ref: fix field enum value and add missing field
* ZFSSA iSCSI driver doc fix - allow\_rename auth/o
* ZFSSA handle manage nonexistent volume
* Adding variable for total gigabytes used by snapshot param
* [Optimize] Use OVO when retrieve volume object
* Add microversion history to api-ref
* Dell PS Driver moves to maintenance mode
* Remove udevadm from rootwrap
* VMAX Rocky doc - version information
* Fix some inconsistencies in messages api ref
* Fix typos in volume api ref doc
* Remove aoe-revalidate, aoe-discover, aoe-flush
* VMAX Driver - Rollback for manage existing volume
* ZFSSA volume driver REST client python3 fixes
* Fix image volume cache max size and max count limits
* Move hscli to privsep
* Imported Translations from Zanata
* 3PAR: Update Storage Driver docs
* Imported Translations from Zanata
* EMC ScaleIO driver does not honor create from snapshot volume size
* Link to the in-tree driver support matrix from multiattach docs
* Imported Translations from Zanata
* api-ref: document no\_snapshots default for volume transfer API
* api-ref: add preconditions for volume transfer APIs
* Add comment to online data migration command
* Rename devstack-plugin-ceph jobs
* Fix wrong filter of backups in db api
* Fix indentation in docs
* Remove resolve\_hostname
* Imported Translations from Zanata
* Clean up bare raised pylint warning
* Fix pylint warnings for "unnecessary not"
* Update Zuul configuration
* add python 3.6 unit test job
* switch documentation job to new PTI
* import zuul job settings from project-config
* Ds8k: Mock evenlet.sleep calls
* Fujitsu DX: Add retries for busy error
* Ensure VNX unit tests don't sleep
* Simplify running pylint
* Tintri: Inherit tests from BaseDriverTestCase
* NetApp SolidFire: Fix CG snapshot deletion
* Imported Translations from Zanata
* Modify Pure driver to configure PG/Pod names
* Move check\_encryption\_provider to volume utils
* Imported Translations from Zanata
* Move release note to the releasenotes/notes dir
* NetApp SolidFire: Fix force\_detach
* fix misspelling of 'configuration'
* Remove deprecated HPE Lefthand config opts
* VMware: Fix revert-to-snapshot
* VMware: Remove member initialization in properties
* Move sphinx-feature-classification to docs reqs
* Simplify hostname lookup
* Imported Translations from Zanata
* tintri: Remove \_resolve\_hostname
* trival: Fix some spacing issues
* Fix typo
* Update doc for get-pools API
* Avoid using dict.get() in assertions
* Imported Translations from Zanata
* Remove auth\_uri usage
* 3PAR: Added retries on volume deletion
* VMAX Driver - Initiator retrieval short hostname fix
* SIO: Clean up padded volume comments
* Add test case: create volume from source volume
* Fix IPv6 for Cinder NetApp ONTAP drivers
* Remove cinder-tox-compliance job
* Correct the link of 'OpenStack Documentation Contributor Guide'
* Fixed invalid number of arguments bug in ScaleIO driver
* LVM: Disable multiattach for LIO iSCSI target
* Replace assertRaisesRegexp with assertRaisesRegex
* Fix deprecation warnings
* VMAX doc - important known issue
* Drop legacy backup service support
* Changed default behaviour of nas\_secure\_file\_\* for Quobyte driver
* Imported Translations from Zanata
* api-ref: add docs for os-migrate\_volume API
* Remove deprecated sio\_allow\_non\_padded\_thick\_volumes
* Remove flashsystem\_multipath\_enabled opt
* Dell EMC: Added excluded\_domain\_ips ListOpt to SC driver
* Remove WindowsDriver mapping
* Remove deprecated iSCSI target config opts
* Imported Translations from Zanata
* Remove os-image-create API extension
* Make divisibility py3 compatible in DRBD driver
* Xtremio: Remove unused constant
* Raise HTTPUnsupportedMediaType when content type is unsupported
* Add 'volume\_attachment' to volume expected attributes
* ScaleIO: Deprecate sio\_allow\_non\_padded\_thick\_volumes
* Make solidfire code py3-compatible
* Imported Translations from Zanata
* Add api-ref for mv 3.55 volume transfer
* Fix support indicator for rbd extend attached
* ScaleIO: Disable volume creation without padding
* Add policy granularity to the encryption API
* Fix api-ref title levels and index
* Fix XTREMIO driver name
* Add False check when do \_retype\_error
* Add retry to LVM deactivation
* [Docs] Update some links for Gerrit of Code Reviews
* Optimizing code (wrap\_socket())
* Save the backup.service just before \_run\_backup
* Make code py3-compatible (global callable())
* Update document for metadata show API
* Reserve 3 migrations for DB backports
* Imported Translations from Zanata
* Imported Translations from Zanata
* NetApp SolidFire: Fix NetApp SolidFire SSL option
* Imported Translations from Zanata
* Remove the CoprHD driver
* Update reno for stable/rocky

13.0.0.0rc1
-----------

* Imported Translations from Zanata
* Fix \_attachment\_reserve to not allow attaching an invalid status volume
* Allow extra parameters in volume\_type\_encryption
* Default functional tests to use v3 API
* Add retries to delete a volume in the Nimble Driver
* Add volume create schema enforcement unit tests
* Fix one help description of rbd driver
* Fix typo on Storwize release note
* Note max API version for Rocky
* Add sphinx-feature-classification based support matrix
* VMAX driver - releasenote fix
* Solidfire: Avoid UnboundLocalError
* 3PAR: Update Storage Driver docs for Rocky release
* VMAX Docs - SSL Support Revision
* VMAX docs - Rocky features
* VMAX docs - Restructure of content
* VMAX Driver - Fix for get-pools and returned Service Levels
* VMAX driver - minor metadata additions
* VMAX driver - replace 'data=' with 'message='
* VMAX driver - pagination on get vols from SG list
* Correct volume-transfers API endpoint
* Improve messages api-ref description
* Add ability to specify minimum value when using capacity based QoS
* IBM XIV: fix issues for replication
* Fix none-ascii char in doc

13.0.0.0b3
----------

* solidfire: Enable SSL with requests
* VMAX Driver - Fix for multiple clones failure
* Fix indentation in docs
* VSA: Concurrent request handling in attachment
* NetApp ONTAP: Fix driver force detach operations
* docs: Write high availability devref
* Consume quota when importing backup resource
* Update volume create schema to allow 'null'
* nimble: Fix missing ssl support
* INFINIDAT: add host.created\_by metadata key
* Set bootable when creating volume from snapshot
* Handle multiattach attribute when managing volumes
* Update delete group snapshot API exception handling
* tintri: Enable SSL with requests
* Fix remotefs driver report wrong value
* IBM XIV and DS8K: Update document for Rocky release:
* Revert "Use Tempest scenario job to run all scenario tests"
* Add release note for force delete MV fix
* ActiveCluster support for Pure Storage drivers
* Remove mox3
* XtremIO: support multiattach
* NEC driver: Return non-random iscsi portal in initialize
* Update microversion number with constants
* [Unity] Compressed volume support
* Don't require size when creating volume from snap
* Fix some nits in transfer volume with snapshots
* Add keystoneauth options to list\_opts
* Update microversion for force delete volume parameter
* VMware: set 'shared\_targets' as False
* INFINIDAT: validate\_connector should validate by protocol
* DS8K: correct the behavior for retype method
* Non Windows per service lock for Backup service
* QNAP: Add support for QES 2.1.0
* [doc] Use openstack client commands to replace cinder client
* [doc] Use openstack client commands to replace cinder client
* Use Tempest scenario job to run all scenario tests
* Transfer snapshots with volumes
* Update attachment create API document
* NEC driver: loss of access after live-migration
* Pure Storage FlashArray driver - enable multiattach support
* VMAX driver - Block revert to snapshot for replicated volumes
* VMAX driver - Add VMAX specific volume metadata to logs
* Add ability to specify mode to attachment-create
* use restore\_file instead of open volume when restoring
* Unity: add multiattach support
* Update api-ref and release notes for schema validation
* Prepare Google Backup driver for latest libraries
* Fix Port nvmet driver to use privsep
* NetApp ONTAP iSCSI/FCP: Enable multiattach capability
* Remove note about mox
* Unity: add thick volume support
* LVM: Enhance option descriptions
* api-ref: Update notes on encryption key size
* Ceph backup: set close\_fds on Popen
* Use ensure\_tree instead of mkdir when creating paths
* RemoteFS: Use summarize option for "du"
* Remove hus-cmd from rootwrap volume.filters
* Avoid os.getpgrp, breaking Windows c-backup support
* Enable split logging for cinder-glanceclient interaction
* Remove tee from volume.filters
* Revert "Use os.mkdir instead of mkdir"
* Change blockbox to block-box
* Remove unused commands from volume.filters
* Remove ssc command from volume.filters
* NetApp: Deprecate E-Series drivers
* Use os.mkdir instead of mkdir
* Remove blockdev from volume.filters
* Drop dmsetup from rootwrap
* Remove mkdir from volume.filters
* NetApp ONTAP: Remove NFS driver online volume extending support
* Add policy in code documentation for os-set\_bootable API
* Port nvmet driver to use privsep
* DS8K: correct behavior and return value for terminate\_connection method
* DS8K: correct the behavior for get\_pools method
* Correct Pure Storage configuration documentation
* INFINIDAT: change create\_child to create\_snapshot
* Adds Overlay Volumes Created from Snapshots to Quobyte
* Fix RBD incremental backup
* Add blueprints and releasenotes link to README
* Fix parameter description in volume and snapshot manage extension
* Keep volume's status in 'creating' when creating from backup
* RBD: support to get manageable snapshots
* [NetApp ONTAP] Add filtering to API trace logging
* [Logging] Enable filtering of trace\_api logs
* Fix 'availability\_zones' attribute not recognized when creating volume
* V3 jsonschema validation: Volumes
* Enable running py36 unit tests
* Handling type's multiattach extra specs in API task flow
* NEC driver: Fix iscsi multipath initialize\_connection tests
* NetApp ONTAP: Remove iSCSI/FC driver online volume extend support
* Multipath: Update docs for backend drivers
* Fix time convert error in testcases
* NEC driver: Reuse iSCSI LUNs of detached volumes
* Fix quota error when deleting temporary volume
* Make scheduler check online\_extend\_support capability
* Clean up unnecessary test params in test\_rbd
* NetApp ONTAP NFS: Enable multiattach capability
* Adds more validations in create\_snapshot
* Add policy check for type show and type list
* Fix vmware disk type changed when volume type is eagerZeroedThick
* Remove report of allocated\_capacity\_gb from Inspur driver
* Fix v3 sample files
* Dell EMC: SC FC Driver wwns api response in lower
* Add v3 api-ref for force delete snapshot
* api-ref: Adds os-update\_readonly\_flag API
* Fix prophetstor drivers report value
* Fix invalid escape sequence warnings
* Get rid of conditional rtslib\_fb imports
* DataCore: get rid of pylint errors due to contextlib
* Nimble: Fix tuple being passed for exception init
* Solidfire: Fix pylint errors for class decorators
* Infinidat: Get rid of pylint errors due to private lib
* NetApp: Remove duplicate volume\_type kwarg
* Increase pylint processes
* Add v3 api-ref for updating snapshot status
* Reject any filter whose key contains non ascii character
* HPE3PAR: Fix pointing to backend in group failover
* Remove 'message' from format argument from exception
* Fix the usage of RBDVolumeProxy in getting manageable volumes
* Storwize: get list of all volumes for ensure\_export
* Keep ORM names matching their VO counterparts
* Storwize:clone volume with iogrp value as expected
* [XtremIO] Remove provisioning factor when reporting
* DS8K: Enable multiattach support
* Move blockbox DB volume to home directory
* VMAX Driver - Incorrect SSL cert verification
* VMAX docs - use config-table directive
* VMAX driver - remove deprecated XML option
* VMAX driver - Deleting snapshot that is source of multiple volumes fails
* VMAX driver - Incorrect service level reporting
* VMAX driver and docs - change san\_rest\_port to san\_api\_port
* Imported Translations from Zanata
* api-ref: Rephrase delete volume precondition
* policy docs: Add volume summary under GET\_ALL\_POLICY entry
* Storwize: add data reduction pool support
* Allow running unit tests on macOS
* Update macOS devref info
* Fix tox -e docs failure
* Add ansible helper to Linux dev environment info
* Remove 'message' from format argument from exception
* Remove 'message' from format argument from exception
* Be explicit about tox python version
* DS8K: correct the return value for initialize\_connection method
* Add debug logs for weigher filters
* Add documentation page for basic volume quality of service
* VMAX: Address nits in list manageable code
* Mark Dell EMC CoprHD Drivers unsupported
* Add doc about backend\_default config
* [doc]Modify failed hyperlinks
* [api-ref] Fix the parameter metadata in v3
* Empty option value maybe cause Unity driver failed to initialize
* Support image signature verification
* Imported Translations from Zanata
* trivial: Add min\_version: 3.1 to api\_ref for upload volume
* Fix cinder-volume uses latest req-id for all log calls

13.0.0.0b2
----------

* Mock log output from DataCore drivers
* Add NexentaEdge drivers
* VMware: Add file open mode to support python3
* Tests: Remove some ovo FutureWarnings about UUIDs
* Add check to the flake8 job
* Cloning image fails results duplicate cache entry
* api-ref: Fix some params in volume types
* Switch to oslo\_messaging.ConfFixture.transport\_url
* Run pylint job under py3
* Disable failing backup tests in LIO/Barbican job
* Remove kwargs 'message' when exception is created
* Api-ref: Fix the incorrect parameter description
* Replace os.makedirs to avoid process race
* Implement privsep boilerplate in cinder
* Default tox jobs to python3
* Fix group availability zone-backend host mismatch
* Mark Disco driver unsupported
* Mark the HGST Driver unsupported
* Move driver config opts out of catchall page
* RBD: support to report backend state
* IBM XIV: Report backend state in service list
* IBM DS8K: Report backend state
* Add note about multiattach not supporting encryption to docs
* Fix Dell EMC Xtremeio drivers report wrong value
* Fix documentation error
* Correct S-Series to DS-Series systems
* Remove the deprecated config option
* Fix GCS backup driver docs
* Doc: Fix broken link (Nimble)
* Imported Translations from Zanata
* Add user messages for extend volume operation
* Mark DataCore Drivers unsupported
* V3 jsonschema validation: volume\_type\_encryption
* ZFSSA handle non-existent snapshot
* Update storage backends supported for Lenovo
* Fix handling of 'cinder\_encryption\_key\_id' image metadata
* Remove \_static folder in doc directory
* Update "auth\_url"
* Fix api-ref for backup export and import
* Missing request parameters in update quotas
* Trivial: Update pypi url to new url
* V3 jsonschema validation: admin\_actions
* [Api-ref] fix the type of service\_id in worker cleanup api
* api-ref: Fix v3 API version details error
* [Unity] Return logged-out initiators
* Add cinder v2 experimental job
* Fix cannot add a column with non-constant default
* Update author in latex sphinx doc builds
* Update the volume-encryption doc
* Additional fix for hostname validation regex
* doc: correct indentation from a note block
* V3 jsonschema validation: scheduler\_hints
* INFINIDAT: fixing extend mechanism
* Storwize: update the function is\_volume\_hyperswap
* Fix the argument for cinder-manage command
* NEC driver: Faster clone status check
* Fix cinder-volume setup in block-box
* [Docs] Fixes documentation warning
* Remove duplicate sample files
* Fix option description in DRBD driver
* Remove Ocata config option changes doc
* VMAX driver - VMAX list manageable volumes and snapshots
* VMAX driver - Enable multiattach support
* Fix wrong usage of fields.BackupStatus.AVAILABLE
* ScaleIO: Rebranding of product to VxFlex OS
* Disable test\_volume\_backup\_restore for lio-barbican job
* Support availability-zone type
* Fix rbd driver json loading
* Fix create backup API document
* Add missing volume APIs
* Imported Translations from Zanata
* [Api-ref] fix incorrect host value in worker cleanup api
* Fix NVMET minor log message issues
* Fix google backup driver
* V3 jsonschema validation: os-services
* Update auth\_uri option to www\_authenticate\_uri
* Huawei driver supports create\_group\_from\_src
* Disallow multiattach for encrypted volumes
* NetApp ONTAP iSCSI: Force exception on online extend
* Fix hostname validation regex
* Add snapshots to minimum driver interface
* Add descriptions for auth\_strategy choices
* RBD: remove redundant exception log to reduce noise
* Log backup\_service.restore() exception
* Add support for promoting a failed over backend
* [Unity] Add support of removing empty host
* V3 json schema validation: generic volume groups
* Fix i18n issue in volume\_action and admin\_action
* Support filter backend based on operation type
* Remove stale pip-missing-reqs tox test
* NEC driver: Delete max volumes per pool limit
* [ci][rally] make the job inherit the right parent
* Make config-table display list defaults in list format
* api-ref: modify 'keys' description
* QNAP: driver fails to detach while uploading volume to image
* Remove static config option table for Infinidat
* Remove zonemanager static config option tables
* [VNX] Fix property set in configuration doc
* Fix os-detach attachment\_id schema
* Adding NVMET target for NVMeOF
* DRBD: Remove cast to int in size calculation
* Remove backup driver static config option tables
* Add missing 'transfer' parameter in API document
* Update HPE docs to use config-table directive
* Skip running py36 tests on irrelevant files
* Remove ZFSSA static config option tables
* Remove Zadara static config option table
* Remove Virtuozzo static config option table
* Remove Tintri static config option table
* Remove Synology static config option table
* Remove SolidFire static config option table
* Remove Quobyte static config option table
* Replace Chinese punctuation with English punctuation
* Replace cluster object's host with service\_topic\_queue
* IBM XIV: enable FC zoning to all the ports
* [doc] Add the possible status for attachment
* Remove Nimble static config option table
* Remove NEC static config option table
* Remove static config option table for Lenovo
* Remove Kaminario static config option table
* Remove static config option table for DISCO driver
* Add skip filter to config-table directive
* Imported Translations from Zanata
* Update auth\_url value in install docs
* Fix doc warnings causing local failures
* Updates overprovisioning dev-ref
* Add reno to test-requirements
* api-ref: modify 'has\_dependent\_backups' param's description
* V3 jsonschema validation: Quota classes
* V3 jsonschema validation: Quotas
* Remove Fujitsu static config table
* Update Dell EMC docs to use config-table directive
* Update Datera docs to use config-table directive
* Update Sheepdog docs to use config-table directive
* Remove remaining block device driver config info
* Update CoprHD docs to use config-table directive
* GoodnessWeigher schedules non-type volumes
* Add config table sphinx directive
* Fix doc errors in nimble driver documentation
* api-ref: Correct the cgsnapshot\_id parameter
* Test running jobs under py36/bionic
* Imported Translations from Zanata
* Clean output of driver list generation
* Fix QNap docstring format
* Fix driver docstring RST formatting
* Add VERSION and WIKI\_NAME to NEC driver
* Remove deprecated lvm\_max\_over\_subscription\_ratio
* Add Keystone v3 domain information to context
* RBD: Handle ImageNotFound exception in \_get\_usage\_info correctly
* QNAP: driver fails to create volume and snapshot in some case
* RBD: add support for active/active replication
* Dell EMC SC: Removed space from debug statement
* Collect resource id from RequestSpec parameter
* Add missing VolumeAttachStatus enum field
* Clearup duplicate req\_version variable
* Parent of RBD cloned volume marked as deleted should not be manageable
* Fix backup/restore error for ceph rbd backend
* Trivial: Update pypi url to new url
* WinSMB volume driver doc: Add Volume backup support

13.0.0.0b1
----------

* Dell EMC SC: Enabled multiattach in Storage Center Driver
* Clarify sizing when creating vol from source
* Improve API method logging
* NetApp ONTAP: Set new sub-lun clone limit for ONTAP driver
* Adding abstract class NVMeOF
* V3 jsonschema validation: volume\_transfer
* Imported Translations from Zanata
* FC: refactor fczm utils decorators to functions
* VMAX driver - Attaches/detaches after host assisted retype failing
* V3 json schema validation: volume manage
* V3 json schema validation: workers
* RBD snapshot needs to be protected/unprotected after being managed/unmanaged
* VMware: Extend volume after clone
* Set sample\_default for 'host' option
* Uncap eventlet
* ZFSSA implement "Enhance iSCSI multipath support"
* Rephrase for multiattach support
* NetApp ONTAP: Fix export path used as volume name
* Use InvalidConfigurationValue instead of InvalidInput
* NEC docs: add new features and improve description
* Update the HP MSA and Lenovo driver documentation
* ZFSSA accept pool stats when cluster node stripped
* Refresh volume when checking for conflicting attachments
* nimble: update documentation for supportability
* Doc: Add driver security notes to contributor doc
* Move MV history under API Microversion contrib docs
* V3 jsonschema validation: snapshot\_actions
* Fix mocks for ZFS Storage Appliance unit tests
* Storwize: Report backend state in service list
* Add doc to pep8 check\_exec
* VMAX docs - miscellaneous clarifications
* [Optimise] Use ThreadGroup to manage periodic tasks
* Update auth\_uri option to www\_authenticate\_uri
* add lower-constraints job
* Unignore .stestr.conf
* VNX: fix performance in create/delete\_volume
* Default pep8/fast8 to run under python 3
* Move testing info higher in contrib docs
* Clean up doc configuration
* Use sphinxcontrib.apidoc for module docs
* Remove exec flag from doc files
* V3 jsonschema validation: volume actions
* fixs grammar problems and unify format in api-ref
* Clarify volume migration CLI reference
* Add delete snapshot preconditions
* Handle migrating encryption key IDs in Backup table
* Dell EMC SC: dell-storagecenter-driver docs updated
* Doc: Add inspur driver doc to toctree
* VMware: Adding NFS41 datastore as supported
* Avoid second restart on offline upgrades
* [Optimize] Validate configured scheduler filters when initialize
* Remove extended attribute 'os-volume-replication' in Doc
* Cleanup volume management CLI reference
* Use check\_virtual\_size to do the size check
* Unity: fail to detach lun when auto zone enabled
* Implementation of Cinder driver over FC for Inspur InStorage
* Dell EMC SC: volume model update return missing vol id
* Adding image membership check to \_is\_image\_available
* OVO: support query for disabled services
* Imported Translations from Zanata
* Fix doc format errors in module docstrings
* Remove unused doc extensions
* Allow extension of volumes with snapshots for VZstorage driver
* 3PAR: Report backend state in service list
* Storwize: self assign the SCSI lun id for volume attaching
* ScaleIO: Prevent usage of unsafe volumes
* Skip masking of command output over ssh
* Move openstackdocstheme to extensions in api-ref
* Unity: Enable ssl verification
* Storwize: check flashcopy\_rate before mkfcmap
* Reduce scope of the lock for image volume cache
* Don't use custom password generating code
* api-ref: Fix microversion for volume.backup\_id
* Remove driver-specific notes from extend api-ref
* Document more review processes
* fix a typo: s/clent/client/
* Updated from global requirements
* [sytle] use http code constant instead of int
* V3 jsonschema validation: Clusters
* VNX: fix options incorrect behavior
* Storwize: modify hyperswap host\_site configuration
* Support Qemu >= 2.10.0 in Quobyte driver
* fix a typo in remotefs.py
* Fix get\_max\_over\_subscription\_ratio docstring
* Fix: Incorrect replication status on clusters
* Fix: Including resources in None cluster
* Follow the new PTI for document build [Updated]
* Imported Translations from Zanata
* NEC driver: Disallow access from the source node after live-migration
* Fix parameter error in image\_utils
* Remove inappropriate directory space check
* Add max MV for Queens and fix formatting
* INFINIDAT: set REST API client parameters
* Mock local directory testing for image conversion
* Imported Translations from Zanata
* Fix vhd image conversion regression
* Sync snapshot's encryption\_key\_id with volume's value
* V3 jsonschema validation: types\_extra\_specs
* DS8K: correct in-use replication vol status
* Dell EMC SC: ISCSI initialize\_connection fixes
* nimble: update documentation for supportability
* Fix incorrect usage of assertEqual() method in RBD unit tests
* Add missing 'target\_obj' when perform policy check
* Fix policy in code docs for extended\_snapshot\_attributes
* Updated from global requirements
* Imported Translations from Zanata
* Revert "Stop unnecessarily querying storage for stats"
* Storwize: filter active wwpns for NPIV
* Use soft authorize for 'extended\_snapshot\_attributes' policy
* Add ISCSI driver for Veritas Access
* Adding Glance method for listing image members and unit test
* Updated from global requirements
* QNAP Drivers - Move from httplib to requests
* Support multiple processes on Cinder Backup
* V3 jsonschema validation: volume\_image\_metadata
* Updated from global requirements
* Fix missing print format error
* Fix api-ref response code title levels
* Clean out config deprecation information
* Fix API reference attach\_mode parameter default for attachments API
* VMAX docs - prefix emc-vmax-driver.rst with 'dell-'
* Enable slow tests for lvm-barbican job
* VMAX driver - Replication failover performance improvement
* V3 jsonschema validation: qos-specs
* Updated from global requirements
* fix spelling error with  errormessage
* [sytle] use http code constant instead of int
* Remove ExceptionInParsingArguments
* Avoid build system IP going into sample config
* VMAX driver - Retype replicated volumes
* use defusedxml to avoid XML attack
* [VNX] Restore snapshot to volume
* Update links in README
* Updated from global requirements
* Add documentation for capacity based quality of service
* Make the LVM Barbican job vote
* Fix typo errors
* INFINIDAT: add support for multi-attach
* Update doc name and path for dell emc vnx driver
* Use rest\_status\_code for api-ref response codes
* Add support for unmanaging snapshot of rbd driver
* Stop unnecessarily querying storage for stats
* Allow configuring tpool size
* Add backup restoration cancellation support
* Imported Translations from Zanata
* NetApp: Add use-exact-size parameter when creating a LUN on ONTAP iSCSI
* Storwize: update flashcopy\_rate range and add it to volume type
* Add 'list\_volume' in Group show&list API Doc
* Dell EMC SC: Added timeout options for SC driver
* VMware: Option to specify datastore name regex
* [api-ref] Fix 'volume\_id' for in the v3/volumes-v3-volumes-actions.inc
* Updated from global requirements
* Imported Translations from Zanata
* Dell EMC SC: Error Deleting Consistency Group
* Remove utils.read\_file\_as\_root()
* 3PAR: Add \`force detach\` support
* ScaleIO Driver: Document support for ScaleIO 2.5
* Move release note put in wrong location
* Fix the testcase of test\_cmd
* RBD: Add comment about multiattach support
* Imported Translations from Zanata
* RBD: Improve connection debug statement
* Delete redundant code
* Parse endpoint arguments in SolidFire
* Api-ref:Add target volume preconditions for backup restore
* Add functional-py35 gate job
* Support cross AZ backups
* Reserve 5 migrations for DB backports
* Improve ChunkedBackupDriver hashlib calls
* Fix allocated\_capacity\_gb race on create volume
* Fix reporting old stats
* Change order of installation to match previous
* Log config options with oslo.config
* RBD: Don't query Ceph on stats for exclusive pools
* Imported Translations from Zanata
* Enable hash randomization in unit tests
* Tests: Fix backup validation with hash randomization
* Add multiattach reporting to SolidFire
* Tests: Fix 3par tests with hash randomization
* Tests: Disable 2 netapp unit tests
* Tests: Fix NetApp tests with hash randomization
* Tests: Fix VMAX tests with hash randomization
* Tests: Fix inspur tests with hash randomization
* Fix find -delete race in tox
* Use oslo\_db.sqlalchemy.test\_fixtures
* Adds a Cache for Volumes Created from Snapshots with Quobyte
* Add unit test coverage for backup chunkeddriver class
* Add throughput limits that scale per-GB
* Change 'hpe3par\_snap\_cpg' to 'hpe3par\_cpg\_snap'
* Imported Translations from Zanata
* Updated from global requirements
* Imported Translations from Zanata
* Cinder logs rabbitmq password on connection log
* docs: Fix volume encryption link
* Tests: Fix python version check
* QNAP: Pass unit tests with hash randomization enabled
* Provide a hint when performing a volume action can't find the method
* Expand on mv 3.50 description
* Only enforce multiattach policy for retype target
* 3PAR: Monitor task of promoting a virtual copy
* Correct attachment create success response code
* api-ref: note that force detach is admin-only by default
* Imported Translations from Zanata
* Stop a connections leak when freeing an SSHPool
* Remove deprecated fatal\_exception\_format\_errors option
* VMAX driver - Concurrency issues involving replicated volumes
* Remove legacy driver name mappings
* Modify broken link
* Admin guide documentation for volume multiattach
* Remove deprecated service-to-driver mapping for backups
* ScaleIO: Add documentation for containerized overcloud
* Solving permission errors due to directory ownership on NFS
* Imported Translations from Zanata
* Improve logs on scheduler
* Fix the note of API version in admin doc
* Fix grammar error
* Remove "cinder-manage logs" commands
* Remove some unused parameters in parameters.yaml
* Fix typos
* Fix link error in 'Boot from volume' doc
* Imported Translations from Zanata
* fix misspelling of 'return'
* Fix spelling mistakes
* Fix typos in cinder
* Enable multiattach capability for the zfssa driver
* Update reno for stable/queens
* Fix AZ not matching backend after migration

12.0.0.0rc1
-----------

* Use provider\_id for SolidFire Volume lookups
* Deprecate Cinder Hosts API/Extension
* Add Windows volume backup support
* Fix json data format
* Fix UnicodeDecodeError when decode API input
* Api-ref: add 'all\_tenants' API query option
* Make CinderException format errors fatal for tests
* VMAX doc - Queens feature documentation
* Revert consumed quota when failed to create group from source group
* Imported Translations from Zanata
* Zuul: Remove project name
* Add python 3.5 in classifier
* Correct lvm\_type default value in config doc
* modify the http link to the https link
* Add missing MV history for 3.50
* Move doc of report backend state to cli
* Imported Translations from Zanata
* Fix pylint error in DotHill drivers
* Imported Translations from Zanata
* Storwize: avoid ascii code error for ssh response stderr
* Fix DuplicateOptError in fixed\_key migration code
* Storwize: modify the self.\_helpers to backend\_helper
* Update document for worker cleanup API
* Add backup cancellation admin doc
* 3PAR: fix cloning issue in create group from source
* Fix link in boot from volume docs
* docs: Use the encryption provider format constants
* Remove unused parameters in v2/v3 parameters.yaml
* Fix leftovers after backup abort
* Updated from global requirements
* Add policy check for create volume with multiattach
* Dell EMC SC: Find volume folder API call fails on root folders
* SMBFS: allow snapshot ro attach
* SMBFS: fix creating volume from snapshot
* Fix the typo in api\_conditional\_updates.rst
* Fix wrong grammar
* [VNX] \`initiator\_target\_map\` is None
* Schedule request to scheduler when manage existing snapshot
* Fix how backups handle encryption key IDs
* Rename lio job to lio-barbican
* Update Windows docs
* 3PAR: Fixed sync period updation in rcg
* Add 'metadata' in backup detail&show API document
* Handle TZ change in iso8601 >=0.1.12
* Storwize: correct return value for update\_group
* Fix cinder quota-usage error
* Remove consistencygroups/api.py
* Fix: request-id missing in volume action's response header
* [Trivial] SMBFS: fix provisioning type usage

12.0.0.0b3
----------

* Support fabric specific Cisco FC Zone Name
* DS8K: Correct create volume behavior for CG
* backup: set default swiftclient log level to WARN
* Tests: Fix RBD invalid UUID warnings
* api-ref: add multiattach considerations to retype docs
* api-ref: update migration\_policy retype note about encrypted volumes
* fix misspelling of 'password'
* Netapp Ontap: Adds support for auto-max-over-subscription
* Overprovisioning Improvements
* HPE 3PAR: Update Storage Driver docs for Queens release
* Update the description of quota's project id
* Fix mis-named context object
* Add debug logging around multiattach status changes
* Fix multiattach policy names in release note
* Add back support for the multiattach flag for volume create
* Remove logging on Swift backup obj writer
* Simplify keystone password assertions
* Add policy check for complete attachment API action
* [1/2] Fix mock for sleep mocks in volume drivers tests
* fix wrong url link
* Fix typo in test\_qnap
* Add contributor notes on how to use pdb with tests
* Run doc8 first
* RBD: Support encrypted volumes
* INFINIDAT: support force detach
* Replace Chinese punctuation with English punctuation
* nimble: update config doc to add missing extra-specs support
* Add the nova-multiattach job to the check/gate queues
* Remove extra spaces of the volume creation request body
* V3 jsonschema validation: volume\_type\_access
* Move disk space check to run when needed
* Update Volume Encryption Documentation
* Avoid use of deprecated commands in lenovo driver
* Rename 'WindowsDriver' to 'WindowsISCSIDriver'
* Fix readonly mode for new attachment API calls
* Enable multiattach capability for lvm driver
* 3PAR: fix volume migration for "in-use" volume
* modify volume spelling errors
* modify http to https
* Fix api-ref for v3 volume group types
* Fix combination of parameters for update APIs
* Add enough notification for QoS
* Unity: Add revert\_to\_snapshot support
* Adapt cinder backup swift help test
* Enable multiattach capability
* Add multiattach policy
* Updated from global requirements
* Fix api-ref for v3 volume types
* [VNX]Add \`force detach\` support
* [Unity] Add \`force detach\` support
* Storwize: fix an incorrect temporary parameter name
* Update nfs driver doc for snapshot support
* Storwize: use DLM locks
* Fix BadRequest for 'ref' as string value
* Remove leading and trailing spaces from parameters
* Adds documentation for DataCore volume driver
* Storwize: Use passed volume names in migrate
* Fix glance create client unit tests
* Updated from global requirements
* Run backup-restore operations on native thread
* Fix compression related tests
* INFINIDAT: add missing connection\_info params
* Update volume's 'updated\_at' when accept transfer
* Tests: Fix Storpool tests hash randomization failure
* Fix: Propagate OS global request ID
* Fix Backup uses latest req-id for all log calls
* Fix BadRequest for 'null' metadata and group\_specs
* Fix api-ref for v3 Services
* Delete duplicated save operation when do backup creating
* Fix dictionary mistakes in docstring
* Fix 'volume\_type' for in the api-ref
* Remove the deprecated "giturl" option
* Remove unused lib in test-rquirements.txt
* VMAX driver - retype fix where workload is None
* VMAX driver - QOS settings incorrectly applied on Default storage group
* VMAX doc - Queens feature documentation
* DS8K: block in-use volume to be added to consistency group
* [Doc] Add replication group support in doc for Storwize
* Fix version details API does not return 200 OK
* Dell EMC SC: On None connector terminate\_connection unmaps all
* Deprecate the allow-multiattach option to create
* Improve multiattach error message
* ScaleIO: Enable multiattach for volumes
* Windows: allow multiple c-vol backends per service
* Check create from image policy when image not none
* Validate metadata before reserve quota
* api-ref: fix the response parameter for multiattach
* Docs: ibm\_storage\_driver: Fix volume\_driver path in documentation
* Synology: Rename iSCSI target config option
* Revert volume consumed capacity when rescheduling
* 3PAR: fix create group from source functionality
* Initialize osprofiler in WSGI application
* VMAX driver - Multiple storage group creation attempts
* Fix: validation error if the optional parameter's value is None
* Storwize: correct in-use replication vol status
* Unity: Attach Unity volume via IPv6
* Fix v3 api-ref for showing API details url error
* VMware:Config option to disable lazy volume create
* VMware: Support volume adapter type change
* Tests: Fix XIV test failure with hash randomization
* Block attempts to transfer encrypted volumes
* Mock FixedIntervalLoopingCall for Huawei unit tests
* [api-ref] Add missing fields to the API Reference
* V3 jsonschema validation: Backups
* Storwize: add hyperswap volume support
* Handle InvalidVolume when creating a volume attachment
* RBD: get manageable volumes
* Fix reserve volume enforcing the wrong policy action
* Fix api-ref for v3 volume types
* Add descriptions of base policies
* Do not explicitly list thin provisioning tools for RPM
* Add driver-requirements entry for storpool
* DS8K: correct LSS behavior for CG snapshots
* V2/V3 json schema validation: snapshot manage
* V2/V3 jsonschema validation: snapshots
* VMAX driver - Fix AttributeError of dell emc driver
* VMAX driver - Errors extending replicated volumes
* VMAX driver - Fix error handling and checks for generic volume groups
* VMAX driver - revert a volume to last snapshot
* VMAX driver - Incorrect stats reporting
* VMAX driver - support for manage/unmanage snapshot
* VMAX driver - retypes failing when workload is missing
* VMAX driver - Implement SRDF Metro feature
* VMAX driver - Cannot extend volumes in a replication relationship
* VMAX driver - Enable CHAP authentication for vmax backend
* VMAX driver - Add async replication support
* Validate volume status again when snapshot created
* Use constants for cinder-volume
* Reintroduce the StorPool driver
* Report backend state in service list
* Remove some no-use code about failover
* Add instructions for the Error response codes
* Fix incorrect description in api ref
* V3 jsonschema validation: Volume-types
* Update 'force' parameter for volume delete API
* NEC driver: implement manage/unmanage functions
* Adding all docs into index.rst of administration docs
* Missing generalized\_filters in cinder administration doc
* Updated from global requirements
* Deprecate CG APIs
* Bump up the API microversion in cinder.rc
* Add microversion and volume status limit to revert api ref doc
* HPE 3PAR - Implement Tiramisu feature on 3PAR
* Enable fail back in SolidFire driver
* StorageCenter: Fix volume mapping for API v3.1
* Update tgt iSCSI target on volume extend
* Follow the new PTI for document build
* NEC driver: add automatic configuration of SAN access control
* Remove unused sf\_enable\_volume\_mapping conf option
* Add admin ctxt to request qos\_specs in SolidFire
* Remove In-repo cinder tempest plugin
* V3 jsonschema validation: Group Snapshots
* VNX: Fix cloning failure when system is busy
* InStorage: fix problem when doing instance live migration
* NFS: Fix nas\_secure auto mode permissions failure
* Add online data migration routine for attachment\_specs
* NetApp: Fix to support SVM scoped permissions
* Dell EMC SC: API 4.0 incompatibilities
* Trivialfix -- Fix spacing in docstring
* VMAX doc - Queens feature documentation
* Create group from snapshot-group failure leaves behind the volume
* SMBFS: fix detecting if a volume is in-use
* Raise PolicyNotAuthorized exception on consistency Group snapshot
* Fix some typos in cinder doc
* Updated from global requirements
* Fix volume image metadata endpoints returning None
* NetApp E-Series: Fix broken generic volume groups
* Fix migration Invalid volume message
* [api-ref] Fix http method for updating encryption type
* Fix create encrypted volume from image
* Storwize: disable creating volume with non cg\_snapshot group\_id
* Rename iSCSI target config options to more general
* 3PAR: Update CHAP on host record when volume is migrated to new compute host
* Use method validate\_integer from oslo.utils
* Add 'shared\_targets' only when it doesn't exist
* Use defusedxml for XML parsing
* Remove deprecated 'pybasedir' config option
* Remove deprecated 'netapp\_eseries\_host\_type' config option
* Remove deprecated HP 3PAR config options
* Remove deprecated 'nas\_ip' config option
* Fix indentation in docs
* Fixes creation of mirrored volumes due to wrong type
* Check for migrated UUID in SolidFire delete
* Add thin provisioning package to install guide
* Correct documented service upgrade order
* VMAX doc - Queens feature documentation
* Add service\_token for cinder-glance interaction
* Add service\_token for cinder-nova interaction
* Switch to oslo\_db retry decorator
* Don't call driver.terminate\_connection if there is no connector
* Store host connector in volume\_attachment.connector column
* qemu-img info --force-share for NFS driver
* NetApp ONTAP: Copy offload bugfix
* Cleanup XtremIO IG cleanup note
* SMBFS: remove deprecated config options
* Storwize: fix group creation restrict rules
* Restore\_backup: set error when volume status not matched
* Keep v3 api-ref error response code 404 for reverting
* Speed up DataCore unit tests
* API ref: add host format to description
* Fix discrepancy in api-ref for volume\_types APIs
* Fix json formatting eror
* V3 jsonschema validation: Group type specs
* Don't raise 'NotAuthorized' inside when soft authorization
* Change ssh\_utils parameter to correctly sends keepalive packets
* Modify v3 api-ref error response codes for reverting
* Removed gb quota decrement in grp snapshot delete
* Add output of slowest tests to UT runs
* Fix available space checking for image conversion
* Deprecate cinder-manage logs commands
* QNAP: Add support for QES 2.0.0
* Fix test case in test\_volume\_unicode.py
* VMAX Doc - clarification and typo fixes
* Updates Help Text on Quobyte Volume URL Option
* V3 jsonschema validation: Volume metadata
* Fix create from snapshot and source volume
* VMware: Bump driver version
* Check snapshot flag for test\_snapshot\_create\_volume\_description\_non\_ascii\_code
* Updated from global requirements
* Fix discrepancy in api-ref for create volume manage api

12.0.0.0b2
----------

* Remove skip\_validation\_flag to False by default
* XtremIO: optional clean IG with no mappings
* Fix api-ref for v3 group type specs
* TrivialFix: Delete word ‘I’ in admin/blockstorage-backup-disks.rst
* Fix TypeError for workers cleanup api incase of invalid resource\_type value
* DS8K: don't swap role after failover group
* Updated from global requirements
* DS8K: lss\_range\_for\_cg should take csv as well as range
* Fix for volume from image snapshot free space issue
* NEC driver: delete an unused configuration parameter
* INFINIDAT: change CI\_WIKI\_NAME
* V3 jsonschema validation: Group types
* Add test for volume create with non-ascii characters
* Add cg policies and clean up old policy handling
* Migrate fixed\_key encryption keys to Barbican
* Add shared\_targets and service\_uuid to volumes
* Pass in the parameters multipath when migrating volume
* Discrepancy in api-ref and code for create group type API
* Imported Translations from Zanata
* Remove extra test variable assignment
* Tests: Cleanup utils.create\_volume fields
* Imported Translations from Zanata
* Discrepancy in api-ref and code for create group snapshot API
* Tests: Fix Storwize hash randomization failure
* added clarification in docs for usage of "volume\_clear\*" options
* Disallow unmanaging encrypted volumes
* Disallow managed volume to be managed again
* Fix project\_domain\_name and user\_domain\_name in doc
* Add support for enhanced features to the QNAP Cinder driver
* Mock out CLI execution in NEC driver tests
* handle no default\_cgsnapshot\_type
* Add shared\_targets flag to Volumes
* Allow purging of records less than 1 day old
* Update the documentation links
* Support create volume from backup
* Fix 'KeyError' when 'with\_count' is not specified
* Consolidate code that manages encryption keys
* Use new oslo.db test cases
* Move legacy-cinder-tox-\* jobs in-tree
* Add cleanup to TestCase.flags()
* HPE3PAR: Create FC vlun as host sees
* Support create a volume from image snapshot
* Filter valid FC initiator while FC attaching
* Remove invalid parameters in the file testing.rst
* SMBFS: manageable volumes
* Fix retype migrating volume with rep\_status 'not-capable'
* Adds DataCore Volume Drivers
* Handle quota in 2 phases when managing resource
* RBD: support driver-assisted volume migration
* Update unity tests to use our test base
* Update access control of show under hostAPI
* Modify the wrong link in document
* V3 jsonschema validation: Attachments
* Add fixture to only emit DeprecationWarning once
* Remove DB authorisation checking with quota API operations
* Update oslo.context RequestContext args
* Update bindep.txt for doc builds
* nimble: handle unicode strings in volume create
* Handle deprecation of inspect.getargspec
* Add service\_uuid FK to volumes
* Fix policy documentation for os-show\_image\_metadata endpoint
* Fix group\_type\_id in api-ref
* Imported Translations from Zanata
* VMware: Backend driver for VStorageObject
* NetApp ONTAP: Fix delayed snapshot deletion call
* Suppress UT log messages
* Try Fetching value from 'cluster' when raise exception
* Fix v3 api-ref for restoring backup are wrongly described
* Fix qos-spec-v2-qos-specs error
* Add v3 api-ref for showing encryption specs item
* Explicitly set expected log level for tests
* Update api-ref to include volume\_image\_metadata
* Remove ExceptionTestCase
* V3 jsonschema validation: base schema framework
* Check available capacity before creating resources
* Remove setting of version/release from releasenotes
* Test os-brick master in LIO gate job
* Storwize: revert to snapshot support
* Fix cinder-manage volume delete
* api-ref: fix 203 error response codes to be 403
* Inspur Cinder iSCSI driver
* [Trivial] set min max\_over\_subscription\_ratio to 1
* Add doc/source/\_static/cinder.policy.yaml.sample to .gitignore
* Fix 'D005 No newline at end of file' Error
* Fix controller install document indentation
* Fix earlier backup records can't be restored
* Fix several instances of chap secret being output to logs
* NetApp cDot: Fix manage volumes
* Fix resource count for os-host show
* Correct gb,snapshot quota update in group snapshot
* HPE 3PAR: Handle single path in FC configuration
* Remove v1 API reference
* NetApp ONTAP: Remove orphaned 7mode file
* Prevent leaking encryption key when deleting volume
* Schedule request to scheduler when create group from resource
* Re-add QNAP Cinder volume driver
* Add missing 'obj\_make\_compatible' in RequestSpec object
* Tests: Rework volume deletion w/ invalid status test
* set vg\_thin\_pool\_size to float type
* Added mount fstype based validation of Quobyte mounts
* HPE3PAR: Modify host & clear zone after detach
* Use oslo\_db.sqlalchemy.enginefacade
* Add .zuul.yaml with LIO job
* Updated from global requirements
* Unity: Remove redundant debug logging
* Change default test log level
* Handle assertRaisesRegexp Python 3 deprecation
* Switch kaminario to use standard trace decorator
* NetApp E-series: Fix provisioned\_capacity\_gb
* Fix VolumeAttachment OVO Volume lazy loading
* Use oslo\_log instead of logging
* Remove deprecated keymgr code
* VMAX doc - add manage and unmanage section
* HPE 3PAR: Adding driver capability
* Improve cinder revert-to-snapshot notifications
* create\_volume: cleanup consistencygroup when driver exception
* Improve deleting-missing-backup exception handling
* SMBFS: add fixed image support
* ScaleIO - Cleanup and enhance configuration doc
* Remove unused print\_function imports
* Schedule the request to scheduler when creating from snapshot/volume
* Optimizes volume creation in the Quobyte Driver
* ScaleIO: Update CI Wiki name
* ScaleIO: adapt to moved connector constants
* imageutils: allow passing subformat when converting
* Unity: Fix duplicate hosts created with same name
* Update setup instructions
* Make test logging setup fixture disable future setup
* XtremIO: extending volume in create\_volume\_from\_snapshot
* Use total reserved quota value instead of partial
* Tintri - Updated driver docs with new nfs option
* Fix imageutils tests on windows
* Fix api-ref for group snapshots API
* HPE 3PAR: ISCSI/FC drivers – code refactoring
* Storwize: Fix typo in log message
* SMBFS: Enable reverting snapshots
* DS8K: update replication\_status in generic group APIs
* Disco driver: Fix the location to get the disco connector constant
* Storwize: add backup snapshots support
* Fix migate\_volume API with replication\_status ‘not-capable’
* Make service object UUID not nullable
* Don't fail when deleting missing backup
* ibm-storage: Fix create\_volume\_from\_snapshot
* Fix incorrect use of assertFalse causing CI failed
* [TrivialFix] Remove errant comma in capabilities policies
* Tests: Fix coverage unit test failure
* Dell EMC: Update PS and SC CI wiki names
* Dell EMC PS: Fix Duplicate ACL records Issue
* Completely remove mox from Cinder unittest
* Support count info in List&Detail APIs
* Remove doc/build before running docs job
* VMware: Add profile ID to connection info
* VMware: Revert to snapshot
* VMware: Improve scalability of querying volumes
* Fix manage\_existing API behaving wrongly with storage pools
* NetApp ONTAP: Remove support for 7mode systems
* Fix key\_manager API call
* Revert "Tests: Fail if oslo.versionedobjects issues Invalid UUID warnings"
* Imported Translations from Zanata
* INFINIDAT: add support for overprovisioning
* Clean up driver configuration reference
* Fix migration 112 to use live\_data\_migration API
* Enable using extra-specs for SF attributes
* Add policy documentation and sample file
* ScaleIO Driver - include snap usage in provisioned capacity
* VMAX driver - Deprecate backend xml configuration
* VMAX driver - Remove workload for next gen arrays
* VMAX driver - Implement Tiramisu feature on VMAX

12.0.0.0b1
----------

* Revert "Move vol\_db\_empty to NFS driver"
* Change Install 'Tutorials' to 'Guides'
* Add index for reservations on (deleted, uuid)
* Redundant alias in import statement
* RemoteFS: revert snapshot support
* DS8K: support clone volume asynchronously
* Move 'zoning\_mode' back to DEFAULT section
* Add display\_name to solidfire volume attributes
* FlashSystem: Add CMMVC6045E CLI error for multi-host mapping
* Add v3 api-ref for updating specific extra specs for a volume type
* Fix "import xx as xx" grammer
* NEC driver: Never use target info in migration\_status
* VMAX driver - detach volume shouldn't remove from volume groups
* VMAX driver - Volume identifier issues
* VMAX driver - concurrently deleting volumes can fail
* Replace http with https for doc links in cinder
* [policy in code] Add support for volume, volume type resources
* DS8000 ConsistencyGroup failed to update group with volumes
* ScaleIO Driver: Backup volume via snapshot
* Run backup compression on native thread
* Fix backup compression unit tests
* Make stringify header work under python2
* Api-ref: Add missing api response for volume transfer
* Switch from ostestr to stestr
* Add v3 api-ref for showing all/specific extra specs for a volume type
* Remove deprecated nova config options
* Switch Rally Task To format V2
* Update configuration names in ITRI DISCO volume driver
* Kaminario K2: Add non discovery iSCSI multipath
* Fix backup-import error when the deleted record in the same db
* Updated from global requirements
* FlashSystems: permit snapshot/clone volumes larger than source
* Deprecate SolidFire Image Caching feature
* [policy in code] Add support for service, limits
* [policy in code] Add support for qos and quota resources
* Vzstorage: improvement of create\_cloned\_volume
* [policy in code] Add support for group, g-snapshot resources
* Add ability to specify backup driver via class name
* Add documentation for API 'validate\_setup\_for\_nested\_quota\_use'
* [policy in code] Add support for backup resource
* VMAX driver - documentation updates around versions
* Add Storwize replication group support
* VNX: Fix issue when creating without type
* Remove deprecated VD base classes which are not used now
* Kaminario K2: Support duplicated FQDN in network
* NEC driver: Fix exception in terminate\_connection with no connector
* [policy in code] Add support for snapshot resource
* Add v3 api-ref for deleting extra spec for a volume type
* Switch base to the latest in doc link address
* Replace the usage of some aliases in tempest
* Update tenant to project in cli quota doc
* ScaleIO Driver - adding cache and refactoring tests
* Remove API check is\_valid\_body
* Add .stestr.conf configuration
* Do not load extendable routes for the Versions router
* Remove newton-compat upgrade code on service startup
* Remove Hitachi volume drivers
* Remove Tegile volume driver
* Remove ZTE volume driver
* Remove X-IO volume driver
* Remove Violin volume drivers
* Add retries to LVM logical volume activation
* Remove Reduxio volume driver
* Remove QNAP volume driver
* Cleanup some todo's for refresh()
* Update BlockBox
* Brocade: Add HTTP connection cleanup
* Remove Infortrend drivers
* VMAX driver - remove WLP stats
* Remove deprecated heartbeat options
* Dell EMC PS: Fix extend volume creating unmanaged snapsots
* Remove deprecated osapi\_volume\_base\_URL
* Clean up docs landing page
* Dell EMC PS: Optimize parsing of capacity info from backend
* Dell EMC PS: Fix over-subscription ratio stats
* Doc: Move generalized\_filters to admin
* Doc: Configuration: Remove some outdated Ceph info
* Add ploop to parallels naming conversion
* Generate create\_at date in usage in isoformat for backups/snapshots
* Add uuid to services entries
* Fix tempest test revet\_client typo
* Fix Tempest Volume Revert test
* Fix Reset a snapshot's status API Request Example
* Replace DbMigrationError with DBMigrationError
* Fix description for volume\_type object in API Ref
* Mark Cisco FC ZM driver as unsupported
* Fix v3 api-ref for updating extra specs of volume type
* Add backups v3 views
* Storwize: add NPIV support
* Address importing directory issue
* Stop overriding LVM overprovisioning ratio and deprecate
* Clean up api-ref index page
* Update provider parameter in sample json files
* NetApp ONTAP: Fix reporting of provisioned\_capacity\_gb
* Fix api-ref for reset group snapshot
* Remove legacy driver name mappings
* Api-ref: change 'tenant' to 'project' in v2 doc
* [policy in code] Add support for message, worker, cluster resources
* 3PAR: Cinder volume revert to snapshot support
* Compact Newton database migrations
* Add indexes to SQLAlchemy models
* Updated from global requirements
* [policy in code] Add support for attachment resource
* Api-ref: fix v2/v3 hosts extension api doc
* nimble: fix for parent volume delete
* Check for outstanding attachments during reserve
* Remove SCREEN\_LOGDIR from devstack install setting
* nimble: update config doc for unicode unsupported
* Use constants for microversion values
* Add default configuration files to data\_files
* HPE 3PAR: fix delete operation of replicated volume
* Revert status to previous state on extend failure
* Clear cached autogenerated docs before docs build
* Switch to use key\_manager.backend
* LVM: Activate thin snapshot before clone activation
* [DOC] Update index page for Install tutorial
* docs: Fix typo error in blockstorage-driver-filter-weighing.rst
* Remove leftover API v1 cruft
* Fix a migration issue of Huawei driver
* DRBD: Remove unneeded list length checks
* Add another hack from NOVA\_GROUP to generate\_cinder\_opts.py
* Remove FalconStor volume drivers
* RBD: get provisioned capacity using same connection
* Add missing snapshot action in index.rst
* [DOC] Remove duplicate build of module index
* docs: link to the api-ref for 3.27/3.44 for the version history
* api-ref: document microversions for the attachments API
* Updated from global requirements
* Update generate\_cinder\_opts path
* Link to API version history from main index
* Create custom assertTrue and assertFalse
* Signal the max v3 microversion for mitaka
* Adding project id check
* Remove Glance v1 API support
* Add tempest configuration for the LIO CI job
* IBM XIV: Fix ordered use of a dict
* Use newer location for iso8601 UTC
* Remove Blockbridge volume driver
* Remove Coho volume driver
* Use conditional update for group update and delete
* Implement keymgr list() method
* Synology: Driver unable to be initialized
* ibm\_storage - fix enable replication after disable
* Fix wrong links in Cinder
* Support az filter for snapshot
* NetApp: Remove redundant QoS cleanup task
* Fix test\_rpc\_consumer\_isolation for oslo.messaging 5.31.0
* Tests: Don't write files to /tmp/nec/
* vzstorage: return from \_create\_cloned\_volume
* NetApp: Adds logging of ONTAP API version
* Fix attachments on volume show when volume is attaching
* Remove API v1
* Deprecate service-to-driver mapping for backups
* VMware: Use vSphere template as snapshot format
* Fix an compatibility issue after Huawei driver upgrade
* VMware: Add 'managedBy' info
* VMware: Remove unused variables
* Remove glusterfs documentation
* Fix use of outdated ternary operator
* Remove unsupported BlockDeviceDriver
* [Api-ref]: Add missing key/values in the json files
* Update HPE 3PAR Storage Driver docs for Pike release
* api-ref: Normalize response codes
* api-ref: Remove unused parameter defs
* Fix 'fix\_allocated\_quotas' doesn't work when validate setup
* Updated from global requirements
* Remove vestigate HUDSON\_PUBLISH\_DOCS reference
* Dell EMC PS: Report total volumes on the backend
* api-ref: Make v3 enclosing objects consistent
* HPE Lefthand: fix volume manage operation
* api-ref: Clarify os-host GET behavior
* Fix python 3.6 escape char warnings in strings
* Fix InvalidUUID warnings in unit tests
* Fix installation instructions format
* cleanup cg field when create image cache volume
* Don't collect snapshots again when sync provider info
* Fix python 3.6 escape char warnings in strings
* Add contributor doc on assertEqual vs assertFalse
* [Api-ref] Add api doc for attachment complete
* Unhide errors from check\_uptodate.sh
* Make sure that versions are applied as relative URLs
* Don't lock whole project's resource when reserve/commit
* VMAX driver - Pike documentation amendments
* Correct contributor doc information
* [Doc] Handle Sphinx warnings as errors
* Making reservations before group creation
* [DOC BLD FIX] Fix remote-code-block warnings
* [DOC BLD FIX] Make opts sections lowercase
* Reserve 5 migrations for DB backports
* Hpe: reduce duplicate validation
* Storwize: reduce duplicate validation
* Use backup\_use\_temp\_snapshot setting for default
* api-ref: Add group replication APIs
* Update the documentation link
* Fix allocated capacity report on non pool drivers
* Modify some spelling mistakes in cinder
* Correct module path in doc
* TrivialFix for the docstring and json format
* Remove duplicate variables in v3
* api-ref: Add backup import and export
* Stop using internal \`oslo\_log.log.\_loggers\` dict
* Removed unnecessary tearDown() methods
* Updated from global requirements
* HPE Lefthand: fix volume retype operation
* Update HPE Lefthand/StoreVirtual Storage Driver doc for Pike release
* Add missing PrettyTable requirement
* Make cinder-manage service list to print full host
* [DOC BLD FIX] Fix duplicate content warnings
* Fix IntOpt type of VMAX config options
* RBD: Fix stats reporting
* NEC driver reads default\_backends
* Cisco zonemanager: fix create multi-fabric zones
* Update the documentation link
* Api-ref: add 'os-services' v3 api doc
* VStorage: make logging path configurable
* Allow v3.0 volume metadata API calls
* [Doc Bld Fix] Add links to man page contents
* Ibm\_storage - fix create volume into group
* Revert "Mark Virtuozzo driver as unsupported"
* Updated from global requirements
* Add input format check for qos\_spec update
* IBM Storage: add QoS documentation
* 3PAR driver-requirements name
* Move config-generator to tools
* Add releasenotes to check\_exec list
* Ibm\_storage - fix delete group with replication
* Ibm\_storage - fix failover\_replication
* IBM storage: check pyxcli version on initialize
* [Docs] Storwize:Update document for Pike release
* [Api-ref] Add worker cleanup for service docs api
* VMware: Add support for cloning attached volumes
* Write maximum version of Pike
* Do not fail if RBD image is broken
* Save object after updating for attachment\_complete
* RBD - volume create failed when volume need flatten
* Change pure drivers default replication interval
* ibm-storage: enable FC zonning to all ports
* Make attachment\_update set status to attaching
* 3PAR: Fixed image cache enabled capability
* Get correct hypermetro remote lun ID while mapping
* cinder incremental backup with ceph fails if last one deleted
* SMBFS: enable thin provisioning support flag
* Fix wrong links
* Update reno for stable/pike

11.0.0.0rc1
-----------

* [Docs] Pull over Cinder service overview for install
* [Docs] Add documentation contribution docs
* [DOC FIX] Create missing index pages
* Revert "Mark ETERNUS drivers as unsupported"
* Fix bug of detaching failed while concurrently attach/detach
* NetApp: block drivers fail when volume missing
* Eliminate randomness in encode\_name&encode\_host\_name methods
* Fix missing print format error
* NetApp: Fix override of scheduler decision
* INFINIDAT: add documentation for volume compression
* INFINIDAT: add driver changelog
* [api-ref] Add api-ref for os-quota-class-sets APIs
* Pike release note cleanup
* Replace dict.iteritems/iterkeys with dict.items/keys
* [Api-ref] Add metatdata parameters to backup create/update
* Load resource filter config file in testcase
* Fix wrong param transfer in scheduler flows
* [DOC BLD FIX] Fix user messages documentation
* [DOC BLD FIX] Fix missing references in documentation
* Make Cinder's Landing Page look like Keystone's
* Fix message format for VolumeAttachmentNotFound exception
* Clean up repl v1 volume creation from replication
* Modify a little desc to satisfy the code
* [Api-ref] Add force parameter to volume delete
* Updated from global requirements
* [DOC BLD FIX] Name files for inclusion properly
* Revert "NetApp: Deprecate E-Series drivers"
* VMAX driver - Error attaching failed over volumes
* VMAX driver - None connector object in a terminate\_connection in Pike
* VMAX driver - performance improvements in retype
* VMAX driver - volume delete can fail
* Remove duplicate variables
* Fujitsu Driver: Fix exception in terminate\_connection with no connector
* Infortrend mask password logging
* VMAX driver - seamless upgrade from SMI-S to REST
* VMAX driver - performance improvements
* Fix host and cluster\_name filter for snapshot list
* Refresh az cache if target az is not found in cache
* Remove redundant mock rpc statement
* Fix grammatical mistake, Changed character from "a" to "an"
* VMware: Bump driver version
* Make VolumeTypeExtraSpecsController policy more granular
* Updated from global requirements
* [DOC] VMware: Add doc for vmware:adapter\_type
* [DOC] VMware: Update config table
* Update resource\_filter to keep backward compatibility
* Switch to using bool for filtering non-deleted volume attributes
* Correct 'os-show\_image\_metadata' API document
* Sort cinder-manage commands
* VMAX driver - Pike documentation
* Catch Castellan errors in create volume
* Removed unnecessary setUp() call in unit test
* Add API document for quota usage
* Cloning a volume from a snapshot in thin lv
* [DOC BLD FIX] Fix the numerous docstring probs in coprhd
* NetApp: Fix SVM scoped user startup exception
* Missing snapshot statuses
* [DOC BLD FIX] Correct docstring errors in dell\_emc VMAX
* Fix image download to volume for iso images
* [DOC BLD FIX] Add missing files under configuration
* VMAX driver - align VMAX QOS settings with front end
* Fix layout of api-ref for group type specs
* Fix failure for failing back the primary
* Updated from global requirements
* Revert "Handle concurrent volume creation request"
* NetApp cDOT: Support generic groups for block

11.0.0.0b3
----------

* Fix typo in message for volume creation failure
* Update and replace http with https for doc links in Cinder
* Add the backup metadata support releasenote
* Update backend state when extending volume
* Handle concurrent volume creation request
* [DOC BLD FIX] Correct json code block in attachments
* [DOC BLD FIX] Fix docstring error in fakes.rst
* cinder backup sets incorrect parent\_id
* Update URL home-page in documents according to document migration
* Mock execute in unit test
* Revert MySQL Cluster Support until an approach is worked out
* [DOC BLD FIX] Add code:: blocks to manager.py
* [DOC BLD FIX] Fix docstring problems in vzstorage driver
* [DOC BLD FIX] Fix dosctring errors in veritas driver
* [DOC BLD FIX] Correct docstring issues in Soldfire driver
* Fix no feature to enable 'exclusive-lock' of image in ceph
* [DOC BLD FIX] Fix docstring issues in hpmsa driver
* Mark Tegile driver as unsupported
* [DOC BLD FIX] Fix docstring errors in reduxio
* Updated from global requirements
* Add choices to backup\_swift\_auth
* Support metadata for backup resource
* VMware: Cache storage profile ID
* Use OVO for test\_backup
* Fix release notes link
* VMware: Add volume adapter type extra-spec option
* [DOC BLD FIX] Fix docstring errors in nexenta driver
* Remove references to dothill driver options
* [DOC BLD FIX] Fix netapp docstring issues
* [DOC BLD FIX] Fix docstring issues in Lenovo driver
* [DOC BLD FIX] Fix docstring errors in VNX driver
* Add cinder backup service initialize check
* Volume type with encryption comparison
* [DOC BLD FIX] Fix docstring issues in ibm\_storage
* NetApp cDOT: Support generic groups for file
* [DOC BLD FIX] Fix docstring issues for Hitachi HNAS driver
* Updated from global requirements
* [DOC BLD FIX] Correct docstring errors in falconstor driver
* [DOC BLD FIX] Fix docstring issues in dothill driver
* [DOC BLD FIX] Correct dosctring errors in disco driver
* Fix test\_scheduler\_stats error module calls
* Add a check warning for quota update
* Add VNX replication group support
* [DOC BLD FIX] Fix docstring errors for VMAX driver
* ibm\_storage - fix disable/delete replication
* Updated from global requirements
* Update group status
* VMware: Optimize volume creation from image
* [DOC BLD FIX] Fix formatting error in driver.py
* LVM: Activate LV before creating exports
* Disable merge snapshot to volume for thin LVM
* Replace six.itervalues with dict.values() in cinder
* Convert lenovo driver to use distributed lock manager
* Do not delete group if group snapshot exists
* ProphetStor: Support generic group
* Updated from global requirements
* VMAX driver - bootable volume errors
* [DOC BLD FIX] Fix formatting errors in Dell/EMC PS
* VMAX driver - Implement Generic Volume Group feature
* [DOC BLD FIX] Fix docstring errors in Dell/EMC Unity
* [DOC BLD FIX] correct formatting errors in datera driver
* 3PAR: Get host from os-brick
* Change Huawei driver's private data storing place
* 3PAR: Modify update\_migrated\_volume code to driver
* ZFSSA iSCSI delete volume with non-existent LUN
* Make doc/source directory compliant with design in spec
* Remove key\_manager.api\_class hack
* Don't verify format with autodetect after image conversion
* Add support for OS-Brick force disconnect
* [api-ref] Update volume metadata for a specific key (v2)
* [api-ref] Backups: change parameter 'backup\_id' to be mandatory
* Fix 'connector' parameter in update attachments API
* Enables MySQL Cluster Support for Cinder
* Added CG capability to volume group in CoprHD
* coordination: use tooz builtin heartbeat feature
* HPE Lefthand: Fixed cloning operation
* [DOC BLD FIX] Add missing glossaries
* Updated from global requirements
* VMware: Use temporary image
* ScaleIO Driver: Updating config reference
* Mark Falconstor drivers as unsupported
* Mark Coho driver as unsupported
* ZFSSA iSCSI volume driver multi-connect
* Move config-reference to configuration
* XIV\A9000: Added replication group support
* [DOC BLD FIX] Fix code block issues
* Kamiario: Fix over subscription reporting
* VNX: ignore cg creation if group is not cg enabled
* Updated from global requirements
* Add missing api-ref documents for group type specs
* [DOC BLD FIX] Remove todo:: directive from volume\_driver
* [DOC BLD FIX] Fix docstring formatting in message\_field
* ZFSSA: apply LUN specs when cloning snapshots
* [DOC BLD FIX] Fix formatting in cinder.compute.nova
* Migrate configuration-reference to Cinder repo
* enabling nimble driver again
* coordination: remove custom Lock object
* SMBFS: deprecate provisioning ratio config options
* [api-ref]Fix API Doc error in creating backup
* ScaleIO Driver: Fix transposing of PD and SP in list of pools
* Updated from global requirements
* [DOC BLD FIX] Fix indentation in attachments.py
* [DOC BLD FIX] Correct :returns: in db/api.py
* Pop "consistencygroup" from volume object
* Fix typo
* NEC driver: Optimal path for non-disruptive backup
* Ignore all .egg-info directories in doc8 check
* INFINIDAT: support for volume compression
* Update Documentation link
* 3PAR: Add volume to consistency/generic group
* DS8K: add replication consistency group support
* DS8K driver: specify pool and lss in extra-specs
* Update contents of attach\_detach\_conventions\_v2.rst
* VMAX - Live Migration, replacing SMI-S with REST
* VMAX driver - Replication, replacing SMI-S with REST
* Dell EMC SC: Terminate\_connection chokes on None
* Revert "Correct RBD Provision stats&fix a perf problem"
* zfssaiscsi driver initiator group option processing
* Make VolumeTypeExtraSpecsController policy more granular
* Add ability to extend 'in-use' volume
* ScaleIo Driver: refactor config options
* Remove dothill driver options
* Add insufficient space async error in create vol
* Globalize regex objects
* Add group to cluster when init host
* Dell SC: Fix python 3.6 'async' keyword warning
* Fix python 3.6 escape char warnings in strings
* Add support for shared "backend\_defaults" config
* Tintri: Fix config option access
* INFINIDAT: Add QoS support
* Fix SSHPool current\_size not work correctly
* Tiramisu: Add groups param to failover\_host
* Api-ref: Reorganize volumes versions
* Keep consistent of naming convention
* Migrate Cinder Scheduling CLI documentation
* Migrate Cinder CLI Quota docs
* Migrate volume management CLI documentation
* Migrate the blockstorage admin-guide to Cinder
* Restore ability to disable API versions
* Fix errors preventing doc builds
* VMAX driver - Compression, replacing SMI-S with REST
* VMAX driver - QoS, replacing SMI-S with REST
* Remove the unnecessary pv\_list assign during LVM object init
* Fix some reST field lists in docstrings
* VNX: wrong size of volume from image cache
* Update attachment\_delete for multiple attachments
* Fix v1 API api-ref link
* Fix Log parameter
* Add snapshot clean worker decorator
* Remove periodic\_tasks method from base manager
* Add params for API v3 snapshot-create
* Modify the length of project\_id for Messages
* Fix volume migration error with NEC driver
* Fix the inappropriate parameter name
* Switch to openstackdocstheme
* VMware: Config option for default adapter type
* Enable H904 check
* LVM: Don't initialize VG with lvm\_type='auto'
* Fix attachment\_delete for reserved case
* Fix wrong usage of rbd.list\_snaps return value
* XtremIO: fix fetching FC targets from X2 array
* Revert "Don't use ignoreskipactivation for thin LVM"
* Api-ref: Update doc for show backups
* api-ref: Add parameter "offset" to list apis
* Use GroupSnapshotStatus enum field
* Add 'reserved' status to api-ref
* Rename method 'delete' to 'delete\_backup' in backup drivers
* Optimize: Replace 'fields.Enum' with 'object'
* Unify host naming in readme file
* Move driver options to "backend\_defaults" section
* Use SnapshotStatus enum field
* Fix scheduler\_host\_manager limitation
* Improve Capacity filter logging
* IBM Storage: fix create volume with --group-id
* Add 'LUNType' configuration verification for Dorado array
* Unity: temp snapshot for backup deleted twice
* Use GroupStatus enum field
* XtremIO: Detach all IGs for null connector
* Remove dothill driver
* Datera 2.4.0 driver update
* Fix image cache db query when limits are enabled
* Don't use ignoreskipactivation for thin LVM
* Fix exception in dothill iSCSI driver's terminate\_connection
* Updated from global requirements
* Allow extension of volumes with snapshots for SMBfs driver
* Windows iSCSI: use configured iSCSI portals
* Add gmcv support in SVC driver
* VMware: Fix volume cascade delete
* Fix wording in warning message
* Remove extra space in release note
* Fix rally "volume\_type" parameter
* Add custom keyring when initializing RBD connection
* Avoid register extensions on the versions router
* Use 'min\_version' to mark newly added parameters in DOC
* Update log translation hacking rule
* VNX: Add QoS support
* remove extra characters "/"
* Fix some doc issue
* Add driver interface documentation for list manageable
* [Api-ref] Update quota-set APIs ref
* Api-ref: Add upload-to-image api-ref
* Fix driver exception when cascade deleting volume after transferring
* Rename DB Driver param for backup drivers to 'db'
* IBM Storage: Fix for misidentification of QoS type
* Unity: Use thin clone when cloning volume
* Show user\_id when cinder snapshot-show
* Tempest for revert-to-snapshot
* Fix the default port value
* SMBFS: enhance volume cloning
* import installation guide pages from openstack-manuals
* ScaleIO Driver: Fix for using scheduler specified pool
* IBM Storage - Fix vol create from snapshot in CG
* Replace OS\_AUTH\_TYPE with OS\_AUTH\_SYSTEM in rc
* Windows: case insensitive path comparisons
* Api-ref: add documentation for v2/v3 backup 'os-reset\_status' action
* Add note about stop supporting of log translation
* VNX: failed to create from image cache
* Add policy granularity to the qos-specs API
* Fix i18n issues
* Allow extension of volumes with snapshots for Quobyte driver
* Add params for v3 API volume-type-create
* Use exception.CinderException instead of Exception
* Performance: Remove useless snapshot object get
* Remove redundant notification
* Provide user friendly messages for db sync
* [XIV] Fix exception message format issue
* Enable some off-by-default checks
* ScaleIO: Logging cleanup
* Fix assertTrue in functional tests
* Cinder volume revert to snapshot
* Fix connection\_info field in VolumeAttachment object
* Add v2 v3 response example in API doc
* Fix bugs while integrated with Huawei Dorado array
* Remove the redundant volume/snapshot check
* Updated from global requirements
* VNX: cg and generic group cleanup
* Add IBM-Storage replication group support
* VMAX driver - Retype, replacing SMI-S with REST
* Storwize Support iSCSI host when FC volume is there
* Add enable\_lazy in api/openstack/wsgi.py
* [api-ref] Add snapshot metadata key api
* [api-ref] Update volume metadata key api
* Move vol\_db\_empty to NFS driver
* Add project\_id admin filter to limits API
* Add thin-provisioning-tools to bindep
* Set default lvm\_type to auto
* Fix migration completion for New Attach API's
* Explicit user messages
* api-ref: clarify retype docs around default policy permissions
* Updated from global requirements
* Tests: Disallow use of assertTrue(str)
* [api-ref]Fix the incorrect description in volume API
* Add the missing brace in api/v3/attachment
* Remove duplicated line from \_do\_attachment\_delete
* [api-ref]Fix the wrong description in volume API
* ScaleIO - Make compatible with next SIO version
* Add backup to cinder architecture page
* Fix response code for update and delete API in volume attachments
* IBM-Storage: group-create-from-src fail with error
* Add rel note for create volume from enc. image
* ignore error when remove non-exist vol from cg
* Mock time.sleep for VMAXRestTest.test\_remove\_vol\_from\_sg\_failed
* Remove deprecated oslo\_messaging.get\_transport
* ScaleIO Driver: get manageable volumes
* Mark ZTE driver as unsupported
* Add CG capability to generic groups in GPFS driver
* FusionStorage: use versioned objects
* Clarify some details related blockbox deployment
* IBM Storage- revert vol size capacity optimization
* Send global\_request\_id to nova/glance when calls are made
* Remove usage of CONF from DISCO driver
* Add Metadata format check
* Fix boolean opts defined as strings

11.0.0.0b2
----------

* Allow Pure drivers to handle detach with no host
* RemoteFS: enable image volume cache
* Ibm storage: added new option for qos type
* Fix api-ref for v3 volume and snapshot manage
* Fix NoneType has no attribute get error
* Api-ref: fix parameter 'volume\_id' info
* Refactor update attachment's testcases
* Api-ref: Add doc for update backup
* Replace deprecated BaseException.message with six.text\_type
* Use requests lib for Huawei array connection
* Add libssl to bindep
* Revert "Using assertFalse(A) instead of assertEqual(False, A)"
* VMAX driver - Base functionality, replacing SMI-S with REST
* Clarify create\_volume size debug message
* INFINIDAT: add metadata to InfiniBox objects
* Using assertFalse(A) instead of assertEqual(False, A)
* Correct cinder dev doc typo
* Mark Virtuozzo driver as unsupported
* Dell EMC SC: Updated Created by Message
* Add warning header to opts.py file
* API/DB: Fix hash randomization test issues
* cleanup: remove DEVSTACK\_CINDER\_SECURE\_DELETE
* Mapping parallel and ploop
* Replace assertTrue(isinstance()) with assertIsInstance()
* Using wrong connector parameter in V3 attach
* Support sort backup with name
* [api-ref]Adds API documentation for 'os-set\_bootable' action
* Updated from global requirements
* Updated from global requirements
* Fix support for AMI image conversion
* Remove service filter for service list
* Remove some unnecessary spaces
* Minor fixes to microversion devref
* VNX: fix issue when backing-up in-use volume
* Introduce managing existing snapshot to rbd driver
* Fix example code about api\_version in api\_m\_dev.rst
* Add description about tox in dev\_env.rst
* Return metadata in volume summary
* Ceph: Fix delete backup with non-existent pool
* Allow logging in tempest tests
* Storwize:  add mirrored volume support
* Trivial fix typos
* Refactor NEC volume driver
* Remove unused \_detach\_snapshot method
* Do proper cleanup if connect volume fails
* Add an instance-uuid check on attachment\_reserve
* GPFS: Fix forceful delete for consistency group
* Periodic task to clean expired reservation
* Update OVO devref
* Add is\_replicated() to Volume and VolumeType OVOs
* Make failover DB changes consistent
* Revert "Use HostAddressOpt for opts that accept IP and hostnames"
* Fix api-ref for POST backup for optional name
* Fix typos in README.md
* change consistencygroup\_id to group\_id
* Fix typo
* Add the missing "vol\_type\_id" param for qos association api-ref
* Fix like filter related issues
* Updated from global requirements
* Extracted HTTP response codes to constants
* Make "connector" param to be optional in force-detach api
* LVM: update max\_over\_subscription\_ratio help message
* Add Generic Volume Group Into Quota Management
* Update SolidFire CI Wiki
* Add a local bindep.txt override
* NetApp DOT: Fix hash randomization test failures
* Updated from global requirements
* Update replication v2.1 devref
* INFINIDAT: add support for generic volume groups
* INFINIDAT: add support for iSCSI
* Rolling Upgrades: Fix Volume OVO
* Rolling Upgrades: Fix Group OVO
* OVO: Remove child\_versions from list classes
* SMBFS: remove redundant check
* SMBFS: switch to distributed locks
* SMBFS: drop JSON file storing allocation data
* SMBFS: report each share as a pool
* Add RemoteFSPoolMixin
* RemoteFS: pass volume object to '\_find\_share'
* Add volume type filter to API Get-Pools
* Updated from global requirements
* SolidFire Generic Groups Support
* OVO: Fix VolumeType create not bound to a Session
* VMAX driver - Detaching volumes if part of two or more MVs
* XtremIO: reduce number of backend calls
* Extend Falconstor driver to utilize multiple FSS storage pools
* Remove empty line in api\_version\_request
* Updated from global requirements
* Use the deprecated os\_privileged\_xxx settings
* Add blockbox to Cinder project
* Create volume from VHD format image always failed
* api-ref cleanup: required flag for tenants
* Updated from global requirements
* Python3: Don't use Exception.message
* GPFS: Handle unsupported operations with an exception
* api-ref: add list manageable resource API
* Check the volume metadata value is a string or not
* Mark X-IO driver as unsupported
* Mark Synology driver as unsupported
* Mark Reduxio driver as unsupported
* Mark Nimble driver as unsupported
* Mark Infortrend drivers as unsupported
* Mark ETERNUS drivers as unsupported
* Remove BRCD primary\_switch\_wwn config option
* Mock qemu calls in sheepdog tests
* Add time.sleep mock for test\_lv\_deactivate\_timeout
* Fix typo errors
* ZFSSA: Allow clones to differ in size from parent
* Convert marker format for listing manageable resources
* vzstorage: use remotefs.VZStorageRemoteFSClient
* OVO: Add reminder to add backporting code
* vstorage: added vz:volume\_format vendor property
* Fix bugs of GPFSNFS & GPFSRemote Driver initialization failure
* Support 'LIKE' operator to filter resource
* Add the missing parameters in the api-ref of ext-backups.inc
* Updated from global requirements
* INFINIDAT: add locking around initialize/terminate connection
* Implementation of Cinder driver for Veritas Access
* Add 'resource\_filters' API to support generalized filtering
* Deprecate osapi\_volume\_base\_url duplicate option
* Updated from global requirements
* Tests: Fix Blockbridge hash randomization failure
* Tests: Fix VMAX hash randomization failure
* Tests: Fix Datera hash randomization failure
* Tests: Fix XIV unit hash randomization failure
* backup: handle device path represented by dir
* Rolling Upgrades: Fix VolumeAttachment
* Add API documentation for force-delete volume in v2 and v3
* coordination: remove un-used method is\_active()
* Fix py27 gate - Remove Tooz usage for tests
* Remove unused volume\_types field when creating group
* INFINIDAT: delete host objects when detaching the last LUN
* INFINIDAT: Use infinisdk for communication with storage array
* Add information in notification of type's extra\_spec
* NFS Backup: Fix overwritting backups
* Add missing retype API documentation
* ibm-storage: update version number and history
* Fix async mirroring on XIV limited range backends
* Rollback snapshot's status when backup failed
* Correct sphinx source code syntax
* Clean codes around backup APIs
* Fix all\_tenants doesn't work for volume summary
* Fix incorrect volume\_id request description in api-ref
* Trivial fix typos
* 3PAR: Added volume to vvset in online copy
* Add documentation for invalid filter keys
* Add service dynamic log change/query
* Dell EMC: Moved SC driver under dell\_emc
* [Trivial] SMBFS: fix passing image format using volume types
* Fix typo
* Correct typo of cinder doc
* Fix swift auth\_url/url check
* Fix typo in docstring
* SMBFS: avoid unnecessary conversion when uploading volumes
* Fix forceful deletion of Consistency Group for GPFS Driver
* Refactor internal context testcases with ddt
* Enable mutable config in Cinder
* VMAX driver - Close ecom connections
* Read XtremIO options from self.configuration
* Read rbd options from self.configuration, not CONF
* Fix backup\_api\_class doesn't work
* Add support for generalized filtering on list APIs
* Modernize the nova client in cinder
* ScaleIO 1.32 deprecation notice
* SMBFS: Use share mountpoint when fetching capacity info
* Fix permission error in VNX driver
* VMware: Stop setting dynamicType
* VMware: Apply policy at vmdk level during retype
* genopts: Fix python 3 compat, sort options
* Remove snapshot['size'] references
* Remove backup-restore methods in driver code
* Fix change API volume create message
* VMAX driver - Manage/Unmanage performance fix
* Updated from global requirements
* VMAX driver - Rollback error on Live Migration
* Remove usage of parameter enforce\_type
* Trivial fix typos while reading code
* Re-arrange v3 API reference
* Re-order api-ref home page index
* Trivial fix PEP 8 coding style violation and typo
* Move the releasenote to the right folder
* Add missing testcases for migration scripts
* 3PAR: Added Replication Feature In Retype Flow
* Functional tests for group replication
* Update attachment's status when attaching a readonly volume
* ds8k: should verify REST version separately
* Remove dependecy testrepository
* Move the releasenote to the right folder
* Remove non-scheduler volume extend support
* Eternus driver: Move soft dependency check out of \_\_init\_\_
* Use cryptography instead of pycrypto
* Tiramisu: replication group support
* xiv: enable get fc targets by host
* NFS: run qemu-img info as root
* Give more time for LVM deactivation
* Remove unused fallocate method/filter
* Fix quota reserve for manage snapshot
* Updated from global requirements
* Delete limited\_by\_marker from api/common.py
* LIO: Fix terminate\_connection AttributeError
* Spelling error "paramenter"
* validate\_integer doesn't check non int properly
* Fix host check in is\_backend\_frozen
* Refactor 'update\_group' method
* Use cg object when invoking update cg method
* Volume Type Encryption added to v2 api-ref
* Fix accessing uninitialized variable bug
* Don't return empty volume\_image\_metadata when list volume
* GPFS: Enhance GPFS driver to work in container
* Create indexes for foreign keys
* NetApp: Refresh directory before waiting
* Fix NoneType has no attribute get
* Updated from global requirements
* HPE 3PAR: Adds CG capability in generic volume groups(GVG)
* Fix typo in comments
* Check groups before deleting group type
* Fix backup temp snapshot path on remote node
* Changing releasenotes file present in review change 409128
* ProphetStor failed to create volume size larger than the snapshot
* Add attachment API doc
* Remove obsolete Liberty code
* VMAX driver - Pre-zoned port group fix
* Updated from global requirements
* Improve help for periodic message\_reap\_interval
* fix typo
* Add 'connection\_info' to attachment object
* Fix the filter when list volume with group
* Filtering attachment doesn't support 'instance\_id'
* Don't check thin provisioning when manage volumes
* Clean up expired user messages
* Dell EMC SC: Support generic groups
* NetApp: Deprecate E-Series drivers
* ScaleIO: Adding CG support to groups
* attach\_volume first check for existing attachment
* Eliminate deprecation warning in db
* Add a release note for groups
* Revert "Huawei: disable certificate verification"
* Fix for Group API update to include check policy
* Create volumes from encrypted images
* Glance: attach volume encryption key id to image
* Dell EMC SC: Raise on \_init\_volume create\_snapshot failure
* qemu\_img\_info: Don't autodetect source format
* Check "kernel\_id", "ramdisk\_id" for Glance v2 only
* XIV: switch to generic volume group
* Updated from global requirements
* Reverts quobyte\_volume\_url option back to type StrOpt
* Disables xattrs on Quobyte driver mounts
* [BugFix] Add method policy in attachment APIs
* Adds a bugfix release note regarding backing up with the Quobytedriver
* HPE Lefthand: add CG capability to generic groups
* qemu\_img\_info: report 'luks' images as 'raw'
* Fix encryption key deletion error handling on volume delete
* Fix rally job gate-rally-dsvm-cinder-ubuntu-xenial-nv
* 3PAR: Enable HPE-3PAR Compression Feature
* ProphstStor driver 'SSL' communication fails to check certificates
* RemoteFS: fix volume cascade delete
* Tests: Remove the redundant methods
* Storwize: correct unreplicated vol status
* recover image-volume size if extend volume failed
* Fix config option volume\_backend\_name's invalid overridden value
* VNX: add missing group snapshot pool stats
* Optimize the link address

11.0.0.0b1
----------

* Updated from global requirements
* Remove unused references from config-generator
* Synology: fix snapshot metadata loss
* Missing volume status on block storage v2 API
* Validate uuid parameters strictly for create volume API
* ds8k: check lun exist or not when clone volume
* DS8K driver should use DLM
* DS8K driver: remove code for fake connector
* [api-ref] Add backing-up to snapshot statuses
* Use HostAddressOpt for opts that accept IP and hostnames
* DS8K driver: change the design of CG
* Add sem-ver flag so pbr generates correct version
* Fixed wrongly catched multiple exception types
* Storwize: add CG capability to generic groups
* Fix attach issue for failed-over volume
* Fix migrate api giving incorrect exception message
* Reduce code duplication
* Separate out routine for getting qemu\_img\_info
* NEC driver doesn't provide link down portal info
* Fix metadata api's raises TypeError
* Remove 'verbose' config option initialization
* Remove sha256file value from logs for incremental backups
* [api-ref] Add cascade to volume delete
* Add CG capability to generic groups in Huawei driver
* Huawei: disable certificate verification
* Hitachi: Mark HBSD and VSP as unsupported
* HNAS: Mark NFS driver as unsupported
* Support for HostAddress opt
* Add an optional db session argument to cinder.db.sqlalchemy.api. quota\_allocated\_get\_all\_by\_project(). Then in quota\_reserve() pass the session that is fetched for that method so that a new session does not have to be made. This can avoid DB timeouts and retries when a lot of concurrent operations are hitting quota\_reserve()
* HPE 3PAR: Handle manage and unmanage hosts present
* VNX: allow specify pool name for replication
* VMAX driver - Live Migration is dropping connection
* [Trivial]Fix some incorrect annotations
* Fix some format error in docstrings
* Add bandit-baseline to tox.ini
* Backup: Add choices to compression algorithm option
* ScaleIO: Fixing support for SIO 1.3x
* Updated from global requirements
* Fix error status check when create backup
* Remove mirror policy parameter from Huawei driver
* Updated from global requirements
* Implementation of cinder driver for Veritas HyperScale
* Tolerate new SQLAlchemy==1.1.7
* [BugFix][Devref] Refactor attach/detach v2 devref
* [BugFix]Cinder forgets to update 'deleted\_at' when deleting
* Add more specific error message
* Tests: mock psutil usage in quobyte tests
* New test case for InfroTrend driver
* Add unit test for brick/local\_dev/lvm.py: create\_volume
* [api-ref] Update snapshot/volume's metadata api-ref
* api-ref: fix rest method error in reset group and group-snapshot status
* Fix the missing args bug while lvm creates volume failed
* [BugFix] Add 'all\_tenants', 'project\_id' in attachment-list
* Huawei driver supports front-end qos
* Use the list iterator instead of six iterator
* Add two response parameters in the api-ref of getting capabilities
* NetApp E-Series CI name update
* Don't use tempest special\_fields
* Add \_\_init\_\_ for cinder.config module
* Clean up index links to removed content
* Make cinder-manage online migrations more verbose
* SMBFS: enable Nova assisted volume snapshots
* Remove deprecated 'host' option for cinder-volume
* Sheepdog: fix conflict of temporary snapshot name
* api-ref: Fix volume\_id parameter for the path
* Fix 500 error when 'mountpoint' is not provided to os-attach
* RemoteFS: prevent creation of encrypted volumes
* HPE LeftHand: extend volume if larger than snapshot
* Mark the Violin volume drivers as unsupported
* Mark QNAP volume driver as unsupported
* [Doc] Add documentation for messages API
* Mark Blockbridge volume driver as unsupported
* Delete the duplicate interface about the api version
* Fix some reST field lists in docstrings
* Remove XML description from media-types
* Fix version numbers on media-types
* Fix status\_code of "list versions" API
* Adding new test case for InforTrend driver
* Fixed inconsistent naming conventions
* Extracted HTTP response codes to constants
* Extracted HTTP response codes to constants
* Extracted HTTP response codes to constants
* Extracted HTTP response codes to constants
* Extracted HTTP response codes to constants
* replace references to cinder.openstack.org
* [doc] Update doc index
* Consistency groups API is not returning project\_id filter groups
* Adding tests for api/v3/group\_specs.py
* Fix docs failures caused by latest eventlet
* VMware: Enforce min vCenter server version 5.5
* Fix cinder functional tests job
* Adds missing return value to create\_cloned\_volume of Quobyte driver
* Don't change volume's status when create backups from snapshots
* Add missing and incorrect response and error codes in cinder api-ref
* ZFSSA can avoid fetching img when creating vol from cache
* Fix more invalid UUID warnings in test\_vmax file
* ZFSSA cache luns are too small when images are precisely X Gi
* Support sort snapshots with name
* [Doc] Add missing parameter in v3 resource documentation
* Remove log translations
* Remove old oslo.messaging transport aliases
* Remove unused CG code
* Delete consistency group fails on xtremio driver
* Remove hacking check for log translation
* Add IOPS limits that scale per-GB
* Update db from drivers in default groups methods
* ScaleIO: Fixing warnings spotted by PyCharm and tox
* Added gigabyte unit to values in exception message
* Set access\_policy for messaging's dispatcher
* Dell EMC SC: Return dict from delete\_consisgroup
* Prevent duplicate entries in the image cache
* Updated from global requirements
* Fix ut error of volume deletion
* IBM storage: switch to generic volume group
* Fix lock contention in SolidFire driver
* Revert "Remove v1 API reference"
* VMAX driver - volumes part of CG not managed correctly
* VMAX driver - consistency group remove empty values
* Datera: extend volume if larger than snapshot
* Tests: Fix InvalidUUID warning for 'qosId'
* Add filter, sorter and pagination for group snapshot
* Correct Extend lvm Volume
* Fix create\_consistencygroup when using CG objects
* Fix: SnapshotStatus missing in Cinder
* Replace yaml.load() with yaml.safe\_load()
* [Optimise] Refactor group snapshot testcases
* Add API documentation for volume detach in v3
* Dell EMC SC: Added retry to \_init\_volume
* Make QnapISCSIDriver unit tests faster
* Adds API documentation for list and show hosts
* Updated from global requirements
* Fix 500 HTTP API error caused by rpcapi RemoteError exception
* Update devref for OVO version bumping
* Improve devref for API errors
* Add a README in tests dir linked to devref html
* Remove HNAS iSCSI driver
* Replace yaml.load() with yaml.safe\_load()
* [Optimise] Refactor ExtraSpecsOpsTestCase with ddt
* ProphetStor driver create vol from snap with wrong size
* Add driver-requirements.txt
* Bump prlimit cpu time for qemu-img from 2 to 8
* Remove "list\_volume" from filter
* Remove unreachable code
* Remove duplicate key from dictionary
* Fix 500 error if boolean is\_public is passed as string
* Fix a typo
* api-ref: v2 API does not mention GET volume metadata by key
* Update guru doc to support file modification events
* rbd: resize volume not cloned but full copy
* Coho: resize volume if cloned image is larger
* XtremIO: allow a cloned volume with larger size
* Replace obsolete vanity openstack.org URLs
* Fix column types in models.py
* cors: update default configuration
* Tests: Use six.moves.urllib urlencode
* Switch to use stable data\_utils
* VMAX driver - Change vendor\_name from EMC to Dell EMC
* VMware: Refactor vmdk unit tests
* api-ref cleanup: remove quotas user related calls
* Fix generic group's unit testcase
* Switch to decorators.idempotent\_id
* Change the default value of used Glance API
* Disallow modification of in use Volume Types
* Hash password displays in debug log
* Add debug log of retryable response on SolidFire
* Filter on Active status in SolidFire List
* Remove TODO related to Nova API version
* Add per-backend availability zones
* cinder-backup - coordination not initialized
* Reuse API v2 for v1 calls
* VMware: Remove redundant sanity check
* api-ref: v2 update volume metadata description is wrong
* Fix action on services raises TypeError
* api-ref: v2 API does not mention DELETE for volume metadata
* Set backup available after verify
* Updated from global requirements
* Fix size update error for snapshot-manage operation
* Remove domains \*-log-\* from compile\_catalog
* Fix typo error
* Updated from global requirements
* Validate display\_name/description attributes in API layer
* Purge immediately on Delete in SolidFire Driver
* Deprecate API v2
* Huawei driver supports specifying copy speed
* Fix internal tempest tests
* Reuse identical API v2 code for v1
* Remove v1 API reference
* NEC: Fix format string in debug message
* Fix ATTACH\_READONLY\_VOLUME message generation
* Remove an outdated comment
* Remove reserving quotas in c-vol's retype method
* Enforce \_usage\_from\_snapshot to fetch info from deleted volume
* VMAX driver - replace pickle with jsonutils
* Switch NFS driver to use DLM locks
* Zadara driver - move from httplib to requests
* Remove Linux SMBFS driver
* Unity driver: fail to disconnect volume
* Remove unused logging import
* create snapshot with generic group fail with XtremIO Driver
* Fix attachments after attached migration
* Fix volume retype with migration as non-admin
* Fix multibackend-matrix confs
* Adds attached migration to multibackend-matrix
* VMAX driver - superfluous debug messages causing error
* Fix SolidFire cgsnap clone bug
* Compact Mitaka database migrations
* Remove Ocata's data migrations
* Add the backup variable structure in backup\_driver interface
* Dell EMC SC: Return dict in delete\_cgsnapshot
* ceph backup support for EXCLUSIVE\_LOCK and JOURNALING features
* SolidFire: Handle connect\_volume() failure when create vol from image
* Change nova\_catalog\_admin\_info to default to publicURL
* Adds db\_online\_data\_migrations to cinder-manage manpage
* VMware: Delete temporary snapshot after clone
* doc: verify all rst files
* Updated from global requirements
* 3PAR: rally test create-volume-from-snapshot fails
* VMAX Driver - disable initiator check by default
* NetApp: Track SVM and Cluster scoped credentials
* Fix Pep8 Failures for Python3
* Tests: Remove mocks of nonexistent methods (NetApp)
* Cinder tox updates for Python3
* [4/4]Reset generic volume group and group snapshot statuses
* Removes getfattr from Quobyte Cinder driver
* Use ovo instead of dict
* Fix duplicate lvs2 entry in rootwrap volume filter
* Updated from global requirements
* fix create\_consistencygroup in xiv
* Output the driver info as json
* Add maximum microversion for Ocata
* Dell EMC Ps: Report discard support
* Switch and/or to ternary operator
* Fix "No documentation found in" errors in docs
* VNX: Handle error during volume deletion
* Unity driver: check array OE version
* Dell EMC: Create independent volume on clone
* Add quota limit check and enhance roll back for cg create
* Storwize: correct the product key for replication
* Fix Block Storage API reference nesting
* VMAX driver - snapshot creation and immediate deletion fix
* Drop version validation
* Add filters support to get\_pools
* [11/11] Refactor test\_volume file
* [10/11] Refactor test\_volume file
* [9/11] Refactor test\_volume file
* [8/11] Refactor test\_volume file
* [7/11] Refactor test\_volume file
* [6/11] Refactor test\_volume file
* [5/11] Refactor test\_volume file
* [4/11] Refactor test\_volume file
* [3/11] Refactor test\_volume file
* [2/11] Refactor test\_volume file
* [1/11] Refactor test\_volume file
* Disable multiattach for all drivers
* Remove support for py34
* Autoselection of IBM SVC/Storwize IO group
* Remove unsupported NexentaEdge driver
* Remove unsupported HPE XP driver
* Remove unsupported CloudByte driver
* VMAX driver - allow for multi volume types in Consistency Group
* Minor cleanup on tools/test-setup.sh
* Add Ocata sanity check migration
* Use https instead of http for git.openstack.org
* Update reno for stable/ocata

10.0.0.0rc1
-----------

* VMAX driver - widen locking around storage groups
* Reserve 5 migrations for DB backports
* Tests: Fix NetApp unit test failure w/ hash randomization
* xiv create vol from replicated source fails
* Don't use None value for sql query
* Remove promote and reenable from policy
* VMAX driver - copy state fix
* VMAX driver - ignore service level and workload in xml
* VMAX driver - Convert eval to ast.literal\_eval
* VMAX driver - failover error fix
* 3PAR: Remove un-necessary snapshot in online copy operation
* Add SUPPORTED flag to Lenovo FC driver
* Image utils: fix fetching available space on Windows
* NetApp cDOT: Add check if copyoffload tool is available
* Fix max\_age calculation for quota usage refresh
* Fix 500 error while listing manageable volumes and snapshots
* Add usage and limit info on quota limit errors
* Prepare for using standard python tests
* Convert ignoreskippedcluster check to be static
* Nosec audit url open issue from Bandit
* Clean up release notes for Ocata
* xiv delete cg fails if removed on backend
* VMware: Set vSphere opID prefix
* Make get\_capabilities look for clusters
* Resolve Brocade HTTPS connection error
* Add SUPPORTED flag to Lenovo iSCSI driver
* Add SUPPORTED flag to HP MSA driver
* Hitachi VSP: Specify compute nodes and copy ports
* ZTE: Added CI\_WIKI\_NAME
* Fix notification short-circuit
* Fix CopyVolumeToImageTestCase max recursion depth
* HNAS: Cloned volume with different volume type
* VMware: Use full clone if extend needed
* Extracted HTTP response codes to constants
* VMware: Use storage profile name in extra-spec
* RBD:Move RBDVolume calls to a separate threads
* Move release notes to correct location
* Add cluster\_name to temporary volumes
* Fix host assignment when clustered
* 3PAR: Inconsistency in copied and source CG
* Remove redundant log during initialize connection
* VMAX driver - sync sv issue
* Reduced the complexity of the main() method
* Add descriptions to Pure drivers
* Adds API documentation for update snapshot status
* clean up replication volume on an xiv backend
* Add create volume from image policy
* Short-circuit notifications when not enabled
* Stop get\_notifier mock in tests cleanup
* VMAX driver - removed incorrect six.text\_type
* Updated from global requirements
* Rebrand and move EQLX driver to dell\_emc folder
* Fix Live Migration for Nimble Storage Driver
* create consistency group mishandles types
* Infortrend: Stable generation of strings from dicts
* VMAX driver - QoS key fix
* VMAX driver - remove global mock of volume\_types
* Switch to decorators.idempotent\_id
* Set image\_owner before adding location to glance
* Dell EMC SC: Delete doesn't account for migration
* Zero out SolidFire capacity when unreachable
* IBM driver update CI\_WIKI\_NAME

10.0.0.0b3
----------

* Fix Qos for clone for Nimble Storage Driver
* Add lock acquire/release debug messages
* [api-ref]Fix the volume metadata description error
* [api-ref]Add volumes/summary API doc
* [api-ref]Change tenant to project
* Fix double call to "qemu-img create"
* Fix api-ref status parameter
* Refactor volumes summary
* Small change to microversion header on devref
* Check if volume node has enough space for image operations
* Revert "Mark the sheepdog driver as unsupported"
* backup of active 3par ISCSI bootable volume fails
* Open the source code of ibm\_storage driver
* NFS snapshots
* Tests: Fix hash unstable dict comparison
* Tests: Fix mock for vzstorage remotefs
* Fix the api-ref CI failure
* Eager load projects when getting types by group
* VMAX driver - rename and restructure driver
* Updated from global requirements
* Switch ManageableSnaphots & ManageableVolumes list to OVO
* VMAX driver - storage group cleanup on error
* Add assert\_min\_rpc\_version decorator
* NetApp cDOT: Add NetApp Volume Encryption support
* Add volume backup tempest tests
* Make CappedVersionUnknown exception more useful
* vzstorage: use resize instead of grow for ploop images
* Add driver supported status to dict output format
* Break migrate\_add\_message\_prefix into two queries
* Remove useless FIXME
* Fix some problem for attachment list
* Don't drop the volume type's extra spec at DB layer
* Switch to using generic groups with Pure driver
* VMAX driver - Implement volume replication for VMAX
* Brcd zonemanager: Fix unstable command generation
* Dell SC: Logging asyncTask if XML returned
* Test: Fix assert\_has\_calls dict order bug (QoS)
* FalconStor: Drop the copy\_image\_to\_volume feature
* Refactor backup RPC API test cases
* Refactor scheduler RPC API test cases
* Update the parameter check when create attachment
* FalconStor: Restore option "san\_secondary\_ip"
* Extracted HTTP response codes to constants
* XtremIO: Add CG capability to generic groups
* VMAX driver - Consistency Group automerge fix
* VMAX driver - Support for compression on All Flash
* Add new attachment APIS
* Add lock around SolidFire clone-image
* VMAX driver - Storage assisted volume migration
* Dell SC: Retype fixes
* Revert "Mark Huawei volume driver as unsupported"
* Fix typos
* Adds getfattr and mount to Cinder rootwrap volume.filters
* Refactor volume RPC API test cases
* Make notify\_service\_capabilities cluster aware
* VNX: Add async migration support
* VNX: Update sg cache if it already existed
* Allow snapshots and volumes to have Null group values
* Fix for FC Initiator API in Nimble Storage Driver
* Revert "Mark Quobyte volume driver as unsupported"
* Fix retype with migrate
* VMware: Allow deletion of snapshot in error state
* Move driver tests to tests/unit/volume/drivers
* Prevent claiming and updating races on worker
* Fix replication freeze mechanism
* Move service and cluster creation in test to utils
* Make Image Volume Cache cluster aware
* Make Replication support Active-Active
* Fix for live migration for Nimble Storage
* NexentaStor5: Added extend method to NFS driver
* Sync \`\`services\`\` SQLA model with what's in the DB
* Make BackupManager not a SchedulerDependentManager
* Optimise: Use sqlalchemy to build table sequence
* Fix volume manage
* Revert "Mark Tintri volume driver as unsupported"
* Nosec subprocess with shell equal True from Bandit
* Modify the spelling mistakes
* Add volume to fake snapshot object
* Clean up image tmp file if c-vol gets restarted
* Modify the spelling mistakes
* Prevent driver load failures from objects
* Nosec Paramiko exec\_command() warning from Bandit
* Replace deprecated pylint disable-msg with disable
* DB: Optimize update methods
* Updated from global requirements
* Save model\_update as admin in create\_volume
* Improvement to get group detail(Part 2)
* Add api version history for 3.23
* Deprecate the Linux SMBFS driver
* Storwize: do the correct update after failover
* Unity Driver: Backup volume via snapshot
* RBD: Fix RBD replication on volumes from image source
* Dell SC: Change DRP search to reference type
* vzstorage: fixed snapshot deletion in error state
* Dell SC: Missing version history
* Remove deprecated RequestBodySizeLimiter class
* Allow triggering cleanup from API
* [py35] image file should be open in binary mode
* HNAS: Change snapshot names
* Add prefix to user message event ids
* Improve compatibility with novaclient 7.0.0
* Updated from global requirements
* Unity: Add support to set IO ports in option
* Fixes hpelefthandclient AttributeError
* Mark the sheepdog driver as unsupported
* Add volume type access operations notification
* Remove inheritance from deprecated classes
* FusionStorage: rename the CI\_WIKI\_NAME
* Dell SC: Failback timeout extended
* Tests: Remove more InvalidUUID warnings
* Don't translate exceptions w/ no message
* Add command information to cinder-manage.rst
* Add CG capability to generic groups in VNX driver
* RBD: Remove volume\_tmp\_dir option
* Fix devref create\_volume doc formatting
* VMware: Use versionutils in oslo.utils
* Delete volume when rescheduling
* VMware: Set backend UUID to volume UUID
* Rename AddFCZone and RemoveFCZone according to PEP 8
* Cleanup limit view name processing
* Datera 2.3 driver update
* Skip CI link in list for infra supported drivers
* Add manage/unmanage to DISCO driver
* Updated from global requirements
* Fix a few typos in storwize\_svc\_common.py
* Doc: Fix build warnings for missing code-block lang
* CoprHD: Handle ScaleIO CI failing with version-3.5
* Python3 common patterns
* Enable DeprecationWarning in test environments
* Add orm type check for paginate\_query
* [api-ref]Add api ref for "volume type encryption"
* Fix sphinx errors related to missing paths/modules
* Cascade + force volume delete parameters
* Adds metadata in search option for snapshot
* Fix python integer interpretation in Py2 and Py3
* Fix Cisco Initiator zoning updates
* Add QoS and Dedupe Support for Nimble Storage
* Remove unused PasteAppNotFound exception
* tgt: Remove existence check before delete
* Only log insecure key manager warning once
* Refactoring ITRI DISCO cinder volume driver
* Convert 'parallels' format name to 'ploop'
* Add psycopg2 and PyMySQL to test-requirements
* Attach/Delete volume for tgt driver race condition fix
* Correct RBD Provision stats&fix a perf problem
* Avoid Forcing the Translation of Translatable Variables
* Updated from global requirements
* Deprecate the block\_device driver
* [1/4]Reset generic volume group status
* HNAS: Deprecate HNAS iSCSI driver
* VMAX driver - PortGroup rollback error path scenario
* Report multiattach capability for Hitachi VSP drivers
* Tests: Split up NFS backup notification test
* Set replication\_status automatically on retype
* Set replication\_status on volume creation
* Update replication property in capabilities
* Cisco: can't add new zone when no zone is created before
* VMware: Fix inventory folder after volume transfer
* Use oslo.messaging topics for multibackend
* Backup project attribute support
* Cinder consistency group returning generic error message
* Move VNX driver to dell\_emc folder
* NexentaStor5: sessions and HTTPS support
* Add more operations to cluster
* Make workers ORM compatible with SQLAlchemy 1.1.4
* VMAX driver - MVs and SGs not reflecting correct protocol
* Delete space to pass the check of pep8
* Fix logging traceback in service logs
* Remove "service" from required\_import\_options
* Add Rest API Support for Nimble Storage
* Adds release note for 'Route extend\_volume' bugfix
* Add 'unmanaging' state to volumes and snapshots
* Fix service\_get mock method
* Mark Nexenta Edge volume drivers as unsupported
* Mark DotHill volume drivers as unsupported
* leave the unreleased branch unspecified for release notes
* Fix VMAX clone CG release note
* Mark Tintri volume driver as unsupported
* Mark Quobyte volume driver as unsupported
* Mark Huawei volume driver as unsupported
* Mark CloudByte volume driver as unsupported
* Mark HPE XP volume driver as unsupported
* RBD: Implement v2.1 replication
* Updated from global requirements
* Storwize: create vol fails near licensed limit
* Add get\_all capability to volume\_attachments
* Cluster volume group fix in lvm
* Drop the judgement condition for FakeConnector
* Rolling upgrade procedure documentation
* Remove Scality backend driver
* Use method is\_valid\_boolstr from oslo\_utils

10.0.0.0b2
----------

* Updated from global requirements
* Support new osprofiler API
* [api-ref] Show more specific parameter of capabilities
* Cosmetic changes to scheduler
* Support A/A on Scheduler operations
* Fix detach twice of snapshot
* Add cinder volume drivers for NEC Storage M series
* Remove authorisation checks at the DB level for quota operations
* Fix condition parameter bug in routes
* Add Apache 2.0 license to source file
* VMAX driver - Attach and detach snapshot
* Improve DB method naming consistency
* Simplify calls to mock\_object
* Make APIVersionRequest's null check more pythonic
* Nexenta: Added ZFS cleanup in NexentaStor4 iSCSI driver
* Move windows drivers to versioned objects
* Correct reraising of exception
* Fix warning when running \`tox -e docs\`
* ibm\_storage driver: Added fczm decorators
* Dell SC: Added Logging to \_swap\_credentials
* Unreserve volume: fix log message for completion
* Dell SC: Missing volume creation options
* Hacking: Remove N333 oslo namespace import check
* Adds Unity Cinder Driver
* Added initial backend ISCSI driver for Reduxio
* Switch default py3x to py35
* Remove run\_tests.sh wrapper
* Do not manage VG with > 1 volume in Kaminario driver
* HNAS: Add list manageable volume/snapshots
* Move to hacking 0.12
* Modify variable's usage in Log Messages
* Prohibit creating volume from source with dif encryptions
* Route extend\_volume calls to scheduler
* Remove deprecated volume\_clear shred option
* Fix dos-style endlines
* Add QNAP ES Storage Driver
* Fix TypeError when execute cinder-volume-usage-audit
* Log detailed attach/detach volumes info
* Remove anyjson test dependency
* EMC VMAX: Remove unused is\_in\_range() method
* Non-WAN port filter issue in Kaminario iSCSI driver
* Updated from global requirements
* Introduce Hitachi VSP iSCSI driver
* Remove Kaminario deprecated option
* Introduce Hitachi VSP driver
* Support A/A in delete actions and get\_capabilities
* Change volume\_type dict to ovo
* Dell SC: Incorrect exceptions being returned
* Tests: Fix invalid UUID warnings
* Block 3.1 message with c-sch RPCAPI pinned to 3.0
* Huawei: Mask unnecessary log print
* Fix status after a VolumeDriverException
* Fix replication\_status on InvalidReplicationTarget
* Add host check on replication actions
* Updated from global requirements
* Revert "Swap volume type for migration started by retype"
* LVM: collect more debug data when VG creation fails
* SolidFire QoS scaled by volume size
* Refactor api test\_common to use ddt library
* New cinder driver to support INFINIDAT InfiniBox
* Remove cgsnapshot\_id before snapshot.save
* Add missing consistencygroup\_id in volume
* Remove support for single backend config
* Removed unused constant in v3/views/clusters.py
* Add back policy check for CG
* Fix secondary lvm cmds rootwrap filters
* Update detach\_volume() with versionedobjects
* Update attach\_volume() with versionedobjects
* Calculate virtual free capacity and notify
* NetApp cDOT driver fails to clone from NFS cache
* Admin API policy enforcement contingent on is\_admin\_project
* test: fix wrong usage of config option in test\_window
* Fix wrong usage of config option gpfs\_images\_share\_mode
* Refactor test\_volume\_actions to use ddt library
* Correct the attributes of volume which created by clone a CG
* Swap volume type for migration started by retype
* Replace functions 'Dict.get' and 'del' with 'Dict.pop'
* Reuse already existing groups in tempest plugin
* Huawei: Mark password option as secret
* Remove Unicode byte order mark
* Add driver interface for groups
* Remove emc folder
* Always allow to create snapshot db record with snapshot-manage
* [api-ref] Correct status code of backup delete
* Add cg constraint when deleting a volume type
* Fix response bootable parameter type in api document
* Skip more parameters when import backup record
* Dell SC: Reject thaw call when backend is failed over
* Dell SC: Unable to locate LV primary after LV-AFO
* Remove nosetests i18n fix
* Remove temporary directory creation for BaseBackupTest
* Add logging to FakeLoggingVolumeDriver
* Remove empty debug\_opts
* Add unsupported status to driver listing
* Add is\_up property to service and cluster objects
* HNAS: Rename hnas\_svcX\_volume\_type
* Fix UnBoundLocalError in update\_consistencygroup
* Support A/A in attach/detach operations
* Remove 2 unnecessary assignments
* Show team and repo badges on README
* HPE3PAR: handle conflict in iscsi host create
* Add dev doc for generic volume groups
* Remove unused constant in hbsd\_horcm.py
* Fix create\_group with group type name
* Show provider\_id for admin
* Fix online data migrations cmd in release notes
* Fix UnableToFailOver exception message
* Gate migration tests: Add Cinder tempest hook
* Updated from global requirements
* Create a dell\_emc folder for Dell EMC drivers
* CG API changes for migrating CGs
* [2/4]Reset group snapshot status
* Update is\_up from Service OVO class to match ORM
* Replace assertDictMatch with assertDictEqual method in tests
* Move XtremIO driver to dell\_emc folder
* Replace six.iteritems with dict.items()
* Fix VMAX unit test timeout issue
* Migrate consistency groups to groups
* Move ScaleIO driver to dell\_emc folder
* Modify the position of try-except
* Fix names in online-data-migrations release note
* Windows SMB: use os-brick remotefs client
* Fix typo in test\_quotas.py
* Skip test\_storwize\_get\_host\_from\_connector\_with\_lshost\_failure
* Update v2 and v3 Volume actions documentation
* Handle NotImplementedError for image cache cloning
* Fix v2 volume create api-reference request parameters
* VMware: VMDK driver performance improvements
* VMAX driver - Create a CG from a source CG
* Deprecate Hitachi Block Storage Driver
* Add host check while create snapshot
* Prevent Active-Active on drivers by default
* Log traceback for validate\_connector exception
* Fix "wrap functions with 2 blank lines" pep8 check
* RBD: improve readability in over provisioning tests
* Delete the redundant expression expected\_attrs

10.0.0.0b1
----------

* Remove use of timeutils.set\_time\_override
* Add generic code for online data migrations
* VMAX driver - Ensure VMAX volume matches cinder db volume
* Updated from global requirements
* Pass OVO instance to copy\_volume\_to\_image
* Drop unused parameter in class EntryCreateTask
* Set EVENTLET\_NO\_GREENDNS for IPv6 and dnspython compat
* Fix doc comments
* Add multipath enhancement to Storwize iSCSI driver
* Update replication doc
* Add VolumeAttachStatus Enum
* Dell SC: Live Volumes not cleaned up
* Remove race conditions from transfer API
* Convert backup\_device to OVO
* Clean \_get\_cctxt method signatures
* DB: Optimize volume\_update method
* Fix typo error
* Fix compatibility with decorator < 4.0.x
* Fix config generator issue with OVO decorators
* Dell SC: Minor cleanup
* NetApp ONTAP: Deprecate 7-mode driver
* Fix unit tests for LVM migration with os-brick 1.7.0
* Fix releasenotes job
* Make c-vol use workers table for cleanup
* Updated from global requirements
* Dell SC: Log FO state more clearly
* Add API unit tests for snapshot creation force values
* Use VolumeDriverException for driver exceptions
* Dell SC: Error creating snapshots with live volume
* Remove GlusterFS volume driver
* VMAX driver - Useful name convention for CG names
* VMAX driver - Duplicate initiator group name error
* To fix miscellaneous bugs in OVOs
* Dell SC: Add init\_volume check and logging
* RBD: prevent creation of encrypted volumes
* Make divisible py3 compatible in vmware driver
* Remove mox3 in test-requirement.txt
* Fix typos in comment
* VMAX driver - No support for creating CG from CG source
* Updated from global requirements
* NetApp Data ONTAP driver enhanced support logging
* FalconStor: Fix creating snapshot failed
* Dell SC: AsyncTask could return incomplete
* VNX:Add more check on replication\_device keys
* Skip unit-tests which use os.fdatasync on MacOS
* Missing parameter for storage pools in Pure Storage driver
* NetApp: Report shared blocks exhaustion
* Allow entry created in VolumeAttachment table for 2nd and later volumes
* storwize: get\_host\_from\_connector optimization
* Huawei: Fix the rest query timeout problem
* Updated from global requirements
* Remove logging import unused
* Add current status to error msg in reserve\_volume
* Return HTTPBadRequest instead of HTTPNotFound
* Removed extra xml api-ref files
* Fix return values of consistencygroup actions in Pure storage driver
* Update .coveragerc after the removal of openstack directory
* Fixes ZFSSANFS driver on Solaris platform
* VMware:Config option for http connection pool size
* Updated from global requirements
* Add generic reset-status method in admin actions' testcases
* Updated from global requirements
* Imported Translations from Zanata
* Mark backup\_swift\_key option as secret
* make Liberty incompatibility error more helpful
* Add Fibre Channel support for Nimble Storage
* Updated from global requirements
* Adjust doc about threading
* RemoteFS: Remove deprecated config options
* Fix HNAS Driver KeyError exception in volume manage
* NetApp NFS: Look for new file for >60s
* Cleanup RCP API versioning
* VMware: Fix deprecation warning
* VMware:Remove redundant check for usable ESX hosts
* Updated from global requirements
* NetApp Data ONTAP headroom calculation error
* Update synchronized decorator
* VNX: use delete instead of remove
* Stop using mox in unit/api/v2/ tests
* Fix the issue that osprofiler opts not in cinder.conf.sample
* Remove volid from attachments\_get\_by\_host|instance
* Coho Data: New socket connections per request
* Imported Translations from Zanata
* Log message cleanup for volume-usage-audit
* Imported Translations from Zanata
* Make divisible py3 compatible in remotefs driver
* Add 'cinder' to the 'allowed\_direct\_url\_schemes'
* Imported Translations from Zanata
* Add backup notification to cinder-volume-usage-audit
* VMAX driver - Create initiator group in single call
* Fix log translation marker in volume/utils.py
* Fix policy file used for testing
* Imported Translations from Zanata
* Dell SC: Can incorrectly identify if it is failed over
* Enable release notes translation
* Remove deprecated cinder.middleware.sizelimit
* Add VERSION to ZTE driver class
* Imported Translations from Zanata
* Switch from tempest-lib to tempest
* VMAX driver - Misleading logging on portgroups
* VMAX driver - Heat detach issue
* Sort options in cinder.conf by module name
* Fix typos in documentation
* Move volume drivers unit tests to tests.unit.volume.driver module
* Add version to ibm\_storage driver
* Remove support for 2.x volume RPC API
* Remove support for 2.x scheduler RPC API
* Imported Translations from Zanata
* Error message for image conversion failure
* Add cleanable base object and cleanup request VO
* Imported Translations from Zanata
* Fix for Tegile driver failing to establish volume connection
* Removing deprecated Dell EqualLogic config options
* Hacking: Remove C305 contextlib.nested check
* Fix typo: remove redundant 'that'
* Removing cinder-all binary
* Updated from global requirements
* Remove old deprecated driver mappings
* Imported Translations from Zanata
* Nexenta: Use base VolumeDriver migrate\_volume
* Add the note of maximum microversion
* VNX: raise exception if no storops
* Speed up kaminario's drivers tests
* VMware: Skip setting vmdk UUID
* Imported Translations from Zanata
* Fix typo in emc\_vmax\_fast.py
* Disable API v1 by default
* RBD Thin Provisioning stats
* Drop unused parameter in class ExtractSchedulerSpecTask
* Add interface decorator to ibm\_storage driver
* Imported Translations from Zanata
* VMware: Remove FakeObject
* Updated from global requirements
* Fix typo in devref/api\_conditional\_updates.rst
* Fix a typo in manager.py,test\_common.py and emc\_vmax\_utils.py
* Re-use RBDImageMetadata and RBDVolumeIOWrapper from os-brick
* Fix IndexError in volume manager
* Remove ovo[fixtures] dependency from tox.ini
* extract\_host: Handle empty host string input
* Updated from global requirements
* Hacking checks for H105
* Remove dead code - replication RPC APIs
* Speed up ibm storwize svc driver's tests
* Files with no code must be left completely empty
* Add support for Infortrend GS Series products
* Add 'replication\_targets' and 'display\_name' in API docs
* Imported Translations from Zanata
* OVO: OPTIONAL\_FIELDS should be moved inside the OVO
* OPTIONAL\_FIELDS should be inside OVO object group\_snapshot
* Moving the OPTIONAL\_FIELDS inside the OVO object group
* Updated from global requirements
* Cleanup lintstack exceptions related to objects
* Imported Translations from Zanata
* Remove placeholder tempest test
* Hacking: remove check for "tests/unit/integrated"
* Allow attribute lazy loading in VolumeType OVO
* Provide cfg to ignore lvm descriptor leak warnings
* Imported Translations from Zanata
* Imported Translations from Zanata
* Imported Translations from Zanata
* Volume get: Check policy before fetching metadata
* Fix a typo in scheduler manager "filter\_propterties"
* Fix test case note
* Fix project assignment in VolumeType OVO
* Imported Translations from Zanata
* Fix pep8 E501 line too long
* Using assertIsNone() instead of assertIs(None)
* Fix formatting in generate\_config\_opts
* Reduce redundant call of image show
* Limit memory & CPU when running qemu-img info
* Updated from global requirements
* Allow getting qos\_specs in db.volume\_type\_get
* Fix missing string format specifiers
* Deprecate LocalVD, SnapshotVD, CGVD, ExtendVD, TransferVD
* Use keystoneauth1 for creating the keystone session
* Add test\_get\_all\_by\_volume in objects/test\_backup
* replace filter() to meet python3
* Add snapshot id validation during volume creation
* Imported Translations from Zanata
* Refactor of getting qemu-img version
* Remove extra param in list\_manageable\_snapshots
* Stop using mox in cinder/tests/unit
* Modifies override logic for key\_manager
* Remove unnecessary setUp
* Imported Translations from Zanata
* Sheepdog: fix clone failure
* Read domain info from context when contacting nova
* Compact Liberty database migrations
* XtremIO: fix migration bug
* Remove unnecessary setUp and tearDown
* Imported Translations from Zanata
* Don't attempt to escalate cinder-manage privileges
* Remove duplicate keys from dictionary
* Remove unnecessary setUp and tearDown
* Add missing %s in print message
* Create v3 API Reference
* Reserve 5 migrations for Newton backports
* Add os-detach to api-ref
* Fix request\_spec conversion from o.vo to dict
* Storwize: remove SCSI LUN ID for volume attaching
* Stop using mox in unit/\*.py (2/2)
* Imported Translations from Zanata
* Huawei: Backend capabilies report optimization
* Imported Translations from Zanata
* Imported Translations from Zanata
* Update reno for stable/newton
* NetApp cDOT: Fix model update for cheesecake volumes

9.0.0.0rc1
----------

* Fixed request/response parameters in doc
* Add volume RPC API v3.0
* Add scheduler RPC API v3.0
* XtremIO: bump driver version to 1.0.8
* Imported Translations from Zanata
* netapp image cache cleaning start thresholds does not work
* Fix missing JSON response in API reference
* Mark v1 as DEPRECATED in devref
* Add xUnknownSliceID to retry list
* Dell SC: ISCSI initialize\_connection fixes
* Use IP in Kaminario locks and add/delete loggers
* Add combined function get\_vol\_type\_by\_name\_or\_id
* Imported Translations from Zanata
* Remove unreachable return statement
* Dell SC: Disable connectivity failures for new servers
* Fix release notes formatting
* Fix coerce good values in test\_fields.py
* VMAX driver - Does not honor clone volume size
* Updated from global requirements
* Fix glance v2 image update
* Unit test to use vol obj instead of dictionary
* Imported Translations from Zanata
* Remove few Kaminario release notes
* Newton release notes cleanup
* Use to\_policy\_values for enforcing policy
* Fix logic in retype check for encryption changes
* Added default for ScaleIO driver max\_over\_subscription
* Save volume\_type/group\_type uuid into db when creating group
* Imported Translations from Zanata
* DRBD: Don't put clients everywhere
* VMAX driver - Cleanup of Initiator group fails
* Imported Translations from Zanata
* fix the %{} when string formating
* Fixed illegal syntax error code in ScaleIO rename volume
* VMware: Send additional connection info
* Imported Translations from Zanata
* Have a default OPTIONAL\_FIELDS for persistent OVOs
* Include OPTIONAL\_FIELDS in VolumeType OVO class
* Remove sleep mocks in RBD unit tests
* Fix RBD timeout
* Fix creating typeless volumes with Mitaka's c-sch
* Add missing release notes
* Make sure get\_backup\_device result is an o.vo
* [api-ref] Correct response code in Cinder API v2
* VMAX driver - failed rollback on VMAX3 when MV issue
* Fix order of arguments in assertIs
* Remove driver interface changes from reno devref
* Imported Translations from Zanata
* Doc: qos-specs is always and only "Administrators only"
* Cleanup Newton release notes
* Clean create\_snapshots\_in\_db method
* standardize release note page ordering
* Dell SC: Error attaching after LV-AFO
* VMAX driver - Removal of iscsiadm from vmax cinder
* VMAX Plugin - Target WWN change for redundancy
* Orphan view and multipath issue in Kaminario driver
* Imported Translations from Zanata
* [api-ref] Correct response code in Cinder API v1
* Eqlx: Ignore missing snapshot on delete
* NetApp cDOT: Fix reporting of replication capabilities
* Mark Scality volume driver as unsupported
* Trivial: Fix a trivial flake8 error
* VMAX driver - Replace "SLO" tag with "ServiceLevel" tag
* Register state\_path opts and add it to sample conf
* Imported Translations from Zanata
* Refactor volume status in managing vol
* Updated from global requirements
* VMAX driver - Won't delete pre-existing initiator groups
* NetApp: Fix issue with busy snapshot deletion
* Provide volume size for tempest volume creation
* Nexenta: Added use of sessions for NexentaEdge drivers
* Imported Translations from Zanata
* RBD: Error when managing a nonexistent volume
* Fixed indentation
* XtremIO: fix bug deleting cgsnapshot
* Raise NotImplementedError instead of NotImplemented
* Imported Translations from Zanata
* Support create group with group type name
* Rename specific driver option with synology prefix
* Remove doc for promote/reenable replica
* Imported Translations from Zanata
* Imported Translations from Zanata
* LeftHand add entry point tracing
* Remove host assignment in Snapshot OVO
* Fix lazy loading cluster field from Service OVO
* Fix manage existing MissingDependencies error
* Do not pass unicode to str.isspace()  when disabling a service
* Correction in log massage format syntax
* EMC VMAX - multi-attach failure to VMAX3 when SLO is omitted
* add more credentials information to check\_is\_admin
* VMAX driver - Retrieve volume from snapshot
* Fix CapacityWeiger to accept None volume type
* Imported Translations from Zanata
* check quota per\_volume\_gigabytes for transfer-accept

9.0.0.0b3
---------

* Dell SC: Add dell\_server\_os configuration option
* Add supported driver checks to Zone Manager
* Fix backup unit tests imports for os-brick
* Fix backup unit test with new os-brick
* Stop using mox in unit/api/contrib/ tests (1/2)
* Stop using mox in unit/volume/drivers/\*.py
* ScaleIO over subscription support
* Fix exceed of dd action when copying with path
* Fix CapacityFilter to accept None volume type
* Fix HNAS stats reporting
* Imported Translations from Zanata
* Stop using mox in unit/api/v3/ tests
* Deleting volume metadata keys with a single request
* Switch StrOpt to URIOpt for URL config options
* Add Castellan release note
* Add ability for ceph driver to report discard
* Changes stats report for ScaleIO driver
* Remove cinder/tests/unit/test\_misc.py
* Imported Translations from Zanata
* CoprHD: Handle create volume from CG snapshot error
* Performance issue for VNX attache LUN
* Config logABug feature for Cinder api-ref
* Stop using mox in test\_wsgi, test\_nexenta, test\_netapp
* Remove unused source file tests/unit/db/fakes.py
* Fix an invalid function call in test\_consistencygroups.py
* zfssaiscsi driver log messges need cleaned up
* Fix typo in enable\_unsupported\_driver description
* Mark GlusterFS driver as deprecated
* Retype encrypted volumes
* Fix DellStorageCenter docstrings
* Fix driver interface checks for ZTE driver
* Add CI\_WIKI\_NAME to ZTE Driver
* Add CI\_WIKI\_NAME to X-IO Driver
* Add CI\_WIKI\_NAME to Synology iSCSI Driver
* Create encrypted volumes from images
* Add encryptor attach/detach in utils
* XtremIO: fix the returned value of CG actions
* Stop using mox in unit/api/contrib/ tests (2/2)
* Change assertTrue(isinstance()) with optimal assert
* Stop using mox in unit/\*.py tests (1/2)
* Use assertIn instead of assertTrue(A in B)
* Remove unused function from unit/fake\_utils.py
* Imported Translations from Zanata
* Clean import in code
* Remove unused config.CONF
* Add tempest tests for Consistency Groups
* HNAS: Add support for manage/unmanage snapshots in NFS driver
* Reduce the runtime of drivers/ibm/test\_storwize\_svc
* Improve TestCase.mock\_object method
* Fix the password print in cinder-volume.log issue
* VMAX Driver - Live Migration for VMAX3
* Remove self.\_\_dict\_\_ for formatting strings
* Imported Translations from Zanata
* CoprHD: Add missing key in ScaleIO driver
* Avoid patch loopingcall in VNX
* Add validation for the metadata properties
* Removed RPC topic config options
* Clean imports in code
* Replace key manager with Castellan
* Cleanup api-ref
* Update api-ref path
* Nexenta: NexentaStor4 NFS driver cache capacity and use sessions
* Stop using /etc/cinder/cinder.conf for cmd tests
* Use utils.validate\_dictionary\_string\_length
* Stop using mox from unit/image/\*.py
* Fix some typos in comments
* Separate create and update rules for volume metadata
* Updated from global requirements
* TrivialFix: remove unnecessary VERSION\_COMPATIBILITY
* When only .pyc left, the extended API can not be used
* Recover volume status after remove\_export
* Pure - warn when deleting destroyed snapshot
* Fix quota rollback on retype failure
* Pin RPC server's serializer to min obj version
* Driver documentation cleanup
* Host selection when creating backup
* TrivialFix: Remove cfg import unused
* Fix password masking result
* Let setup.py compile\_catalog process all language files
* Dell SC: Add exclude\_domain\_ip option
* Add support for force backup for Nimble Storage
* Retype issue in Kaminario Cinder drivers
* TrivialFix: Remove logging import unused
* Stop using mox in unit/volume/drivers/emc/\*.py tests
* Stop using mox in unit/consistencygroup/\*.py tests
* Stop using mox in unit/scheduler/\*.py tests
* Stop using mox in unit/zonemanager/\*.py tests
* Stop using mox in unit/backup/drivers/\*.py
* Fix incorrect parameter in create\_key
* Use constraints for api-ref environment
* Dell SC: Live Volume Autofailover
* Add new supported driver checks
* Tests: Fix racy volume unit test
* [Trivial] Refactor the using of dict.get() in the test assertion
* vzstorage: fix create/delete snapshots
* Sending ScaleIO volume id in attach and detach volume
* Cleanup upgrade-related FIXME's
* Using oslo\_config's min attribute
* Add replication failback in Kaminario K2 drivers
* Added config option to enable SSL
* Group specs: Fix exception name
* Dell SC: Failback replications limited to 5 at a time
* VMware: Add volume name in vCenter to conn info
* NetApp: Report multiattach as enabled
* Attachment lost after migrating in-use volume
* Fix typo in the huawei\_driver.py
* Fix invalid services caused by enabled\_backends
* Updated from global requirements
* Change NFS driver to not throw exception without nfs shares file
* Datera driver 2.2 update
* Reduce the runtime of drivers/dell/test\_dellsc
* Add release note to warn about os-brick lock dir
* Updated from global requirements
* Use min attribute from oslo\_config
* Imported Translations from Zanata
* Fix the interface to call update\_server\_volume
* Dell SC: Break\_replication unhandled NoneType error
* Volume Manage/Unmanage Support for IBM FlashSystem
* Imported Translations from Zanata
* Change a typo error in the releasenote
* Fix reported driver's versions
* Use OVOs to set errors in manage volume/snapshot
* Use original volume OVO instance in create flow
* Fix mysql binary comparison
* VMware: Allow images in ova container
* Add CI\_WIKI\_NAME to driver's devref
* Improve Hitachi HNAS volume drivers log messages
* Updated from global requirements
* EMC VMAX - iSCSI Multipath support
* Fix typo in cinder/tests/unit/image/test\_glance.py
* Clean imports in code
* Imported Translations from Zanata
* Enhance api\_microversion doc
* Add CI\_WIKI\_NAME to Tegile volume driver
* Add get\_manageable\_\* methods to Pure drivers
* Use constraints for all tox environments
* Imported Translations from Zanata
* Remove the using of dict.get() in assertIsNone
* Revise Synology DSM storage driver
* Refactor the usage of save\_and\_reraise\_exception
* Add volumes/summary API support
* Imported Translations from Zanata
* Ignore case when comparing wwns in Pure FC driver
* NetApp: Add Consistency Group Support for NFS
* Replication, hard-coding and dict.name issues in K2
* Update homepage with developer document page
* Add CI wiki page to driver listing
* Imported Translations from Zanata
* Refactor cinder.utils.\_copy\_volume\_with\_path
* HNAS: Deprecating XML config file
* Add functional-py35 to tox
* Remove code duplication in enums
* Concurrency issue in K2 iSCSI and FC Cinder drivers
* VMAX Driver - QoS support for the VMAX3
* Mask out passwords when tracing
* Remove debug logger translations
* Imported Translations from Zanata
* Fix volume creation with no volume type
* Dell SC: delete\_live\_volume payload incorrect
* Dell SC: Requests async header is invalid
* Imported Translations from Zanata
* Use object instead of string when reset backup
* Prevent doc generation failure on OVO decorators
* CI: Add CI\_WIKI\_NAME to all drivers
* Imported Translations from Zanata
* Make the volume-manage doc be more general
* Add missing dependency on keystoneauth1
* Fix tox pip-missing-reqs
* Revert "Remove Tegile volume driver"
* HPE XP add entry point debug tracing
* Remove resource\_common\_manage load warning
* Updated from global requirements
* Huawei: Check before add initiator
* Huawei: Modify array LUNs naming rules
* Added update-host for CGs in cinder-manage
* Imported Translations from Zanata
* Remove unused context parameter
* Imported Translations from Zanata
* QoS support for the Coho Data Cinder driver
* Fix backup NFS share mount with default backup\_mount\_options
* Add tracing to remotefs entry points
* NetApp cDOT: Add cheesecake replication support
* Don't use config option sqlite\_db
* Improve snapshot handling in K2
* Fix volume retype from SolidFire
* EMC VMAX - Oversubscription support
* Ceph doesn't save a container name for volume backup
* Updated from global requirements
* Fix volume upload-to-image for vhd disk-format
* Imported Translations from Zanata
* Remove context object in oslo.log method
* 3PAR add entry point debug tracing
* Fail manage operations if service is down
* Support retype in K2 cinder driver
* Remove comma from end of policy.json
* Prevent adding same OVO version twice to history
* Removed a dead db function register\_models()
* Handle snapshot delete conflict in 3par driver
* Imported Translations from Zanata
* Specify key algorithm and size for create\_key
* Add functional-py34 to tox
* Fix size exceed of dd action when clearing a volume
* HNAS drivers refactoring
* Use volume o.vo in get\_backup\_volume\_temp\_snapshot
* Imported Translations from Zanata
* Fix ImportError of fake\_driver
* Add proxy config option to google backup driver
* Add API Reference for groups
* Add stochastic weight handler to scheduler
* Fix Scheduler manager masking retype fail details
* fixed misspelling in synology\_common.py
* Updated from global requirements
* Don't puke when exiting driver list
* corrected the help string in coho.driver
* Fix ImportError of fake\_driver
* Storwize:create\_volume\_from\_snapshot with different size
* Imported Translations from Zanata
* Fixing pending comments for CoprHD Drivers
* Huawei: Fixed problems caused by password expiration
* Add metadata length check to volume-manage
* Added unit test coverage to test\_limits.py for api v2
* Dell SC: Use Live Volume for replication
* Remove race condition from lvextend
* Switch request\_spec in create volume calls to ovo
* Support replication in K2
* Support manage/unmanage and extra-specs in K2
* Update xiv\_ds8k driver name and description
* Imported Translations from Zanata
* Set VERSION in VNX cinder driver
* ScaleIO ignore rename of external volumes
* Managed snapshot should return ceiling of size in Huawei driver
* Size in tintri driver should be converted to integer
* Improvement to query cg detail(Part 1)
* Fix documentation and remove dead code
* VMware: Fix retype when storage policy is enabled
* Validate name in qos-spec
* Replace functions 'Dict.get' and 'del' with 'Dict.pop'
* Updated from global requirements
* NetApp: Report hybrid aggregates in volume stats
* Storwize: Quote vdisk names to handle spaces
* Add group\_type\_id in create\_group\_snapshot
* Fixes ZFSSANFS driver
* DRBD: Disk-options for new resources
* Fix mistakes introduced with QoSSpecs object
* Add backup update function (microversion)
* VMware: Fix upload to image with glance v2
* Remove Tegile volume driver
* Quobyte volume driver should use DLM
* Add functional tests for nested quotas
* XtremIO: Implement update\_migrated\_volume
* NetApp: Refactor unit tests
* Add driver list to doc build
* Move fake\_driver to tests root dir
* Map volume/snapshot manage extensions to v3
* Replace OpenStack LLC with OpenStack Foundation
* VMAX Driver - SnapVX licensing checks for VMAX3
* LVM driver: list manageable volumes and snapshots
* Sheepdog:fix the bug of failed to clone image
* Move drivers unit tests to unit.volume.drivers directory
* Docs: Correct i18n information
* Fix db purge for quality\_of\_service\_specs FK constraint
* Fix log message when service is disabled
* Add interface documentation to driver devref
* Remove duplicate code in functional tests
* Docs: cleanup doc8 errors
* Docs: remove todo list generation
* Update doc README and remove old Makefile
* Imported Translations from Zanata
* Handle API NotFound exceptions at WSGI level
* Add worker's DB operations
* Add workers table
* Modify API to include cluster related operations
* Update manage with cluster related commands
* Improve cinder-manage arg parsing
* Add cluster job distribution
* Update Versioned Objects with Cluster object
* Add cluster table and related methods
* Update OVO instance on destroy method call
* Fix wrong declaration in Scheduler's base driver
* Refactor sqlalchemy service methods
* Improve api\_version decorator to avoid noqa
* Imported Translations from Zanata
* Add functional tests for groups
* Tests: mock notifier in CG tests
* Remove duplicated code in manage\_existing\_snapshot
* Initialise oslo.privsep early in main
* Imported Translations from Zanata
* Add lock decorator to SolidFire clone\_image method
* Dell: Fix docstring cut/paste error
* NetApp: Support new parameter to cDOT clone API
* Auto sync manager's RPC\_API\_VERSION
* Fix CinderPersistentObject.refresh
* Replace locks in remotefs and glusterfs backend drivers
* Block Device Driver: report pools in volume stats
* Add missing test case
* Updated from global requirements
* Invalid volume state when manage operation fails
* Add group snapshots - APIs
* Dell SC: Add secondary DSM support
* Fix some typos
* Remove generate\_driver\_list dependency on cur dir
* Huawei: Support reporting disk type of pool
* Fix 500 for 'qos-create' key or value > 255 characters
* Add group snapshots - manager
* Add group snapshots - db and objects
* XtremIO: support of snapshot manage commands
* Fix the group type filter
* Fix policy check for group types
* Differentiate thick and thin provisioning
* Remove force option from create\_snapshots\_in\_db()
* Set sleep time to 0 in Datera driver
* Add generic volume groups
* Huawei: Support backup snapshot
* Fix assertEqual usage in test\_volume\_manage
* Fix chunked backup driver interface name
* Removed unused code from cinder.utils
* 3par driver handles concurrent host create conflict
* Fix typo in delete snapshot in Synology driver
* Removed unused code from cinder.utils

9.0.0.0b2
---------

* Fixes consistency snapshot creation
* [doc] Fix a non-alphabetical order bug
* Trivial: Use fake.VOLUME\_ID instead of id
* Violin Memory iSCSI storage for 7000 series AFA
* update min tox version to 2.0
* Updated from global requirements
* Switch \_create\_temp\_cloned\_volume in driver to VO
* NetApp: Add aggregate capacity info to scheduler
* Add strict Boolean checking for storage pools
* Add Synology DSM storage driver
* Use from\_environ to load context
* Use context.from\_dict to determine available arguments
* Add ZTE Block Storage Driver
* iSCSI Target: remove confusing comment/log
* Storwize: Fix exception ProcessExecutionError
* Changing method \_from\_db\_object to classmethod
* Allow admin project to operate on all quotas
* Use default provisioning type from config
* Delete \*.pyc files before running tox tests
* Implementation for CoprHD Cinder Drivers
* Image virtual size doesn't fit to volume size
* Don't apply config fixture to auth\_token.CONF
* Check flashcopy mapping before deleting volume
* Send scaleio id to os-brick
* Nexenta: Added HA support and enhance get\_volume\_stats()
* Fix failure with "None" volume type in Pure drivers
* Add backend driver for Zadara Storage VPSA
* Add group type and group specs
* Don't use shred for volume clearing
* Add cinder backend driver for Huawei FusionStorage
* Do not conjecture volume-id from iscsi\_name
* VNX: New Cinder driver in Newton
* Return vaild reason when unknown error occur
* Moving the OPTIONAL\_FIELDS inside the OVO  object
* Support microversions on inherited Controllers
* Replace use of mox with mock in test\_base\_filter
* Replace 10 \*\* 9 with a constant units.G
* Reduce logging level of API validation messages
* Fix manage existing volume fails after object merged
* Add strict Boolean checking for volume manage
* Adds unit test coverage for consistencygroups.py
* FalconStor: New Cinder driver in Newton
* Move QualityOfServiceSpecs to use VersionedObject
* Snapshot object has no attribute about size
* Add return parameter info for manage\_existing\_get\_size
* cinder-manage db purge has issues with foreign keys
* Huawei: Use versionedObject
* Resolve unittest hang issue
* Fix some typos
* Add logging when filtering returns nothing
* Validate extra\_specs type
* Just a few spelling modification. "occurred"
* Remove white space between print and ()
* Log traceback for initialize connection failure
* Remove unused LOG
* Use assertEqual/Less/Greater/In/IsNone
* Updated from global requirements
* Add \_\_ne\_\_ built-in function
* Fix consisgroup V3 interfaces
* Add proper scheduler\_hint key to dev-ref
* check the validity of metadata when update volume
* Remove unused \_\_init\_\_
* EQLX: Extend of snapshot or clone failure
* Log terminate\_connection exception with traceback
* Replace use of mox with mock in test\_api\_urlmap
* Add README in release notes directory
* Fix broken link in HACKING.rst
* Replace int with float to bring math.ceil into effect
* EMC ScaleIO should return ceiling of volume size
* Deprecate defining c-vol backends in DEFAULT
* Dell SC: Do not set High Availability in async mode
* Replace use of mox with mock in test\_ibm\_xiv\_ds8k
* Remove translation from config options
* Correct reraising of exception
* EMC VMAX - locking SG for concurrent threads
* Use elevated context to query DB in VolumeNumberWeigher
* Huawei: Support huawei consistency group
* Make divisible py3 compatible in nfs driver
* Updated unit tests to use official unittest methods
* Fix raise UnableToFailover call in SolidFire
* Provide Kaminario K2 all-flash array FC driver
* RBD: uppercase rbd\_opts for consistency
* Add strict Boolean checking for volume create
* Replace use of mox with mock in test\_brick\_lvm
* Replace use of mox with mock in test\_lvm\_driver
* Remove six.iter\*
* Updated from global requirements
* Add validation for container name
* VMware: Fix create vol from streamOptimized image
* Use True instead of 1 in while loop
* Remove mock.patch.stopall call in test\_smbfs
* XtremIO: fix test suite
* Add strict Boolean checking for quota show
* Correct unavailabe to unavailable
* Huawei: Support iSCSI configuration in replication feature
* Dell SC: Specify High Availability for create replication
* Increment Pure Storage Driver Versions
* Refactoring Kaminario iSCSI driver
* Don't reuse pep8 env in compliance tox runs
* Trivial Fix
* NetApp: Finish SSC refactor by removing dead code
* Implement unit test for HPE Lefthand driver
* Added coverage report to tox.ini
* Add strict Boolean checking for qos delete
* Add validation for type extra\_specs
* Replace mock with self.override\_config
* fix cinder ceph backup driver padding error
* Replace 1024\*1024\*1024 with units.Gi to express more accurately
* Unexpected function is called in \_migrate\_volume\_generic
* Violin: resize volume if cloned lun is larger
* Make dict.keys() PY3 compatible
* Move \_validate\_extra\_specs to cinder/utils
* VMware: Refactor vmdk unit tests
* Updated from global requirements
* Move \_check\_metadata\_properties to cinder/utils
* Remove deprecaterd mapping in manager.py
* Capability lists in Cinder scheduler
* Updated from global requirements
* Nexenta: Add NBD driver for NexentaEdge
* Add missing coordination=True on service start
* tempest: Add Unicode volume name test
* Adding Scaling QoS for ScaleIO driver
* Updated from global requirements
* Implement match-set type 3PAR FC VLUN creation
* Fix pylint error in K2 iSCSI driver
* Fix lock files littering working dir during tests
* Fix TSM backup driver test mocks
* Improve DB volume check in LVM manage volume
* VMware: Honor vmware\_cluster\_name during retype
* Revert "Revert "use utf8 as default charset for all tables in mysql db""
* Fix snapshot stuck in 'deleting' after reboot c-v
* Update initialize\_connection to use versionedobjects
* Updated from global requirements
* NetApp: Replace SSC for cDOT block & file drivers
* Revert "use utf8 as default charset for all tables in mysql db"
* huawei-iscsi-multipath-support
* use utf8 as default charset for all tables in mysql db
* Implemented unit test cases for HPE LeftHand driver
* add FIXME tag for extra argument 'topic' in scheduler rpc api
* update coordination.Lock.release's docstring
* Fix permissions error when configuring nfs backend
* Use cinders test class in cloudbyte unit tests
* Correct DB modifications from compaction
* Add unit tests in cinder for HPE Lefthand driver
* Provide Kaminario K2 all-flash array iSCSI driver
* VMware:Persist storage policy ID in vmdk meta-data
* Allow setting CG name or description to empty value
* Support None value of extra\_specs in cinder-scheduler filter
* Fix db purge for volume\_types FK constraint
* ABC Metaclass for IBM FlashSystem
* IBM FlashSystem: Add host check for iSCSI driver
* vzstorage: add ploop volume format support
* Use versionedobjects in remotefs.py
* Move test from test\_glusterfs and test\_quobyte to test\_remotefs
* Netmask needs corersion to string
* image\_size\_m should get ceiling of image
* Add unit tests in cinder component for 3PAR driver
* Handle quota exceed exception
* Replace locks in volume manager
* Updated from global requirements
* Start/Stop coordinator with Volume service
* Tests: Remove notification\_driver config
* Tests: Use mock for notifier tests
* 3PAR: Fix delete volume when online clone
* Add driver interface checks
* Add test type clarification to devref
* Backup and restore broken in zfssaiscsi driver
* Windows SMBFS: fix VHD/x resize
* Remove duplicated fake drivers
* Cleanup volume\_type\_projects
* Implement OVO class init mechanism
* Add debug level logs on OVO backports
* Stop assuming persistent OVOs are also DictCompat
* Move OVO methods from CinderObject to Persistent
* Remove remotable from OVOs
* Use manifest to backport OVOs during upgrades
* Nimble: Don't query all vols from DB in do\_setup()
* Fix wrong usage of exception's attribute message
* Add parameter info for manageable snapshots
* Adds ACL, IP Pool, Multipath to Datera Driver
* Dell SC: Retry unhandled exception REST Gets
* Fixed \_create\_3par\_iscsi\_host(), added unit test for 3PAR
* Set QoS on cloned volumes
* VMware: Deprecate vCenter version 5.1
* Update manage\_existing to use volume object
* VMware: Fix constants in unit tests
* Updated from global requirements
* EMC driver should return ceiling of volume size
* Use oslo\_middleware sizelimit
* migrate to os-api-ref
* volume upload-to-image fails for iso disk-format
* Huawei driver should return ceiling of volume size
* Volume manage/unmanage support for Eqlx driver
* NetApp: Log unexpected errors from backend
* Add Auth Version 3 support in Swift Backup Driver
* Add error messages to conditional updates devref
* Add docstrings to CG and CG Snapshot filters
* Virtual size should get ceiling of image
* DRBD: Allow to set options for new resources
* SolidFire driver should return ceiling of volume size
* Clean up man page and remove version/date
* 3PAR: Fix terminate\_connection when failed over
* VMware: Remove unused methods
* Fix MySQL DB error in Delete CG
* Nimble driver should return ceiling of volume size
* Updated from global requirements
* Remove locks from Pure volume drivers
* Give more fine grained access to DriverInitiatorData
* Remove IN\_USE from ConsistencyGroupStatus enum
* Compact Kilo database migrations
* Bump to Nova v2.1
* Switch to using correct TaskFlow Failure class
* Optimize service find in migration
* NetApp NFS Cmode: Fix NotFound exception
* Add check to limit maximum value of age\_in\_days
* GPFS: Fix consistency group ERROR\_CREATE status
* Remove the duplicated definition of \_add\_to\_threadpool
* Imported Translations from Zanata
* Coho data sanity fix in the driver unittest

9.0.0.0b1
---------

* Dell SC: Added support for failover\_host failback
* Remove API races from consistency groups
* Minimize cost of DB exists decorator checks
* Pass volume\_type\_id in when deleting snapshot
* Add unit test case in Nimble Driver
* Fix attachment\_get\_by\_\* to return entire list
* Remove API races from migrate and retype
* SwiftBackupDriver: Dont add project\_id to authurl
* Updated from global requirements
* Catch GlanceMetadataNotFound in creating cgsnp
* Updated from global requirements
* List manageable volumes and snapshots
* Updated from global requirements
* Add pagination support to messages
* gpfs: Add changed options for 'find' command in rootwrap filters
* Huawei replication should use auto recovery policy
* Dell SC: Switched REST calls to async where available
* Move all backups related unit tests to backup directory
* Move consistency groups tests to consistencygroup directory
* Volume manage should parse volume size as float
* Return BadRequest for invalid 4byte unicode character
* NetApp: Add iterator handling to client library
* Make IBM drivers return snapshot object for cg ops
* Coho Data: Reconnect to cluster on broken pipe
* Remove mox usage from test\_nexenta
* Manage/unmanage snapshot in ScaleIO driver
* 'display-name' is not used in snapshot\_manage
* LeftHand Fix terminate\_connection when failed over
* Storwize: terminate\_connetion NPIV perf improvement
* Revert "Add hacking check to prevent assert\_called\_once"
* Fix 3PAR cg display name issues
* DRBD: ensure\_export() might not have 'provider\_location'
* Fix image-volume cache to use volume object when evicting
* Fix retype from non-repl to repl type in Pure drivers
* Remove test\_conf.py
* Dell SC: Changed rename volume REST API call
* Add hacking check to prevent assert\_called\_once
* Updated from global requirements
* Huawei: Raise if no FC port found
* VMware: Increase default task poll interval
* VMware: Update volume config during unmanage
* Drop use of invalid assert\_called\_once call
* Fix AttributeError when obtaining 'name' attribute from 'snap'
* Handle SSL termination proxies for version list
* Call \_init\_volume\_driver in backup manager
* Updated from global requirements
* model\_update for temp volume or snapshot in backup
* Add debug messages and comments for ceph backup
* Avoid ascii code error for request body strings
* Fail on disabled\_reasons with more than 255 chars
* Windows iSCSI: properly handle config option
* Remove unused logging import and LOG global var
* Fix Brcd zone driver initiator zone update
* Add SnapshotStatus enum field
* Tests: Fix mock imports
* NetApp: Remove type checks from manage workflow
* ScaleIO actual volume size model update
* Capacity weigher: Pass correct arg to super()
* IBM Flashsystem: Add missing items to common
* Prevent Multitable conditional updates
* Remove support for 1.x volume RPC API
* Remove inappropriate Copyright
* RBD: include cluster name in connection info
* Tests: Don't attempt connection for Coho driver init
* 3PAR Clean up VLUN deletion on detach
* Remove object to dictionary translation logic
* Refactored the update method in api.py for vol obj
* Tests: Use unique volume IDs in backup tests
* Move LVM tests to test\_lvm\_driver.py
* Move CG unit tests to test\_cg.py
* Fix an error in CG object
* Fix backup using temp snapshot code path
* IBM FlashSystem: Cleanup host resource leaking
* Updated from global requirements
* Add sample config file to cinder docs
* Make api\_microversion\_dev more explicit
* Use check\_string\_length from oslo\_utils
* Fix up RPC cleanup process
* Add unit tests in cinder component for HPE drivers
* Whitelist 'rm' in api-ref tox environment
* gpfs: remove a race in deleting volumes
* Fix taskflow parameters for manage\_existing
* Correct misspelt words in msg in cinder
* Implement CHAP Authentication for E-Series Driver
* WADL to RST migration in cinder tree
* Properly mock out image\_utils operations for tests
* Dell Eqlx: Volume from snapshot now honors resize
* Use example.com in unit tests
* Extend remove\_version\_from\_href support
* Fix return value of \_clone\_image\_volume
* image: don't use is\_public with glance V2 API
* Change provider\_id to StringField
* Add missing SnapshotUnavailable to cinder/exception.py
* NetApp: Rewrite user API discovery logic
* Remove unnecessary v3 VolumeController.\_\_init\_\_
* Fix v3/volumes.py VolumeController super(...) parameters
* DB: Optimize volume existence check
* Reorder DB API require\_context decorators
* Remove API races on extend and volume\_upload\_image
* Manage existing volume with invalid host
* Remove CG db access in Storwize driver
* Specify a user-agent in Pure volume drivers
* Dell SC: find\_volume failure in manage and retype
* 3PAR driver failure SR License missing in array
* Remove unnecessary created\_at from ORM Message
* Fix uncaught NotFound exceptions
* Remove support for 1.x Backup RPC API
* Provide consistency to "Openstack-Api-Version" header
* Change OVOs project\_id and user\_id to StringField
* Use to\_utf8() instead of safe\_encode() in convert\_str()
* Replace manually changing CONF options
* remove extra quota commit of manage snapshot
* Add replication v2.1 test cases
* Move initiator\_data access to helper methods
* Add ability to filter by volume\_glance\_metadata
* Add Cheesecake APIs to policy.json file
* Add upload\_image API role-based access policy
* Add snapshot\_metadata operations to policy.json
* Mark the v1 API as deprecated
* Fix Lun ID 0 in HPE 3PAR driver
* Added 'volume:get\_transfer' to policy.json file
* NetApp: Decouple capacity volume stats collection
* NetApp: Managing cDOT LUN by UUID fails
* VMware: Use \_in\_use() to check for in-use volumes
* Add devref for conditional updates
* Fix gate-cinder-tox-db-functional job
* Add ordering possibilities to conditional update
* Add unmanage volume for RBD driver
* Updated from global requirements
* VMware: Support for paraVirtual image adapter type
* Pass default executor to os-brick
* NetApp: E-Series driver using invalid host-types
* NetApp: Use Local Cache to Copy an Available Image
* Add provider\_location to cloned volume
* Failback will enable the host that has been frozen
* Move and rename tempest\_tests to cinder/tests/tempest
* Tests: lower case all fake uuid constants
* Tests: Fail if oslo.versionedobjects issues Invalid UUID warnings
* Removed extra line of code
* Fix uuid warnings in various api contrib unit tests
*  Fix snapshot test uuid warnings in api.contrib
* Fix volume test uuid warnings in api.contrib
* Fix vol type/spec uuid warnings in api.contrib
* Fix qos\_manage uuid warnings in api.contrib tests
* Fix CG uuid warnings in api.contrib unit tests
* Fix admin\_actions uuid warnings in api.contrib
* Fix uuid warnings from api.contrib backup tests
* Fix uuid warnings from test\_db\_api unit tests
* User messages API for error cases
* Imported Translations from Zanata
* Imported Translations from Zanata
* Assisted snapshot:  use Keystone Session with Nova Client
* Imported Translations from Zanata
* fix invalid uuid in emc extremio unit tests
* fix invalid uuid warnings from test\_cmd
* Fix invalid uuids in tintri unit tests
* Fix uuid warnings from db unit tests
* Fix invalid uuids in EMC scaleio unit tests
* Tests: Fix invalid UUIDs in EMC VNX tests
* ibm flashsystem: Fixing hardcoded attribute
* Fix 20 typos on devref
* VMware: Remove TODO for port config option
* Remove XML API
* Microversion of Bootable filter in cinder list
* init\_host offload to default to true
* Imported Translations from Zanata
* Updated from global requirements
* 3PAR: Remove metadata that tracks the instance id
* Updated from global requirements
* Handle TFlow short comings in SF driver
* Add failed\_over detection to SolidFire driver
* Implement replicate\_volume & failover on SolidFire
* Deprecate nas\_ip and change this to nas\_host
* Imported Translations from Zanata
* Implement Cluster Pairing for SolidFire Driver
* Fix minor typos in the migration devref
* Cleanup volume\_attachment in case of reset-state attach\_status
* Updated from global requirements
* Use messaging notifications transport instead of default
* Fix doc and source documentation errors and warning
* RBD: delete snapshots if missing in the backend
* Coding style issue
* Remove support for 1.x scheduler RPC API
* Launchpad Answers no longer used
* Fix RPC and Object version pinning on API
* Fix service version pinning on start
* Fix doc build if git is absent
* Updated from global requirements
* Tests: Define fake\_constants as constants
* Doc: Remove incorrect run\_tests.sh documentation
* fix invalid uuid warnings from test\_quota
* Fix fake uuids in NetApp ESeries unit tests
* Fix invalid uuids in sheepdog unit tests
* Use utils.convert\_str to convert HTTP header values
* Remove deprecated ISERTgtAdm
* Set backup import volume id to real uuid
* fix ConsistencyGroup volume\_type\_id field
* Updated from global requirements
* Storwize: Multiple management IP not raising exceptions
* Fix ExtraSpecsOpsTestCase sub unit tests
* check per\_volume\_gigabytes quota for cinder extend
* Imported Translations from Zanata
* Updated from global requirements
* Make cinder-all binary deprecated
* Add in-tree tempest tests
* Update SolidFire driver to store cluster info
* VMware: Reduce volume creation time
* Fix typos in Cinder files
* Fix driver.failover\_host call in manager.py
* Remove "patch mock to raise for invalid assert calls"
* Add test for checking object compatibilities
* Update the Administrator guide links
* Update \_usage\_from\_backup() method with versionedobjects
* Dell SC: Updated to utilize provider\_id
* Updated from global requirements
* Sheepdog:make full use of all sheepdog nodes
* Enable str2size() to handle long int for i386
* Imported Translations from Zanata
* Hacking: Ignore tools/ for C303
* Pylint: refactor ignored message lists
* Brocade FCZM: Fix LOGOUT\_PAGE reference
* Fix volume retype failure with on-demand policy
* Define context.roles with base class
* Fix invalid error message of volume create
* Stop using tpool with oslo\_db
* Huawei: Do not do split if replication pair abnormal
* Storwize: fix unmapped multi-attached volume failure
* Cleanup DB schema after Mitaka
* Fix uuid warnings from api.v2 unit tests
* Dell SC: Checking volume size in create\_volume\_from\_snapshot
* Fix uuid warnings from api.v1 unit tests
* Fix api/v1 unit test inconsistencies
* Add fake\_cgsnapshot for unittest use
* Fix typos in Cinder files
* http header value must be a string
* python34 tests don't run without python3-dev
* Re-enable image to volume with failure test
* Dell Eqlx: Cloning volume does not honor new size
* Storwize: fix deadlock and major lock granularity issue
* Fix for NexentaEdge jsonrpc url formatting
* Support oversubscription for IBM Storwize/SVC

8.0.0
-----

* Huawei: Fix getting admin\_metadata
* Imported Translations from Zanata
* NexentaStor4 iSCSI: convert blocksize to str
* Conditionally restore display\_name
* NexentaStor drivers: resize volume if cloned image is larger
* rtstool surrounds IPv6 addresses by brackets
* Imported Translations from Zanata
* NexentaStor: Remove extra format string specifier
* Fix typos in Cinder files
* Imported Translations from Zanata
* XtremIO handle errors in terminate\_connection:
* Imported Translations from Zanata
* Check hasattr before calling get in SolidFire
* Huawei: Fix getting admin\_metadata
* Remove unused utils.find\_config function
* Sheepdog:optimization of connection error handling
* DRBD: extend volume if larger than snapshot
* Imported Translations from Zanata
* Fix invalid uuids in rbd unit tests
* Dont query image metadata for empty volume list
* Remove entry\_points from setup.cfg
* Don't suppress the path part of glance url
* Fix meaningless quota exceeded exception info
* Imported Translations from Zanata
* Don't disallow quota deletion if allocated < 0
* Added more options while uploading volume as image
* VMware: Support for non-default port
* Remove PyMySQL and psycopg2 from test-requirements.txt
* Imported Translations from Zanata
* Provide user friendly message for FK failure
* Fix misspelled word in help text
* Datera: resize volume if cloned image is larger
* Fix Brcd lookup service to use defined southbound protocol
* Docs: Add genconfig to devref toc
* Updated doc string
* Imported Translations from Zanata
* Report 2.0 as supported version of RPC APIs
* Fix volume RPC API methods related to backups
* Report 2.0 as supported version of RPC APIs
* NexentaStor5 iscsi: resize volume if cloned image is larger
* Imported Translations from Zanata
* EMC VMAX - Operations and timeout issues
* Imported Translations from Zanata
* Imported Translations from Zanata
* Fix the format problem of LOG in failover\_host
* Dell SC: Error results moved to json
* Dell SC: create\_cgsnapshot returning wrong structure
* Re-add policy check for get\_snapshot
* Enable functional test for volume creation
* Remove bandit.yaml in favor of defaults
* NexentaEdge: resize volume if cloned image is larger
* Storwize: Set multiattach property per pool
* Fix volume RPC API methods related to backups
* Imported Translations from Zanata
* Imported Translations from Zanata
* Fix race condition when toggling SP
* Dell SC: create\_cgsnapshot returning wrong structure
* Hitachi drivers: resize volume if cloned image is larger
* Huawei: Record and check LUN wwn
* Mark deprecated options correctly
* SMBFS: fix parsing volume type extra specs and metadata
* Update reno for stable/mitaka
* VMware: Bump driver version
* VMware: Bump driver version
* Imported Translations from Zanata
* VMware: Refactor unit tests
* Update .gitreview for stable/mitaka
* Huawei: Record and check LUN wwn

8.0.0.0rc1
----------

* Reserve 5 migrations for Mitaka backports
* Add update\_host for backup in cinder-manager
* Fix formatting in vol/snap delete API messages
* Cleaned duplicate dictionary values
* Fix compatibility mode of backup jobs scheduling
* Add devref on rolling upgrades
* 3PAR fix create\_cloned\_volume for larger size
* VNX: Enhance migration start verification
* Check volume\_id consistent when creating backup
* Fix race condition when toggling SP
* Huawei: Check when attach hypermetro volume
* Huawei: Check the QoS status before we use
* LeftHand: Add default SSH timeout and key values
* Pass correct source\_id to \_handle\_bootable\_volume\_glance\_meta()
* Alter wrong comment about param filters
* Use get\_by\_args instead of get\_by\_host\_and\_topic
* Fix format in cinder/volume/drivers/netapp/dataontap/block\_base.py
* XIO: refactor \_send\_cmd to reduce the redundant
* Revert "VNX: Set timeout for naviseccli"
* NetApp E-Series: Volumes not added to consisgroup
* Fix volume migration VolumeType exception
* Fix retype failure when original has no volume type
* Add backup RPC API v2.0
* IBM XIV/DS8K: Implement Replication v2.1
* Huawei: Implement v2.1 replication
* Remove circular import to fix config generation
* Wrong comment line in quotas.py
* XtremIO handle errors in terminate\_connection:
* Imported Translations from Zanata
* VNX: Set timeout for naviseccli
* VNX: Allow set migrate rate when migrating volumes
* Fix ScaleIO driver does not honor clone size
* Fix py34 error of indexing 'dict\_keys' object
* Imported Translations from Zanata
* Fix error message when running genconfig
* Huawei: Creating hypermetro failed in the remote pool
* Delete deprecated configuration in NFS tests
* Imported Translations from Zanata
* Emit notifications for volume retype
* Fixup stats key for replication in init\_host\_with\_pc
* EMC VMAX - SSl connection is not picking up values
* Add the key 'replication' and set the correct 'replication\_status'
* register the config generator default hook with the right name
* Fix for Pure drivers not checking full client version
* Fixup for Pure drivers cheesecake replication setup
* Remove empty directories and unused files from unit tests
* Cleanup 3PAR/LeftHand failover\_host exceptions
* Use googleapiclient import instead of apiclient
* Enable api.view.test\_versions unit tests
* Allow clone volume with different size
* DRBD driver: resize volume if cloned image is larger
* Fix 500 error if 'offset' is out of range
* Add volume RPC API v2.0
* Imported Translations from Zanata
* typo: add a missing '}' in comment
* Fix up failover\_host exceptions to preserve states
* Add release note for delete volume with snaps
* RBD: remove duplicate clone test
* Disallow quota deletes if default under usage
* EMC VMAX - SnapVX and other snapshot improvements
* Move replication\_status update to init\_with\_rpc
* Lazy load a project quotas's default values
* Permit volume type operations for policy authorized users
* SMBFS: fix parsing volume type extra specs and metadata
* Host selection in backup service
* Add volume\_type to volume object expected\_attrs
* VNX: Update replication for v2.1
* Imported Translations from Zanata
* Pass new volume size when cloning (blockbridge)
* Storwize: Update replication to v2.1
* LeftHand: Create cloned volume didn't honor size
* Switch failover-host from rpc call to cast
* Dell SC: Active\_backend\_id wrong type
* Show qos\_specs\_id based on policy
* Remove remaining oslo-incubator code from Cinder
* Updated from global requirements
* Pass RBD order to clone call
* Remove "sqlite\_clean\_db" option
* Exclude test.py from sample conf
* Fix invalid UUID warnings for test\_volume\_\*
* Huawei: Check before delete host
* rbd: Change capacity calculation from integer to float
* Fix failure with rbd on slow ceph clusters
* Remove those unnecessary statements "return True"
* Imported Translations from Zanata
* Run py34 tests with plain 'tox' command
* Report versions in cinder-manager service list
* Dell SC: create\_cloned\_volume didn't honor size
* Cleanup Mitaka release notes
* Dell SC: Incorrect values in REST API Login call
* Moved CORS middleware configuration into oslo-config-generator
* Add get\_volume\_stats for LoggingVolumeDriver
* Correcting thin provisioning behavior
* SMBFS: Fix initialize connection issues caused by in-use images
* NetApp: volume resize using clone fails with QoS
* VMware: Unit test refactoring
* Fixes creating volume issue for multiple management IPs
* Imported Translations from Zanata
* Add volumes table definition when migrating to 67
* Trim 5s+ from storwize unit tests
* Allow api\_version\_request.matches to accept a string
* microversion header for legacy endpoints removed
* Update quotas to handle domain acting as project
* Continue volume delete on encryption key delete errors
* Fix backup import
* Unset executable bit in release note
* DRBD: Policy-based waiting for completion
* Block subtractive operations in DB migrations
* Handle exceptions about snapshot in backup create
* Replace logging with oslo\_log
* Support https keystone CA checking in volume quotas
* Imported Translations from Zanata
* Fixup release notes for v2 -> v2.1 replication impls
* support new HTTP microversion header
* Fix for glance\_metadata during volume migration
* Readd iscsi\_target table
* Imported Translations from Zanata
* Fix issue with Pure drivers delete\_snapshot exception handling
* Add backend id to Pure Volume Driver trace logs
* Don't fail on clearing 3PAR object volume key
* Fix invalid uuid warnings in backup unit tests
* Update quota\_utils with import for keystone\_auth
* Fix invalid uuid warnings in test\_volume.py
* Tintri image direct clone
* Use get\_by\_args instead of host\_and\_topic
* Remove a vol in error state from a CG
* Fix call to Barbican Secrets create()
* 3PAR use same LUN id for each export path
* Fix oslo.service config generation
* Update unittest for Storwize pool-aware-cinder-scheduler
* Huawei: Check the real size before extend volume
* Revert "Remove Cisco FC Zone Manager Driver"
* Make query to quota usage table order preserved
* Allow for Pure drivers to verify HTTPS requests
* Fix volume filtering for quoted display name

8.0.0.0b3
---------

* Use openstack.org URLs in README
* Add attach/detach doc to index
* Don't run test\_volume.VolumeTestCase twice
* Fixes running error for storwize \_run\_ssh
* Dell SC: Support Replication V2.1
* Use OSprofiler options consolidated in lib itself
* Fix test\_create\_volume\_flow test issue
* Fix test isolation issues related to versions
* Add missing requirements
* Convert huawei ISCSIDriver unit tests to RFC5737 addrs
* Changes in ScaleIO configurations options
* Storwize/SVC: Clone between different size volumes
* Huawei: Manage volume fails due to lower array version
* Fix exception during service update
* Huawei: Create snapshot have a log error
* EMC VMAX - Limit SG and MV to 64 characters
* Fix spelling mistake in docstring
* EMC VMAX - Recreating SG when it has been deleted
* VMAX-Replacing deprecated API EMCGetTargetEndpoints
* 3PAR: Update replication to v2.1
* LeftHand: Update replication to v2.1
* Update Pure replication to cheesecake
* Fixed logging for oslo versioned objects
* Move replication volume manager warnings to info
* Trim 50s from huawei ISCSIDriver unit tests
* Copy unit tests for StandardLogging fixture from Nova
* Add 'conf' param for TextGuruMeditation autorun setup
* Use is\_int\_like method from oslo\_utils
* Fix sshpool.remove code
* Remove an useless and wrong call
* Copy StandardLogging fixture from Nova
* Add ability to failback for replication V2.1
* Storwize SVC multiple management IPs
* Updating Datera DataFabric Driver to v2 of Datera DataFabric API
* Capture warnings into logs
* Return BadRequest for invalid unicode names (continued)
* IBM Storwize with pool-aware-cinder-scheduler
* Fix HTTP sessions left open in Brocade zone driver
* Fix invalid uuid warnings in block device unit tests
* Fix invalid uuid warnings in scheduler unit tests
* Add necessary fields to volume creation
* Add scheduler RPC API v2.0
* Clean up replication v2.1 (Cheesecake) RPC API
* always use pip constraints
* Remove unused columns from Service ORM model
* CONF add suppress\_requests\_ssl\_warnings
* Make nullable of fields in db model and object match
* Remove unused pngmath sphinx extension
* Delete volumes with snapshots
* Clarify glance\_api\_insecure help text
* NetApp: Fix SSH Client File Creation in Unit Test
* Trim 12s from disco unit tests
* Remove QoS settings from SolidFire attributes
* EMC VMAX - get iscsi ip from port in existing MV
* Misprint in policy.json
* Re-enable -1 child limits for nested quotas
* Support IP lookup of target portal DNS name
* Updated from global requirements
* Huawei: delete\_snapshot need not return any value
* Match the ip more accurately in Huawei driver
* Huawei: Consider bandwidth when selecting port
* Add description when rename LUN in Huawei driver
* Huawei: Code cleanup
* Modify the number of params of hypermetro in HuaweiDriver
* EMC VMAX - Changing PercentSynced to CopyState in isSynched
* Add basic workflow of attach/detach to devref
* Change frozen error messages from \_LE to \_
* Replication v2.1 (Cheesecake)
* Change Fail to Failed in error messages
* NetApp: Add Consistency Group support for E-Series
* Return BadRequest for invalid Unicode names
* Check for service existance in capabilities API
* Enable all unit tests on Python 3.4
* Adding general notes about rolling upgrades
* Move deprecation release notes to correct section
* Tests: Don't assert on LOG.warn
* Return all target\_wwpns for FC storwize
* Fix error message in cinder type-update
* Fix NoneType error in service\_get\_all
* Add os-brick rootwrap filter for privsep
* LeftHand: Updating minimum client version
* NetApp: Implement CGs for ONTAP Drivers
* Fix HNAS iSCSI driver attachment
* NetApp: Support iSCSI CHAP Uni-directional Auth
* Avoid hardcoding value from oslo library
* cinder-api-microversions code
* Port netapp dataontap driver to Python 3
* Scalable backup service - Liberty compatibility
* Huawei: Log the IP when login fails
* Huawei: Fix create volume with prefetch value error
* Huawei: Don't fail when port group does not exist
* Force target\_lun to be int type to make os-brick happy
* Changed Nexenta default chunksize from 16k to 32k
* Volume manage/unmanage support to ZFSSA drivers
* Removed unreachable code
* Disable multi-attach for RBD
* Correct iscsi lun type
* Fix invalid uuid warnings in object unit tests
* Imported Translations from Zanata
* Fixed help message for AllocatedCapacityWeigher
* EMC VMAX - not cleaning up HW Resource WWPN initiators
* Huawei: Fixed url range
* Updated from global requirements
* Test: use assert\_has\_calls() instead
* Move anyjson to test-requirements
* Huawei: Judgement failure when creating hypermetro
* Remove useless get\_replication\_updates driver call
* [LVM] Restore target config during ensure\_export
* 3PAR get host by WWN now handles mixed cases
* NetApp: E-Series remove snapshot limitations
* Fix race condition in RemoteFS create\_snapshot\_online
* Add SIGHUP handlers to reset RPC version pins
* Handle OverQuota exception during volume transfer
* Remove extra get\_active\_zoneset query from Brocade CLI
* Tintri image cache cleanup
* Huawei: Ensure the port is online
* Rtstool sets wrong exception message on save
* Test middleware test\_faults to Python 3
* Split out NestedQuotas into a separate driver
* Revert changes to use ostestr
* doc: Fix wrong description about adding RESTful API
* Propoerly call oslo's Service stop and wait
* Remove unused kill method from Service
* Wait for periodic tasks to stop on exit
* Dell: Failed vol create could leave dead volumes
* Roll back reservations quota in RPC if necessary
* Scaling backup service
* EMC ScaleIO - fix bug in extend volume
* VMware: manage\_existing for VMDK driver
* VMware: manage\_existing\_get\_size for VMDK driver
* Delete unuseful code in Huawei driver
* Cleanup unused conf variables
* Port infortrend driver to Python 3
* Disable Rally backup-related scenarios
* Fix last Python 3 issues in zonemanager
* Port hgst driver to Python 3
* Port API v1 and v2 to Python 3
* Port API contribs to Python 3
* Port test\_emc\_vnx to Python 3
* Fix service-list filter
* Coho volume stats update
* Sheepdog: Fix malformed image url format
* Update quota when volume type renames
* Add restore\_volume\_id in backup
* Updated from global requirements
* Support for consistency groups in ScaleIO driver
* Use of metadata id instead of metadata name
* Fix 'asert' typo in unit test
* Fix dynamic import of CONF.volume\_api\_class
* Filter & goodness functions in NetApp drivers
* Manage/unmanage volume in ScaleIO driver
* HNAS driver: Fix SSH and cluster\_admin\_ip0 bug
* Remove duplicated code in volume manager and base driver
* Don't use Mock.called\_once\_with that does not exist
* EMC VMAX - necessary updates for CG changes
* RBD: use versioned objects
* Tests: Fix calls to non-existent assert methods
* Updated from global requirements
* Profiler: make it possible to run without loading osprofiler
* Profiler: don't call trace\_cls if profiler is not enabled
* Tests: Set volume listen port to test\_service\_listen\_port
* Remove Cisco FC Zone Manager Driver
* Add variable QoS to NetApp cDOT drivers
* Move integrated tests to 'functional' directory
* py3: Fix usage of JSON in API contrib
* Port utils.safe\_minidom\_parse\_string() to Python 3
* Include allocated quota value in the quota reserve
* Log stack trace for middleware faults
* hacking: Fix false positive in C302 check
* Port backup drivers to Python 3
* Storwize: Implement v2 replication
* Volume create fails with FakeISCSIDriver
* Adds support for configuring zoning in a virtual fabric
* ScaleIO QoS Support
* Zfssaiscsi driver should not use 'default' initiator group
* Update db in CGSnapshot create
* 3PAR: Create consistency group from source CG
* Remove old client version checks from 3PAR driver
* Improve logging to debug invalid "extra\_specs" entries
* Huawei: Implement v2 replication (managed)
* DRBD: Fix arguments for resize\_volume DBus API call
* Port objects unit tests to Python 3
* Updated from global requirements
* VNX: Add 'None' check in parsing provider location
* NexentaStor5 iSCSI driver unit tests
* LeftHand: Implement un/manage snapshot support
* Updated from global requirements
* EMC VMAX - Method not being called for V3
* Allow for eradicating Pure volumes on Cinder delete
* HNAS driver: retry on Connection reset fix
* Fix issue in hacking with underscore imports
* DRBD: Compat for current DRBDmanage versions
* Fix variable scope issue in try-except
* Imported Translations from Zanata
* Bootable filter for listening volumes from CLI
* Clean uploading volume when c-vol restarts
* mock time.sleep in Broadcom unit test
* Don't create cgsnapshot if cg is empty
* Added osprofiler headers to cors middleware
* Imported Translations from Zanata
* Fix the replication spelling in message
* 3PAR fix driver to work with image cache
* Updated from global requirements
* Improve logging for volume detach
* Remove useless unit tests mock in Huawei driver
* Return updated volume type after updating
* Remove 'external=True' in Huawei driver
* Fix XtremIO multi cluster support
* EMC VMAX - Fix for last volume in VMAX3 storage group
* Filtering type extra-spec support to ZFSSA drivers
* Zfssaiscsi driver should return target\_lun as int
* Pin RPC and object version to lowest running
* Report RPC and objects versions
* Add missing RPC calls versions to rpcapi modules
* Huawei: Balanced FC port selection when zoning
* VNX: Replication V2 support(managed)
* Adds HTTPS southbound connector for Brocade FC Zone Driver
* Replication V2 for Pure Storage
* Support ZeroMQ messaging driver in cinder
* Remove redundant definition of 'deleted'
* Fix update\_consistencygroup log info
* Correct opt type for nexenta\_chunksize/blocksize
* Huawei: Add manage/unmanage snapshot support
* Remove deprecated options from NFS driver
* Fixing HNAS XML parser
* Replace exit() by sys.exit()
* IBM XIV/DS8K: Implements Replication V2
* Support cinder\_img\_volume\_type in image metadata
* Adds friendly zone name support
* LeftHand: Implement v2 replication (unmanaged)
* EMC VMAX - VMAX driver failing to remove zones
* Remove access\_mode 'rw' setting in drivers
* Tests: Strengthen assertFalse assertions
* Fix laggard cisco FC zone client unit tests
* Fix xtremio slow unit tests
* Fix sluggish rbd unit tests
* Fix torpid coordinator unit tests
* Rework Storwize/SVC protocol to fix add\_vdisk\_copy
* NetApp ONTAP - Reapply API tracing
* Run flake8 also on cinder/common
* Replace assertEqual(\*, None) with assertIsNone in tests
* Wrap the method to calculate virtual free capacity
* Add pagination support to consistency group

8.0.0.0b2
---------

* Fix NFS driver unit test docstring
* Adding action to policy.json
* fix NFS driver max\_over\_subscription\_ratio typo
* Add pip-missing-reqs tox env
* Add missing requirements
* Added 'bootable volume' filter for non-admin user
* Move wsgi to oslo\_service.wsgi
* Set LVM driver default overprovisioning ratio to 1.0
* Tegile tests: Change volume size to int
* VMware: Fix release notes
* FlashSystem reports error in \_find\_host\_exhaustive()
* Huawei: Refactor driver for the second time
* Add cinder backup driver for Google Cloud Storage
* NexentaStor 5 iSCSI backend driver
* NexentaStor 5 NFS backend driver
* DRBD: Rename "dres" to avoid confusion with "res"
* EMC VMAX - Incorrect SG selected on an VMAX3 attach
* Activate sparse copy for Netapp
* Add Fujitsu ETERNUS DX Volume Driver (FC part)
* Imported Translations from Zanata
* XtremIO: FC initialize connection failed
* Updated from global requirements
* Disallow transferring volume in consistency group
* Reduce use of eval()
* Remote unused iscsi\_targets table
* ITRI DISCO cinder driver
* NetApp eseries: report max\_over\_subscription\_ratio correctly
* Python 3: Replace reduce and xrange with six.moves
* Infrastructure to use the DRBD transport for NOVA
* NetApp ONTAP: Fix extending volume beyond lun geometry
* Refactor Windows drivers using os-win
* Base iSCSI initiator validation
* Fix ChunkedBackupDriver \_create\_container
* XtremIO: Set the location of a CA certificate
* Huawei: Add manage/unmanage volume support
* Remove DB calls from Pure Volume Driver CG methods
* Dell SC: Adding logging to httpclient
* LeftHand: Implement v2 replication (managed)
* Enable trim/discard in SolidFire's driver
* API Middleware fault: Log exception type
* Re-add Nexenta drivers
* Remove invalid NetApp QoS keys
* Fix thin provisioning flags in NetApp drivers
* Return BadRequest for invalid Unicode names
* Handling Invalid argument iflag=direct in dd
* Execute mount.nfs check as root
* Report discard support for Dell SC connections
* Add ConsistencyGroupStatus enum field
* 3PAR: Adding volume checks to manage snapshot API
* Added Keystone and RequestID headers to CORS middleware
* Allow host and instance\_uuid at attach
* Trival: Remove 'MANIFEST.in'
* Imported Translations from Zanata
* Add finish\_volume\_migration to volume object
* Fix tox -e fast8
* Updated from global requirements
* Removes the Violin 6000 FC and iSCSI drivers
* Dell SC: Implements Replication V2
* Storwize: Add force flag on vdisk mapping call
* Storwize/SVC: Volume manage using source-name
* Enable consisgroups in SolidFire driver
* Replace deprecated library function os.popen() with subprocess
* Constant defined for sqlAlchemy VARCHAR & INTEGER
* Fix image volume creation error
* Cleanup in backup reset status
* NetApp FC drivers should not set 'rw' access mode
* Change minimum 3PAR API version for replication
* Optimize 3PAR array ID retrieval
* Add metadata aliases to Volume object
* Add pagination support to volume type
* Re-enabled hacking checks for H105
* Don’t log warnings for image cache when disabled
* Fix grammatical mistake in defining articles
* Scality SOFS: don't always read /proc/mounts twice
* Add BackupStatus enum field
* Updated from global requirements
* Fix issue with flake8 check and full paths
* Fix race conditions in migration 061
* Replace use of mox with mock in test\_nfs
* Updated "deleted" column of volume\_type\_access
* Add Fujitsu ETERNUS DX Volume Driver (again)
* Add backref relationships to ConsistencyGroup obj
* Misspelling in message
* Fix some warnings about 'unused variable' for XIO
* Updates consistency group for ibm svc driver
* Add volume driver for Tegile IntelliFlash array
* Fix to allow RBD delete an unprotected snapshot
* Remove the deprecated ibmnas driver
* Wrong usage of "a"
* VMware: optimize in get\_cluster\_refs
* Rebrand HP XP driver to now be HPE
* Fix creating volume by snapshot for GPFS driver
* Rename Huawei drivers
* Check min config requirements for rbd driver
* Remove API races from delete methods
* Remove API races from attach and detach methods
* Quota API is now compatible with keystone API v2
* Add pagination support to Qos specs
* Remove name\_id when creating volume with cache enabled
* Imported Translations from Zanata
* Updated from global requirements
* Enhance the stats reported from the Pure Volume Drivers
* Allow replicated volumes to be recoverable
* Imported Translations from Zanata
* Retyping volume got error under max vol limit
* Add config option to enable reporting discard
* Storwize: Split up \_\_init\_\_ into separate files
* Fix volume upload failure with glance\_api\_version=2
* EMC VMAX - Extend Volume for VMAX3
* XtremIO add support for create CG from CG src
* Fix bugs caused by porting to python3
* Imported Translations from Zanata
* Disable capabilities based on 3PAR licenses
* Add empty initialize\_connection method to PureBaseVolumeDriver
* Fix python 3.x import issues with pure.py
* Override osapi\_volume\_listen\_port for test\_workers
* Updated from global requirements
* replace deprecated oslo\_messaging \_impl\_messaging
* Remove downgrade migrations
* Fix delete\_snapshot error case in Pure driver
* 3PAR: Implement un/manage snapshot support
* Error handling for invalid SLO/Workload combo
* 3PAR: Implement v2 replication (unmanaged)
* Add serial number to eseries ASUP payload
* XtremIO: fix generic glance cache with XtremIO
* VMware: Add support for VVOL datastores
* Tooz locks
* Small refactoring in test\_admin\_actions.py
* Imported Translations from Zanata
* Making NFS \_find\_share efficient
* Change the format of some inconsistent docstring
* Preserve request id in Cinder logs
* Add volume\_extensions:quotas:delete to policy.json
* Pass volume\_id in request\_spec for manage\_existing
* VMware: Fix volume copy across vCenter datacenters
* Imported Translations from Zanata
* Modify VO so that obj.get always defaults to None
* Replace use of mox with mock in test\_quotas
* Replace use of mox with mock in test\_rbd
* Skip check whether volume is local if it's None
* Imported Translations from Zanata
* Implement refresh() for cinder objects
* EMC VMAX - get\_short\_host\_name not called in find\_device\_number
* Move retype quota checks to API
* Implement snapshots-related features for Block Device Driver
* Refactor cinder.utils.is\_valid\_boolstr
* Add synchronization in Block Device driver
* Recalculate allocated value of parent project
* Updated from global requirements
* Volume migration: add 'name\_id' as valid skippable field
* Fix invalid cache image-volume creation
* Imported Translations from Zanata
* Remove eventlet WSGI functionality
* Deprecated tox -downloadcache option removed
* Fix for showing default quotas to non-admin user
* VNX: Fix failure in SnapCopy feature
* Use wild card for passing env variable
* Recognize extra fields in CinderObjectDictCompat
* Imported Translations from Zanata
* VNX: Fix issue in deleting cg/cgsnapshot
* Add validation for volume\_type of volume object
* Update Pure REST API supported version numbers in Pure driver
* Updated from global requirements
* Retype functionality in Tintri driver
* Fix non-migration swap with error
* Replace use of mox with mock in test\_solidfire
* Check context before returning cached value
* 3PAR: Implement v2 replication (managed)
* Use Cinder API v2 for Rally scenarios
* Check backup service before backup delete
* Python 3: fix a lot of tests
* EMC VMAX - Fix for randomly selecting a portgroup
* Volume driver for Coho Data storage solutions
* XtremIO: fix iscsi chap discovery bug
* XtremIO: fix missing multiattach flag
* Fix StrOpts with integer defaults
* Dynamically Pull Out Option Sections
* Use the catalog to retrieve glance\_api\_servers
* Address potential races in SolidFire VAG
* Update migrate\_volume API to use versionedobjects
* Storwize: add config option to control flash copy rate
* Remove version per M-1 release instructions
* Use proper config option to connect to keystone
* Robustify writing iscsi target persistence file

8.0.0.0b1
---------

* Adding devref about genconfig
* LIO: Handle initiator IQNs as case insensitive
* Fix dictionary key error
* VMware: Replace mox with mock
* VMware: Unit test refactoring (image to vol - 2/2)
* VMware: Unit test refactoring (image to vol - 1/2)
* Imported Translations from Zanata
* Remove deprecated LVM ISCSI and ISER Drivers
* Delete unused codes in rbd.retype
* NetApp: E-Series fix JSONDecodeError on first add
* Add Mitaka-1 release notes
* NetApp: Refactor E-Series tests
* xio: fix regression in authentication
* Add some missing fields to Volume object
* Imported Translations from Zanata
* Add retype in lvm driver
* Updated violin driver check for volume objects
* Take into consideration races in XtremIOClient3
* Optimize "open" method with context manager
* Updated from global requirements
* Sheepdog: Optimization of error handling
* Fix the bug of can't get the desired image info
* Cleanup orphaned code in sqlalchemy API
* Cleanup orphaned code from image and manager
* Cleanup orphaned code from brick LVM
* Cleanup orphaned code from ceph backup driver
* Force releasenotes warnings to be treated as errors
* Remove db access in VNX driver
* Fix quotas issue during volume transfer
* Declare multiattach is True in Dell Eqlx driver
* Nexenta Edge iSCSI backend driver
* RBD: Make snapshot\_delete more robust
* Hacking Checks for assertTrue/IsNone()
* Remove netaddr useless requirement
* Improve metadata update operations
* Add atomic conditional updates to objects
* Revert "Add Scality SRB driver"
* VMware: Validate extra spec opt vmware:clone\_type
* Update list\_replication\_targets
* Port zonemanager to Python 3
* Port key manager to Python 3
* Move oslo-incubator's scheduler module to cinder
* Remove stubs and add resource cleanup
* VMware: Skip unsupported datastore types
* Port IBM storewize\_svc driver to Python 3
* Declare multiattach is True in RBD driver
* XtremIO fix attach readonly bug
* CG API should return volume type IDs
* EMC VMAX - Change naming convention for MV and SG for FAST
* Fix the bug of OSError when convert image
* Don't build two tox envs for pep8(-constraints)
* Add guidelines for release notes to devref
* Imported Translations from Zanata
* Imported Translations from Zanata
* Updated from global requirements
* Eager load columns in volume\_get\_active\_by\_window
* Backup snapshots
* LeftHand: Remove self.db assignment
* Deprecate \*\_multipath\_enabled flag for IBM drivers
* Fix debug output for cinder-volume-usage-audit
* Add check\_uptodate.sh --checkopts to "pep8"
* Move get\_by\_id to CinderObject
* Imported Translations from Zanata
* fast8: Skip git rm'd files
* Manage existing: fix volume object saving
* Fix swap\_volume for case without migration
* Remove .mailmap file
* Remove db access from 3PAR and LH cg functions
* Additional VAG support for SolidFire
* Fix InstanceLocalityFilter scheduler filter
* Add a FakeGateDriver
* Fix metadata retrieval in GPFS driver
* Imported Translations from Zanata
* VNX: Fix metadata get overriden issue
* Added VAG support to SolidFire
* Refactor HP LeftHand driver to now be HPE
* Remove db access from XIV/DS8K CG functions
* Do not use api-paste.ini osprofiler options
* Remove duplicate keys from dictionary
* Bad exception clauses order
* Imported Translations from Zanata
* Check specific driver enabled in create\_backup
* get\_all\_snapshots: Fix log message typo
* Updated from global requirements
* ScaleIO extend volume round up capacity
* Port HP 3PAR driver to Python 3
* Modify test\_hpe3par to support random hash
* Imported Translations from Zanata
* Fix ScaleIO driver provisioning key
* Imported Translations from Zanata
* Remove the HP CLIQ proxy driver
* Retry on database deadlock on service\_update method
* Downstream Fix for Genconfig
* Correct assertDictMatch argument order
* 3PAR Fix find\_existing\_vluns
* Port xio driver to Python 3
* Remove kombu as a dependency for Cinder
* Port EMC VMAX to Python 3
* Port EMC VNX CLI to Python 3
* Sheepdog: Fix a problem about multi backend
* Imported Translations from Zanata
* Update compression license check
* py3: Fix error handling in prophetstor driver
* Updated from global requirements
* Refactor HP 3PAR drivers to now be HPE
* add "unreleased" release notes page
* Add os-win to requirements.txt
* Update extend\_volume API to use versionedobjects
* Update retype API to use versionedobjects
* Update get/delete\_volume API to use versionedobjects
* Update create\_volume API to use versionedobjects
* Test for object version hash changes
* Fix cinder objects unit test registration
* CG driver function should not access db
* Add test for snapshot filtering by project id
* Imported Translations from Zanata
* Use oslo\_config new type PortOpt for port options
* Update CONTRIBUTING.md to CONTRIBUTING.rst
* CG creation should be scheduled on backend level
* Removal of deprecated NPIV option in Storwize
* Fix ZFSSA drivers' local cache bugs
* OpenStack typo
* Change nfs to NFS in the help strings of nfs.py
* Port zfssa driver to Python 3
* Port vzstorage to Python 3
* Port cinder.utils.monkey\_patch() to Python 3
* XtremIO fix create CG from src flow
* Don't use default=None for config options
* Imported Translations from Zanata
* 3PAR drivers volume size conversion is incorrect
* Port vmware datastore to Python 3
* Use Service object instead of DB API directly
* Docstring fix in scheduler-stats
* Add LC\_ALL=C to lvcreate, lvextend and pvresize
* Port cinder.hacking to Python 3
* Port test\_tintri to Python 3
* Add reno for release notes management
* Imported Translations from Zanata
* Fix failure of unit test TestCinderAllCmd
* Execute mount.nfs check with absolute path
* Imported Translations from Zanata
* Update minimum tox version to 1.8
* Update cinder-manage man to match current options
* Replace warnings.warn in sqlalchemy-api
* Replace warnings.warn in glusterfs
* Using extra-specs in cloned vols for Nimble driver
* SheepdogDriver: Improve get\_volume\_stats operation
* Add retype logic in manage\_existing for VNX
* Adds CORS support to Cinder
* Fix calling delete\_zones method with a wrong argument
* Return volume\_type extra specs based on policy
* Revert "Handle correct exception raised by python-novaclient"
* NetApp: Fix issue with updating E-Series password
* NetApp: Fix issue with E-Series volume expand
* Update register\_opts hacking check to allow tuples
* Updated from global requirements
* optimize the copy\_image\_to\_volume method of sheepdogdriver
* Fix UsedLimitsController's authorizer to soft
* Imported Translations from Zanata
* Handle correct exception raised by python-novaclient
* lvconvert missing from cinder volume.filters
* Support insecure NAS security options in Quobyte
* Brocade driver add\_zone optimization
* Imported Translations from Zanata
* Add missing cgsnapshot field to Snapshot object
* Eager load snapshot\_metadata in \*snapshot\_get\_all
* Case sensitivity problem in cinder scheduler
* Add protocol to help of glance\_api\_servers option
* SMBFS: Fix retrieving total allocated size
* Make relationships in objects consistent
* Imported Translations from Zanata
* Remove the jointly loaded model in finish\_volume\_migration
* Update docs to generate Guru Meditation Report
* Add qos\_specs\_id to volume type show
* Fix NoneType Attribute error
* Support initialization state in Backup Manager
* Imported Translations from Zanata
* Add -constraints for CI jobs
* Fix typos about 'target\_discovered'
* NetApp: Cleanup if E-Series volume create fails
* VMware: Unit test refactoring
* Cleanup for cinder tests with CGSnapshot
* Imported Translations from Zanata
* VMware: Enforce min vCenter version
* Add hypermetro support for Huawei driver
* Updated from global requirements
* devref doc: assorted fixes in "Unit Tests"
* LIO: Let delete\_initiator succeed if iqn not found
* CGSnapshot Object
* Updates in consistency\_group in xiv/ds8k driver
* Retype support for CloudByte iSCSI cinder driver
* Add retries for Cisco FCZM client CLI \_cfg\_save
* Updated from global requirements
* Remove unused gettextutils from oslo-incubator
* Wrong usage of "an" in the mesages:
* NetApp: E-Series fix deletion of missing volume
* Wrong usage of "an" in the mesages: an service
* VMware: Relocate volume only during no disk space
* Port Windows drivers to Python 3
* Use project id from volume when retyping volumes
* Fix typo in LIO terminate\_connection error msg
* Update the devref for volume migration
* Implement update\_migrated\_volume for NFS driver
* Only use LOG.exception in exception handler
* Port API admin action tests to Python 3
* Port API types extra specs to Python 3
* Port API to Python 3
* Mark XML API as deprecated in Mitaka
* windows: don't use LOG.exception if not logging an exception
* Improve performance listing detail for volumes
* Move CloneableVD to common functions
* Fix updating only volume type is\_public
* encryption\_api\_url requires a version
* Cleanup/move code in Storwize Driver
* Port WSGI tests to Python 3
* Fix method VolumeTypeList.get\_all
* Use lvm\_conf\_file directory for LVM\_SYSTEM\_DIR value

7.0.0
-----

* Squashed commit of WebOb 1.5 and oslo.db fixes
* Change default Exception code to 500
* Dell SC: Disable REST verify warnings
* Update config format for replication\_devices
* Fix log formatting for rbd driver
* Fix Status-Line in HTTP response
* Huawei driver handle volume exists error
* Updated from global requirements
* Tox fast8: use pep8 env dir
* Move ssh\_utils tests to test\_ssh\_utils
* Volume extend error does not catch exception
* Fix test\_misc for WebOb 1.5
* ScaleIO driver: update\_migrated\_volume
* Fix error string format for replication API calls
* Port IBM flashsystem to Python 3
* Port ceph driver to Python 3
* Provide better debug log when 'cinder manage' fails
* Remove references to Swift in chunked driver
* Add insecure option for swift backup
* ScaleIO: Fix protection\_domain\_id log message at init
* Port test\_srb to Python 3
* Add fast format option for thick volume creation
* Imported Translations from Zanata
* Retype enhancement for EMC VNX cinder driver
* Updated from global requirements
* Verify volume is replication capable
* Add device identifier to replication device
* Port violin driver to Python 3
* Port EMC scaleio to Python 3
* Remove extra register\_opts() calls in netapp eseries
* Add multi-initiator extra-spec for Nimble driver
* Fix SolidFire target composition
* Port targets test\_iet\_driver to Python 3
* Port image cache to Python 3
* py3: Run unit tests with ostestr on Python 3.4
* Add testresources and testscenarios used by oslo.db fixture
* Clone cg support in VNX driver
* Test\_backup\_swift: Don't leak notifications
* test\_backup\_nfs: Set volume id per test
* test\_backup\_swift: Set volume id per test
* Add backup\_swift\_auth\_url to swift backup driver
* Dell Eqlx: Support over subscription in thin provisioning
* Hacking check for opt name registration
* Add ability to set prefix in SolidFire Volume name
* Updated from global requirements
* Fix broken format string in vol mgr log
* Detach volume on device validation failure
* Convert  Retry-After header parameter value to string
* Fix capacity report error in Huawei driver
* emc vmax driver: use integer division for Python 3
* VMAX Target iSCSI IP Address
* Updated from global requirements
* Delete a temporary volume in DB with admin context
* Fix update quota of subprojects
* Port test\_quobyte to Python 3
* Remove unused 'deprecated' option from auth\_strategy opt

7.0.0.0rc2
----------

* Fix VMAX live migration problem
* Imported Translations from Zanata
* Port netapp SSC Cmode to Python 3
* Port test\_netapp to Python 3
* VMAX Truncate Storage Group Name
* HNAS iSCSI manage does not work with spaces
* Port scheduler host manager to Python 3
* Fix various Python 3 issues
* Fix volume throttling to Python 3
* Ensure replication functions check driver status
* Fix enable/disable\_replication raise InvalidVolume
* Tests: print fake\_notifier queue upon mismatch
* Cleanup orphaned code from cinder root directory
* Image cache tests: use fake\_notifier
* Implement extend\_volume method to Block Device driver
* Small optimization in Block Device driver
* DRBD: new option "drbdmanage\_devs\_on\_controller"
* Obtain target authentication from database same as LIO target
* Dell SC: cgsnapshot-delete doesn't actually delete
* LVM: Make sparse\_copy\_volume private, use for capabilities
* Dell SC: cgsnapshot-delete doesn't actually delete
* Fix typo in cinder-config-generator.conf
* Port test\_volume to Python 3
* Fix unreachable code pylint issues
* Huawei driver add check before use a QoS
* Report \*real\* free capacity in Huawei driver
* Fix update Huawei driver issue
* Fix Python 3 issues in wsgi
* py3: Port pure driver test to Python 3
* GlusterFS: extend volume to the right path
* Use pbr wsgi\_scripts to install Cinder WSGI entry point
* Report \*real\* free capacity in Huawei driver
* Imported Translations from Zanata
* Fix Bad indentation pylint issues
* Show image metadata
* XtremIO fix remapping bug
* Revert use of netapp\_lib from NetApp Drivers
* Fix volume related operation in CloudByte driver
* Add placholder for migration backports in Liberty
* Add placholder for migration backports in Liberty
* Revert use of netapp\_lib from NetApp Drivers
* Remove the destination volume check in delete\_volume
* Huawei driver add check before use a QoS
* Fix VMAX live migration problem
* Cleanup of Translations
* Missing configuration opts from cinder.sample.conf
* Use function capsulation in Huawei driver

7.0.0.0rc1
----------

* Open Mitaka development
* Create volume in cg enhancement in VNX driver
* Remove duplicate keys from dictionary
* Fix URL format in Huawei driver
* Setup LVM\_SYSTEM\_DIR earlier in LVM.\_\_init()
* Add "fast8" tox env
* Allow c-vol backends to start when some backends fail to load
* Fix use of wrong storage pools for NetApp Drivers
* VMware: Remove VMDK driver for ESX server
* Use of ast for integers doesn't changes type
* Make rpc\_client method private for VolumeCommands
* Ignore Forbidden error on quotas-get for nested projects
* Change ignore-errors to ignore\_errors
* NetApp volume/snapshot delete performance fix
* Replace soft\_delete in volume\_type\_access\_remove
* Fix way of getting LUN id in Huawei driver
* Fixing create CG from Cgsnapshot bug in VNX driver
* Fix delete quota of subprojects
* Dynamically create cinder.conf.sample
* Updated from global requirements
* Fix MITM vulnerability for Brocade FC SAN lookup
* Imported Translations from Zanata
* Fix cinder-all binary
* NetApp: Fix volume extend with E-Series
* Fix netapp\_enable\_multiattach default for E-Series
* Check for None on service's updated\_at
* Fix issue of volume after host-assisted migration
* Attaching enhancement for EMC VNX driver
* Tests: Split VolumeTestCase into separate classes
* Local img-cache files ignored for image transfers
* Snapmirror targets should not be reported as pools
* Change check method for 'all\_tenants'
* Create a page of drivers with stevedore.sphinxext
* Enable certificate verification during image copy
* Fix NetApp clone from glance failure
* Storwize: Fix format string
* Fix usage of novaclient
* Check for empty attributes on SF volume
* Fix volume lookups in SolidFire template caching
* Don't rely on provider\_id for resource deletion
* Fix Pure get pgroup volume snapshot name
* Dothill fix options access
* HPMSA fix access to common options
* Lenovo driver fix access to common opts
* Fixed missing log variable types
* VMware: Fix invalid product name
* Retrieve volume in update\_migrated\_volume
* Swap the decorator order for PureFCDriver methods
* Add ScaleIO Cinder driver commands
* SolidFire provider\_id for snapshots on init
* LeftHand Add update\_migrated\_volume to drivers
* Huawei: fix multi REST-URLs bug
* Improve coverage for snapshot\_get\_by\_host
* LVM: add the exception handling to volume copy
* Fix NetApp loop in clone of NFS backed images
* Hacking log format arg check
* backup init\_host cleanup exception handling
* Making opt names consistent
* Fix QoS keys not being available to scheduler
* Add ConsistencyGroup object entries to linstack.py
* Pass in snapshot refs for host on provider\_update
* Filter hosts with pool in snapshot\_get\_by\_host
* Fix typos in comments
* Filter scheduler: Fix KeyError on invalid create request
* Updated from global requirements
* Return a tuple from SolidFire update\_provider\_info
* Add unmanage default implementation to VolumeDriver
* Correctly report multiattach in Pure drivers
* Add manage\_existing and unmanage to BaseVD
* Add migrate\_volume to BaseVD
* Update update\_migrated\_volume in VNX driver
* 3PAR Disable generic image volume cache
* Add updated\_at into response of listing detail
* Add os-brick's scsi\_id command to Cinder rootwrap
* Fix order of arguments in assertEqual
* Updated from global requirements
* Error message in update\_migrated\_volume was incorrect
* Remove empty rules from policies for API access
* Fix HDS HNAS driver logging password as plain text
* Add mechanism to update snapshot provider\_id
* VMware: Remove global patching of open
* VMware: Skip ESX hosts in maintenance mode
* 3PAR Add update\_migrated\_volume to drivers
* Updated from global requirements
* Switch SVC driver to use lsportfc to determine FC target WWPNS
* Use consolidated update for failover\_replication
* VMware: Fix exception messages
* Adds allow\_availability\_zone\_fallback option to Cinder
* NetApp E-Series over-subscription support
* ZFSSA driver to return project 'available' space

7.0.0.0b3
---------

* Get full volume model in Replication manager API’s
* Fix problem of efficient volume copy for migration
* Generic image-volume cache
* Implement thin provisioning support for E-Series
* Remove useless response checks in SolidFire driver
* Sheepdog: Improve snapshot and clone operation
* Fix the virtual port support in VNX driver
* DotHill driver fix create\_cloned\_volume parent id
* 3PAR Fix create\_cloned\_volume source volume id
* Cloudbyte fix create\_cloned\_volume parent id
* Scheduler-based over-subscription for NFS drivers
* ScaleIO driver should use os-brick connector
* Add instructions on how to deploy API under Apache
* Sync volume versionedobject to ORM
* Check before add lun to QoS in Huawei driver
* Fix backup metadata import missing fields
* Remove the unnecassary volume\_api.get(context, volume\_id)
* Port image\_utils to Python 3
* Port volume transfer to Python 3
* Service object
* Allow specified backend capabilities to be retrieved
* Remove deprecated options
* Add cinder.conf.sample to gitignore
* Add delete\_snapshot and update\_snapshot rules
* Handle KeyManager exception when deleting a volume
* Fix a merge problem in VMAX driver
* Don't require OpenSSL for unit tests
* Add pagination to backups
* Enhance FC zone support for Huawei driver
* Add support for file I/O volume migration
* Add debug logging before attaching volume in driver
* Detect addition of executable files
* Remove executable bits on files
* NetApp DOT block driver over-subscription support
* Cleanup for SnapshotObject
* Add additional SSC extra specs to E-Series driver
* Minor optimization
* Adding delete-wait-loop for CloudByte Volumes
* get\_replication\_updates call to driver is wrong
* Earlier authority check for create volume API
* Fix url in API response to get original
* Efficient volume copy for generic volume migration
* Volume status management during migration
* Clean up line continuation in Storwize driver
* LeftHand: Adding Consistency Group Support
* 3PAR update driver to store stats
* Remove driver.set\_execute()
* Skip intermittent VMDK tests
* Rework Scality SOFS driver to use RemoteFS class
* Adds framework for get\_capabilities() feature
* Implement AutoSupport for NetApp E-Series driver
* Add retries to delete a volume in the RBD driver
* Add support for volume groups and netapp\_raid\_type
* Dell SC: init\_volume stale volume info fix
* Validate filters in snapshot\*, backup\* in db.api
* Fix volume copy for 'virtual' volumes in DotHill
* Imported Translations from Transifex
* Use version convert methods from oslo.utils
* Implement manage/unmanage snapshot in Pure drivers
* Reduce runtime of E-Series iSCSI tests
* Cinder Nested Quota Driver
* Add manage/unmanage volume support for Nimble
* Python 3 incompatible expression fix
* Local cache feature of Oracle ZFSSA drivers
* Replace urllib.unquote with urllib.parse.unquote
* Remove unused dependency discover
* Update volume status AFTER terminate\_connection is done
* Add unit test for backup get\_all
* Incremental backup improvements for L
* Sheepdog: improve create and delete operation
* Implement function to manage/unmanage snapshots
* Sheepdog: Add class for dog command executor
* Dont eager load volume type specs on volume list
* Filter out extra-specs from type get for non-admin
* Prevent that all backup objects are deleted
* Add pagination to snapshots
* Parameter osapi\_max\_limit is always used by default
* Update NetApp Drivers to use netapp\_lib
* Extend unit tests for backup get\_all
* Fix nimble storage volume stats reporting
* TemporaryImages to inspect image before conversion
* Efficient image transfer for Glance cinder store
* adds user\_id to check\_is\_admin
* Fix backup list all\_tenants=0 filtering for admin
* Add Cinder API wsgi application
* Add consistency group tests to test\_volume\_rpcapi
* Cinder replication V2
* force\_detach terminate\_connection needs connector
* Assisted volume migration for Oracle ZFSSA drivers
* Add https options and minor code changes
* Fix bad except clauses order
* Add volume retype support for Huawei driver
* Fix URLs to admin-guide-cloud
* Nested Quota Driver: Get Project Hierarchy
* Check sio\_storage\_pools in check\_for\_setup\_error
* Fix description for "Barbarism of editting a file"
* Dell SC: Added logging for the find\_wwns functions
* Add missing space to logged error in create volume
* Cleaning up CONF.register\_opts() in compute/\_\_init\_\_.py
* Update provider\_id column on SolidFire init
* Add ability to update provider\_id during init
* Fix \_LI() to \_LW() in LOG.warning message
* Remove the method delete\_volume\_admin\_metadata
* Support efficient non-disruptive volume backup in VNX
* Validate value when user update quota
* Add SolidFire svip to config options
* Return multiple iSCSI portals in VNX Cinder driver
* Avoid returning volume metadata in DotHill driver
* Small cleanups in BaseVD/VolumeDriver
* Port 3PAR drivers to use ABCMeta driver model
* Updated from global requirements
* Switch to the oslo\_utils.fileutils
* Parse out SolidFire account from api response
* Dell SC: Better exception handling in init\_conn
* Port test\_nfs to Python 3
* Corrects the order of AssertEquals params in Quobyte tests
* Adds the random option to cinder retry function
* Extra specs may not be in volume types
* VMware: Fix re-attach volume error for VC 5.1
* Remove duplicate keys from dictionary
* LeftHand driver is ignoring reserved\_percentage
* Update devref unit tests doc
* Tests: Fix zfssa TestRestClientURL.test\_request
* Test whether sample config generation works
* Revert "mark oslo.vmware as optional dependency"
* Register the volume\_opts config options in remotefs.py
* Create CG needs extra specs
* Configure space reservation on NetApp Data ONTAP
* Dell SC: Fix error causing missed log message
* Rename free\_virtual in capacity filter
* Make migration's volume source deletion async
* Add the ability to update type public status
* Adds manage/unmanage methods for HNAS drivers
* Update deprecated version of novaclient
* Add version columns to services table
* 3PAR: Adding Consistency Group Support
* Remove unused function volume\_type\_encryption\_get
* Refactor to remove duplicate code
* Correct comment to be consistent with code
* Allow 0 length name
* Add volume migration support for Huawei driver
* Cleanup for cinder tests with ConsistencyGroups
* VMware: Change inventory folder hierarchy
* Adapt SnapshotController to view builder
* Add backup/restore methods to Sheepdog driver
* Use min and max on IntOpt option types
* Over subscription for HP 3PAR drivers
* Allow CG without snapshot to be deleted
* Tintri snapshot id
* Add volume type support to Datera
* Fix Pure create volume from cgsnapshot
* Implement Clone CG in Pure Volume Drivers
* Dell Eqlx: Use generic option ssh\_timeout
* Make X-IO volume driver wait for delete volume to complete
* Reduced file size to prevent timeout
* Update SolidFire driver to pass newer flake8
* 3PAR: Adding performance metrics to volume status
* Don't use context.elevated to get volume
* Enable cinder-manage to remove services
* VMware: Bump driver version
* Fix backup init\_host volume cleanup
* VMware: Deprecate vCenter version less than 5.1
* Updated from global requirements
* Small clean up in volume object
* Move import and export backup metadata to object
* On Volume list only retrieve needed data from DB
* Return volume name from backup\_restore
* Switch Pure volume drivers to use Snapshot Objects
* Don't return Exception when volume is detached
* Use Requests HTTP library and URL safe names
* Remove RetypeVD class, fix NFS driver retype
* Fix Python 3 issues in Windows tests
* Add objects.register\_all() to cinder-all command
* GPFS volume encryption-at-rest support
* VMware: Set virtual disk UUID to volume ID
* Add oslo.vmware into test-requirements
* Add multipath support to 3PAR iSCSI driver
* Prevent volume already in CG to be added to another
* LVM Thin Provisioning auto-detect
* Fix HNAS iSCSI 32 targets limitation error
* Remove unused fake objects in vmdk test module
* VMware: Add volume ID in vCenter's volume config
* Enhance PureISCSIDriver multipath support
* Add unit test cases for the capacity scheduler
* Fix argument order for assertEqual in tests
* Fix order of parms in assertEqual for scheduler ut
* VNX driver needs extra params for create cg from src
* Prevent creating encrypted volume with image
* EMC VMAX Create CG from CG Snapshot
* mark oslo.vmware as optional dependency
* ConsistencyGroup Object
* Validate string, integer limit for input parameter
* Validate name and description string
* Handle missing temp volume and snapshot during cleanup
* Updated from global requirements
* Validate 'is\_public' when creating volume type
* Remove StorPool Driver
* Ignore InsecureReq warning in SolidFire Driver
* Attach snapshot - driver only
* Remove bad tests for the VMAX driver
* Update authorization actions for services API
* Fix missing parameters in driver CG interface
* Remove incorrect URLs from jenkins.rst
* Fix list comparison for empty list
* Snap copy feature for EMC VNX Cinder driver
* Tests: Fix os.path.exists mock (emc\_vnxdirect)
* Add connector object to create\_export
* Correct usage of assertEqual for boolean values
* Remove unit test migration logging
* Add support '--all-tenants' for cinder backup-list
* Corrected order of parameters in docstring
* Fix wrong exception usage in cinder exception classes
* Fix RestURL to storage backend in Huawei driver
* Sync scheduler module from oslo-incubator
* VNX driver needs to return snapshot objects
* Revert "Revert First version of Cinder driver for Quobyte"
* Enhance unit tests for zfssa drivers
* VMware: Remove unused constants
* Fix volume limit exceeded exception
* Refactor api.v2.volumes unit tests
* Dell SC: Add check of current value on retype
* Update snap-quota to unlimited in Nimble driver
* Add more Rally scenarios to run
* Updated from global requirements
* Fix PEP476 & format message of Oracle ZFSSA drivers
* Add SmartX support for Huawei driver
* Enhance deletion efficiency when backup init host
* Fix order of arguments in assertEqual
* Add multiple pools support to VMAX driver
* Fix status comparison for attached volume backup
* Updated from global requirements
* NetApp SSC job will be run periodically
* RBD: use user-configured value for chunk size
* Over subscription for HP LeftHand iSCSI driver
* Use prefix for SolidFire template account
* Fix multi-line docstrings to meet hacking rules
* sqlalchemy exception kills FixedIntervalLoopingCall thread
* VMware: Fix protocol in backend stats
* Fix error message in cinder/api/v2/volumes.py
* Fix concurrent attaches on HNAS iSCSI driver
* GlusterFS: Using 'fallocate' instead of 'dd'
* Fixing notify message of manage\_existing flow
* Clone CG
* Fix get default quota values for subprojects
* Add deactivate step to extend\_lv
* Fix exception on uploading a volume to image with glance v2 API
* Set VERSION on the Nimble driver

7.0.0.0b2
---------

* Log which service is down
* Move update\_migrated\_volume() to BaseVD
* GlusterFS backup driver
* Posix backup driver
* Add mock cases for IBM FlashSystem
* Add discard to connection properties
* Remove deprecated config options for Liberty
* RBD: use user-configured value for max\_clone\_depth
* Updated from global requirements
* Fix lvm manage existing volume
* Add entry create and cast tasks to manage workflow
* Fix cleanup\_temp\_volume\_snapshots for missing vol
* Remove unused context parameter
* Adding NFS support to the GPFS Driver
* Remove deprecated SimpleScheduler
* Fix doc string definitions
* Port StorwizeSVCDriver to use ABCMeta driver model
* Add extra spec capability for Nimble Cinder Driver
* XtremIO support for iscsi discovery auth
* Add bandit for security static analysis testing
* typos(?) in create\_snapshots\_in\_db
* Add multiple pools support for Huawei driver
* Port XIVDS8K Driver to use ABCMeta driver model
* Fix Python 3 issues in Hitachi HNAS tests
* Port remotefs driver to Python 3
* Port IBM driver to Python 3
* Clean up volume\_types logging
* NetApp ESeries: fix delete of non-existent volume
* Refactoring of manager's create\_volume flow
* Remove unused arguments from c-vol's create\_volume
* Updated from global requirements
* Add I/T mapping check for IBM FlashSystem
* Remove simple scheduler which is deprecated since Juno
* LVM: Support efficient data copy for LVM driver
* Implement retype for Pure drivers
* Dell SC: Add support for driver retype
* EMC VMAX Modify CG
* XtremIO volume driver consistency group support
* Add Cinder internal tenant support
* VMware:Replace vCenter calls with oslo.vmware calls
* Rename filename from il8n.rst to i18n.rst
* Non-disruptive backup
* DRBD: Rename a constant to a better name
* Remove resource lock operation for HBSD
* Dell SC: Fix legacy bug, init\_conn bug and REST API bug
* Dell SC: Fix Consistency Group issues
* Add drivers list generator
* Fix 033 add encryption unique key migration
* Add CHAP support for Huawei driver
* Move volume.api test to correct location
* Remove logging statements from migrations
* DRBD: Define a separate prefix for snapshots
* Prevent missing Purity hosts from raising errors
* Revert "Remove X-IO volume driver"
* Filter cgsnapshots data on the DB side
* Refactor Huawei Volume driver
* Add volume\_attachment to volume usage notifications
* Graceful shutdown WSGI/RPC server
* Backups: allow name to be specified during restore
* Set default policy for "volume:get"
* Add iSCSI multipath support for Huawei driver
* Fix 3PAR driver handling of existing VLUNs
* Don’t log warnings in Pure initialize\_connection
* scality: add export and name keys to os-initialize\_connection info
* Add delete/update\_volume\_metadata policy rules
* Remove "volume:services" rule from policy.json
* Report capability of multiattach for FlashSystem
* Handle volume not found on zfssa volume delete
* Raise BadRequest for invalid replication status
* Add unit tests for cinder.api.v2.volumes
* Raise HTTP exception for backup not found
* Port NetApp NFS drivers to use ABC driver model
* Removing OpenvStorage for no CI
* Remove unused serialize\_args method
* Remove obsolete API from documentation
* Tests: test\_volume mock conversion
* Fix restore point if backup base is diff-format in ceph
* Add white list support for target ports in VNX driver
* Preserve mock side\_effect’s in test\_pure
* StorPool: clean up the last uses of str.format()
* Removing archaic references
* Remove useless logging from unit tests
* cinder list fails with 'name' sort key
* Storwize\_svc\_npiv\_compatibility\_mode default value change
* Remove unused parameter in PureFCDriver \_connect
* Cleanup unused method fake\_get\_target
* Set driver version in Sheepdog driver
* Updated from global requirements
* Fix saving tz aware datetimes in Versioned Objects
* set/unset volume image metadata
* Fix not implemented wording in update\_migrated\_volume
* Add support for force-delete backups
* Improve 3PAR driver VLUN creation and deletion
* Remove hacking check N327
* Fix tests failing in gate
* Fix properties extracting from image with glance api v2
* Support SMI-S provider v8.0.3 in VMAX driver
* Add ability to override OpenStack privileged user auth url
* VMEM v6000: Fix export verify routines
* Port Tintri driver to ABC driver model
* Fix block\_device driver to behave as documented
* NetApp E-Series: Add debug tracing
* Set encrypted key in connection\_info during initialize
* Nested Quota: Set default values to subproject
* Dell SC: Add support for ManageableVD
* Fix NetApp cDOT driver use of Glance locations
* Fix missing pool name in consistency group
* NetApp ONTAP: Add debug tracing
* Add tracing facility for drivers
* Fix error message in Pure driver with correct text
* Notify the transfer volume action in cinder
* Storwize Driver zone removing
* Dell SC: Add support for consistency groups
* Remove duplicate volume.filters entry
* Port NetApp E-Series iSCSI driver to ABC model
* Fix getting out-of-date volume operation state issue for VNX
* Separate FlashSystem FC and iSCSI common code
* Update expected error message from lvs
* Fix HBSD horcm driver with oslo.concurrency 2.1.0
* Remove X-IO volume driver
* RemoteFS: Fix the offline snapshot delete operation
* Implement the update\_migrated\_volume for the drivers
* Avoid race condition at snapshot deletion stage
* Fix Python 3 issues in cmd
* Port image/glance.py to Python 3
* Switch to oslo.reports
* Validate maximum limit for quota
* Updated from global requirements
* Fix block eventlet threads on rbd calls
* RemoteFS: Reporting configured reserved\_percentage in \_update\_volume\_stats
* GlusterFS: support extending a volume that has snapshots
* Port dothill to Python 3
* Fix backup.rpcapi to pass object backup
* Fix typo in solidfire driver option
* Mock socket.gethostbyaddr in test\_v7000\_fcp
* Replace missed basestring by six for python3 compatability
* Return 404 if volume type encryption is not found
* Updated from global requirements
* smbfs: fix invalid check for smbfs\_used\_ratio correctness
* Remove lio\_initiator\_iqns config option
* Move HDS drivers to Hitachi folder
* Fix Python 3 issues in targets unit tests
* Port drbdmanagedrv driver to Python 3
* Port test\_db\_api to Python 3
* Port hitachi driver to Python 3
* Fix getting wwpn information in infortrend driver for DS4000
* Do not allow to modify access for public volume type
* Add dependency check in RBD delete\_snapshot
* Port huawei driver to Python 3
* XtremIO driver fix array snapshot problem
* Fix cinder.conf.sample generation
* Handle attachment of second volume
* VMware: Create volume backing in specific clusters
* Use versionutils from oslo.log
* Correct overquota error message
* Updated from global requirements
* Fix timeout issue in EMC VNX driver unit test
* Remove oslo logging from backup unit tests
* Add notifications about snapshot.update.\*
* Sync the latest fileutils module from oslo-incubator
* Port NetApp DATAONTAP blocks drivers to ABC model
* Fix 'no actual-pathname' NetApp API error
* Use right oslo.service entry points
* Use symbol for error code in VNX cinder driver
* Storwize driver report capability for multiattach
* Filter snapshots data on the DB side
* Change generic NotFound to specific exception
* Storwize: add the missing stops in the end of the messages
* Ensure 'WSGIService' derives from oslo\_service base class
* Switch to oslo.service
* Fix library includes for config generator
* Revert First version of Cinder driver for Quobyte
* Fix cinder-manage volume delete cmd
* Fix Python 3 issues in the blockbridge driver
* Fix Python 3 issues in the swift backup driver
* Fix Python 3 issues in ceph and rbd drivers
* Fix Python 3 issues in backup
* Remove generate\_glance\_url
* Fix manage\_existing function in infortrend driver
* Add unit tests for the capacity filter
* Modify template account creation in SolidFire drvr
* Tests: Fix assertRaisesRegexp deprecation warnings

7.0.0.0b1
---------

* Harden scheduler.rpcapi unit tests
* Fix backups.rpcapi to pass objects over RPC
* Fix weird change of volume status in re-scheduling
* Fix tox -e py34
* Add exception catch in report\_state for DBError
* Updated from global requirements
* Dell SC: Enable use of Storage Profiles
* Use elevated context for backup destroy
* Fix Cinder Objects unit tests
* rbd: add volume\_id to connection\_info in initialize\_connection
* Fix Datera driver export call
* Add iscsi\_target\_flags configuration option
* Adds the Violin Memory V7000 series FC driver
* Remove the hardcoded concurrency limit for ostestr
* Revert "Disable backup progress notifications for unit tests"
* Nested Quota : Create allocated column in cinder.quotas
* Handle incorrect '--config-dir' param
* Get updated volume status in begin\_detaching
* Tests: Make fake\_notifier per-instance
* Validate outermost request body element name consistently
* Add missing argument to delete\_keys method
* Port LeftHand driver to use ABCMeta driver model
* Add Virtuozzo Storage Volume Driver
* Disable profiler for unit tests
* Use a hard-coded project\_id in racy cinder.tests.unit.test\_volume tests
* Validate bool value using strutils.bool\_from\_string method
* Incorrect exception caught in qos-specs create api
* VMware: Remove unused methods
* Scality SOFS: enhance how the remoteFS mount is detected
* Backup object
* Add missing Jinja2 to requirements.txt
* Storwize: remove the useless method check\_copy\_ok
* Update version for Liberty

7.0.0a0
-------

* ScaleIO: Fix broken format string
* Sync 'report' from oslo-incubator
* Ceph driver support retries on rados\_connect\_timeout
* Dell SC Removed \_find\_domain and associated tests
* LVM add multiattach flag capability
* Add volume drivers for Infortrend Storage
* XtremIO Volume driver requests, multipath
* Updated from global requirements
* Adds FC and ISCSI Cinder drivers for Lenovo Storage Arrays
* Adds FC and ISCSI Cinder drivers for HPMSA Storage Arrays
* Replace basestring with six.string\_types
* Fix broken export commands on block\_device driver
* Switch to oslo.policy 0.3.0
* Add config option to set max\_volume\_size\_limit
* Fix LIO target helper when missing targetcli
* Move DRBD tests into tests/unit
* Volume driver for HP XP storage
* Replace xrange() with six.moves.range()
* Drop L suffix from long integers
* Pass proxy environment variables to tox
* Re-add DRBD driver
* Refactor API create\_volume flow
* Introduce Guru Meditation Reports into Cinder
* Adds FC and ISCSI Cinder drivers for DotHill Storage Arrays
* Get rid of oslo-incubator copy of middleware
* SQL scripts should not manage transactions
* Targets tests: Clean up long lines
* Update 3PAR user config help strings
* Disallow backing files when uploading volumes to image
* Remove WritableLogger wrapper
* Get StringIO from six for Python 3 compatibility
* Fix Python 3 issues in utils
* Update SolidFire to use target driver model
* Wait until service thread is done on service stop
* Add cinder volume driver for Blockbridge EPS
* 3PAR enable multiattach capability reporting
* Replace dit.itervalues() with dict.values()
* Rewrite code merging two dictionaries
* Replace dict(obj.iteritems() with dict(obj)
* Replace dict.iteritems() with dict.items()
* san driver: don't use relative Python import
* Implement Cinder Volume driver for HGST Solutions
* Volume manager should set filter\_function and goodness\_function
* Tintri driver to manage existing backend storage objects
* Replace it.next() with next(it) for py3 compat
* Use six to fix imports on Python 3
* NetApp E-Series: Add Fibre Channel Support
* NetApp E-Series: Refactor class structure for FC
* NetApp E-Series driver: Remove caching logic
* Use six.reraise() for Python 3 compatibility
* Updated from global requirements
* Add secondary account capability to SolidFire
* Replace urllib and urllib2 with six.moves.urllib
* Replace unicode with six.text\_type
* Use correct rtslib namespace for newer versions
* Dispose DB connections between backend proc starts
* EMC ScaleIO Cinder Driver
* RemoteFS: Fix doc for locked\_volume\_id\_operation
* Re-integrate Oracle iSCSI Cinder driver
* Dell SC: Expanded comments and update var names
* Re-add the StorPool distributed storage driver
* Add iSCSI protocol support for IBM FlashSystem
* Fixes 3PAR snapshot failure with optional params
* ConsistencyGroup: Return 400 instead of 500 for invalid body
* Port remote\_fs driver to use new driver model
* Make VNX Cinder Driver aware of VNX Pool Full Threshold
* Add 'source-id' and 'source-name' support in VNX driver
* Revert "Adds drivers for DotHill Storage Arrays."
* Dell SC: Added support for alternate iscsi portals
* Dell: Added verify cert option for REST calls
* Handle ineffective backup compression
* Prophetstor driver needs to return snapshot objects
* Complete switch to snapshot objects
* DriverFilter: don't check volume\_backend\_name
* Add Pure Storage FibreChannel driver
* Fix exception parameter name
* Move Dothill tests out of root test directory
* Fix remaining memory issues with nfs backup unit tests
* Don't send heartbeats if Manager reports a problem
* Changes in rally-jobs/README.rst
* Removed explicit return from \_\_init\_\_ method
* Return provider\_id in SolidFire model update
* Deprecate the HPLeftHandISCSIDriver CLIQ driver
* Allow provisioning to reach max oversubscription
* Port ProphetStor driver to use ABCMeta driver model
* Clean up unused exceptions
* Refactor scheduler's create\_volume flow
* Adds FC and ISCSI Cinder drivers for DotHill Storage Arrays
* Bump SolidFire version number
* Dell SC: update\_volume\_stats could use uninitialized vars
* Disable backup progress notifications for unit tests
* Tintri Cinder Volume driver
* Fix assertRaisesRegexp deprecation warnings in UT
* Refactor PureISCSIDriver into base and iSCSI classes
* Add missing unit test for goodness weigher
* Non-admin user to query volume filter by az
* Fix cinder concurrency issues on rtstool
* Use SolidFire snapshots for Cinder snapshots
* Switch get\_all\_snapshots to use objects
* rbd driver in cinder does not manage glance images multi-location
* Notification with volume and snapshot metadata
* Remove pretty\_tox and use ostestr
* Add volume ID to fake volumes in Gluster tests
* Fix capacity filter to allow oversubscription
* EMC VMAX Manage/Unmanage Volume
* Add chap support to CloudByte cinder driver
* Multiple pools support enhancement in VNX cinder driver
* Remove un-used import at test\_volume\_transfer.py
* NetApp FC driver shims missing manage/unmanage
* Updating cmd/manage.py get\_arg\_string() argument parser and adding unit test
* Fix expression-not-assigned pylint issues
* Add standard QoS spec support to cDOT drivers
* Avoid LUN ID collisions in NetApp iSCSI drivers
* VMware: insecure option should be exposed
* Create iSCSI lio portals with right IPs and port
* Create consistgroup from cgsnapshot support in VNX driver
* Stop using deprecated timeutils.isotime()
* Fix response when querying host detail by host name
* Fix wrong response with version details
* Display NOTIFICATIONS on assert failure
* Brocade driver not parsing zone data correctly
* Fix issues with extra specs in VMAX driver
* Don't use dict.iterkeys()
* Address 0x712d8e0e error in VNX Cinder Driver
* Leverage dict comprehension in PEP-0274
* Add missing '-o' CLI option to VNX Cinder Driver
* Validate name and description for volume type
* Leave sqlalchemy convert to boolean to the DB SQL type to use
* Switch from MySQL-python to PyMySQL
* Add ability for drivers to copy data preserving sparseness
* Remove HDS HUS iSCSI driver
* Updated from global requirements
* Use nfs\_oversub\_ratio when reporting pool capacity
* LVM: Pass volume size in MiB to copy\_volume() during volume migration
* LVM: Support efficient data copy using "dd" for create\_cloned\_volume
* Fix a problem with FAST support in VMAX driver
* Remove use of deprecated LOG.warn
* Fix incorrect reraising of exceptions
* Switch to oslo\_versionedobjects
* Cinder os-force\_detach api returns 500
* Check volume\_backend in retype
* Fix overwrite of params in SF image cache update
* Dell SC driver honoring folder name after volume creation
* Check type match on create from source/snap
* Add patch for consistency group update in ProphetStor driver
* Logging not using oslo.i18n guidelines (openstack)
* Remove unused context parameter
* Replace suds test dependency with suds-jurko
* Fix missing translations for log messages
* Remove Brick from cinder codebase
* Follow i18n guidelines in LIO target
* Windows SMBFS: Fix image resize errors during volume creation
* Windows iSCSI: Add CHAP authentication support
* NFS Backup: Correcting backup\_sha\_block\_size\_bytes help message
* Fix common misspellings
* GlusterFS: Renaming test case to test\_mount\_glusterfs
* Add new exception to retryables in SolidFire driver
* Convert mox to mock: tests/compute/test\_service.py
* FlashSystem reports error while running tests with multi-thread
* Dell: Added support for update\_migrated\_volume
* Fix FakeISCSIDriver and FakeISERDriver
* Add volume status to error messages in backup create flow
* Bad link in API version details response
* Fix xxx=\n pep8 errors in volume\_utils.py
* Log command failure details before raising ISCSITargetDetachFailed
* Eqlx: Fixes the retries on Network Connection Error
* Rename Datera test to test\_datera for discovery
* Allow rexports for targets with Datera
* Add os-brick to cinder requirements.txt
* Fix the KeyError in CloudByte iSCSI cinder driver
* LIO: Enable iSER for IPv6
* LIO: Use rtslib property instead of private method
* Fix missing translations for log messages
* Cinder os-attach api returns 500
* cinder os-detach api returns 500
* HDS HNAS Driver fails when FS unhealthy
* Logging not using oslo.i18n guidelines (zonemgr)
* Fix broken add\_iscsi\_conn log message
* Fix unit tests spam output
* Preserve usage and reservations on quota deletion
* Fix 'driver is uninitialize' typo
* Removing sleep between when a command is sent and 'YES' is sent
* Windows iSCSI: remove ensure\_export
* tests: replace mox by mox3, clean out mox usage
* Catch additional type conversion errors
* Tests: Remove sleep from NFS tests
* Port block\_device driver to use new driver model
* VMware: Enable vCenter certificate verification
* Fix typo in log messages and comments
* Clean up failed clones in VMAX driver
* Correct directories check for N327 hacking check
* Fake out sleeps in unit tests
* Fix range check for NFS used ratio
* Move logging sample to use oslo\_log
* Targets test refactoring
* Revert state if attachment already exists
* Add retry to lvm delete
* Admin extends tenant's volume but change admin's quota
* Drop use of 'oslo' namespace package
* Add Multi-connection support to XIV
* VNX Cinder driver Over Subscription Support
* Fix namespace issue in generate\_sample.sh
* Add hacking check for str and unicode in exceptions
* Fix volume creation from image with allowed\_direct\_url\_schemes
* Change default of option volume\_driver to LVMVolumeDriver
* GlusterFS: Support over subscription in thin provisioning
* Remove unnecessary checks for encrypted types
* Add test case for volume\_encryption\_metadata\_get
* Updated from global requirements
* Port rbd driver to use new driver model
* Don't truncate osapi\_volume\_link prefixes
* Fixed issue with mismatched config in VMAX driver

2015.1.0
--------

* Add external genconfig calls
* Create initiator id for VMAX iSCSI driver
* Remove deprecated methods in VNX driver
* Remove unused find\_attribute\_or\_element()
* 3PAR don't log version numbers every stats update
* Sync oslo service module
* Add external genconfig calls
* Enable use of filter\_function in PureISCIDriver
* NetApp E-Series: Fix instance live-migration with attached volumes
* Add resource tag to logging in volume.manager.py
* VMware: Handle concurrent inventory folder create
* Leverage timeutils, drop strtime() usage
* GlusterFS: Using mount method in RemoteFsClient
* Remove redundant code from VNX Cinder Driver
* Remove force check from copy\_volume\_to\_image
* Logging not using oslo.i18n guidelines (scheduler)
* service child process normal SIGTERM exit
* service child process normal SIGTERM exit
* Move unit tests into dedicated directory
* Dell SC driver calls out the wrong REST API version
* Move RBD calls to a separate threads
* Windows SMBFS: fix volume extend
* Fix a wrong argument of create method
* Fix tiny typo: compatability => compatibility
* Reserve 5 migrations for Kilo backports
* RBD: Add missing Ceph customized cluster name support
* Standardize logging in volume.api.py
* Release Import of Translations from Transifex
* Fix fetch\_to\_volume\_format if vhd is requested
* Windows: Improve vhdutils error messages
* SMBFS: Add minimum qemu-img version requirement
* VolMgr: reschedule only when filter\_properties has retry
* Storwize driver should only report active wwpn port
* update .gitreview for stable/kilo
* Mask passwords with iscsiadm commands
* Add support for customized cluster name
* Updated from global requirements
* SMBFS: Lock on a per-volume basis
* Windows SMBFS: fix volume extend
* Complete the doc/README.rst instructions to build docs
* Verify all quotas before updating the database
* Add locking to PureISCSIDriver around creating Purity Host objects
* Include boot properties from glance v2 images
* Add CA cert option to backups swift driver
* Fix a wrong argument of create method
* Add locking to PureISCSIDriver around creating Purity Host objects
* Reworked Dell SC iSCSI target portal return
* Fix LUN misalignment issue with NetApp iSCSI drivers
* Remove the export creation during volume creation for migration
* Fix assertEqual in test\_volume.py in correct order of params
* VNX Cinder Driver should report 0 free\_capacity\_gb in some scenarios
* Include boot properties from glance v2 images
* Logging not using oslo.i18n guidelines (brick)
* set default auth\_strategy to keystone

2015.1.0rc1
-----------

* Open Liberty development
* Removed sleep before 'YES' is sent to confim an operation
* Update openstack-common reference in openstack/common/README
* GlusterFS: Returning provider location of volume from snapshot
* Fixes snapshot creation failure in CloudByte driver
* Delete the temporary volume if migration fails
* Revert "Removing Windows drivers"
* Correct cinder hacking check numbering
* Add hacking check for print() statements
* Rbd update volume stats in wrong way
* Add missing copy\_volume\_to\_image method to Sheepdog driver
* Partial Revert "Removing Huawei drivers"
* Create initiator id if not exist in VMAX driver
* Fixed encrypted property for 3PAR FC and iSCSI drivers
* Partial Revert "Removing ZFSSA driver"
* Mock wait\_for\_volume\_removal in test\_brick\_connector
* Dell SC driver has insufficient iscsi logging
* VMware: Skip vSAN for preallocated image download
* Enable H238 hacking rule
* Use six.text\_type instead of unicode
* Fix ISCSIDriver initialized connection volume type
* Fix multipath device discovery when UFN is enabled
* Fix missing clone\_image API support for sheepdog driver
* More error handling on EMC VNX migration failure
* Set volume\_attachment to [] for the temporary volume creation
* Add volume:update rule to policy.json
* Fix always false condition in glance wrapper
* Only use operational LIFs for iscsi target details
* Revert "Removing Netapp FC drivers for no reported CI"
* Get volume from db again before updating it's status
* Catch more general exception in manager's create\_volume
* Fix broken fetch\_to\_volume\_format log message
* Tests: Fix v6000 test failure with random hash seed
* Check volume status in detach db api
* Fix wrong command for \_rescan\_multipath
* Storwize: Replication status still active when primary copy is offline
* VMware: Fix instance\_uuid access in volume retype
* Logging not using oslo.i18n guidelines
* Remove LP bug ref in remove\_iscsi\_device
* Fix potential access to missing key
* Brick: Fix race in removing iSCSI device
* VMware: Improve invalid container error message
* Fix the format of the system name in VMAX driver
* Hitachi: Fix access to volume instance\_uuid
* VMware: Fix ImageNotAuthorized during copy volume
* Fix: Boot from image with HNAS iSCSI
* SMBFS: Fix missing volume provider location
* Enhance VNX Cinder volume creation logic
* Properly use obj\_extra\_fields in objects
* Create unit tests for volume objects
* Fix incorrect invocation of \_add\_to\_threadpool
* VMware: Fixed usage of volume instance\_uuid
* Change volume and snapshot stuck creating to error
* Imported Translations from Transifex
* Fixed access to instance\_uuid in retype
* Ensure initialize\_connection in targets pass multipath parameter
* Eager load volume extra specs
* Be safe with getting attachment
* Added the missing attachment to detach\_volume
* Make lio iSCSI changes persistent to avoid lost
* Sort list of cinder\_object.changes
* Move to hacking 0.10
* Syncing versionutils from oslo-incubator
* Properly remove host object from ISE
* Dell Storage Center API change fails init\_conn
* Windows iSCSI: fix volume clone
* Enable request-id in cinder API logs
* Use cached values for stats on query failures for vmem drivers
* The value of netapp\_storage\_protocol should default to none
* Change leftover oslo.\* to oslo\_\*
* Updated from global requirements
* Fix: Synchronise Quobyte Share mounting
* Fix typo in cinder/cinder/volume/drivers/emc\_vmax
* Update file doc string for pure.py
* update oslo policy to remove policy.d log spam
* Fix QoSSpecManageApiTest to work in parallel

2015.1.0b3
----------

* Remove chap secret DEBUG logging in PureISCSIDriver
* Removing Windows drivers for no reported CI
* Fix logging mistake in swift backup driver
* Removing Zadara driver for no reported CI
* Removing Huawei drivers for no reported CI
* Removing Netapp FC drivers for no reported CI
* Removing Fujitsu driver for no reported CI
* Removing DRBD driver for no reported CI
* Removing FusionIO driver for no reported CI
* Removing Nexenta driver for no reported CI
* Removing Symantec NFS driver for no reported CI
* Removing StorPool driver for no reported CI
* Removing ZFSSA driver for no reported CI
* Make the 3PAR drivers honor the pool in create
* Removing HP MSA driver for no reported CI
* Removing Coraid driver for no reported CI
* Add retry to create resource in Datera driver
* Logging not using oslo.i18n guidelines
* Tests: Fix az test failure when PYTHONHASHSEED != 0
* Change datetime.now() to timeutils.utcnow() from oslo\_utils
* Fixes nits in check\_no\_contextlib\_nested
* Fix logging to catch original exceptions and tracebacks
* Remove error messages from multipath command output before parsing
* Return updated volume object to the caller of \_attach\_volume()
* Fix SAN generic driver ssh whitespaced commands
* EMC: Fix use of "\_" as variable name
* Reduce configured file size for nfs backup unit tests
* tests: remove useless variable
* Revert "Datera's export to avoid deprecated keys"
* Don't override extra specs with config in VMAX
* Check license before clone in VMAX driver
* Fixing mount when state\_path is configured with a final '/'
* Verify all quotas before updating the database
* Update Violin REST client library name
* Remove the reference of volume['instance\_uuid']in VNX driver
* Increase LeftHand driver minimum client version
* Decrement remaining retries after failed REST call
* VMware: Fail immediately for images in a container
* Make unused iscsi\_num\_targets, iser\_num\_targets configs as deprecated
* Raise exception for invalid mock assert calls
* Mocked utils.execute for broken tests
* Huawei driver check before associating LUN to a LUN group
* Windows: Fixes wintypes import issue in vhdutils
* Fix typos in LVMVolumeDriver
* Add minimum qemu-img version check functions
* Implement IET target driver
* Fix unit tests for multiattach patch
* Fixed a concurrency issue in VMAX driver
* Fix LVM thin pool creation race
* Added provider\_id to volume and snapshot object
* Fix ArgsAlreadyParsedError in emc\_vnx\_cli.py
* Fix typo in log message
* remotefs: Fix doc string for \_create\_snapshot
* Fix a typo in sf\_template\_account\_name help
* Move to the oslo.middleware library
* Remove use of contextlib.nested
* Remove strutils from oslo-incubator
* Add waiting for the driver to SchedulerManager
* Fix retype return value in volume driver base class
* Fix retype arguments in volume driver base class
* Fix sqlalchemy reuse in multi-backend children
* Fix Cinder logs to show authentication error in RBD driver
* Update hacking check for oslo\_log
* Add is\_ready method to scheduler driver
* Fix for  inconsistent cinder-services state change
* Fix HNAS iSCSI driver error on LUN creation
* Datera driver looks for lun-0 instead lun-1 now
* Use oslo.log instead of oslo-incubator
* Remove the useless next link for volumes, transfers and backups
* Unset auth token before trying to login to Datera
* NFS backup driver
* Sort snapshots in create CG from CG snapshot
* Add multiattach capabilities injection
* Tests: Harden fake\_notifier asserts
* Error trying to delete snapshots on Hitachi driver
* Remove global mocking from test\_pure.py
* Allow scheduler to receive volume stats when starting service
* VMware: Fix exception logging
* Adjust Cinder to support FCP on System z systems
* Refactor Swift backup driver and introduce chunking driver
* Namespace updates for \_i18n and imageutils & fileutils
* Dell FC driver inheritance order causing failures
* Add volume multi attach support
* Add project\_id to barbican keymgr wrapper
* Fixes VNX NotImplementedError of unmanage
* Replace assertEqual(True, \*) -> assertTrue(\*)
* Update Datera's export to avoid deprecated keys
* Improve error handling in refactored Tgt driver
* Adds pool aware scheduling for HNAS drivers
* PureISCSIDriver consistency group updates
* HP lefthand driver filter and evalautor function
* Fix the unicode encode error when create volume
* Add consistency group support for XIV/DS8K cinder driver proxy
* Don't fail target\_delete if ACL's don't exist
* Change log level for no object attribute found
* Add Manage/Unmanage support to NetApp NFS drivers
* Use snapshot object in create\_volume flow
* Fix "rtsllib" -> "rtslib" typos
* Fix some issues with pool name sent to SVC
* Fix allocated\_capacity tracking when rescheduling
* HP 3par driver filter and evaluator function
* Add support to incremental backups in cinder
* Convert all eqlx tests from mox to mock
* Fixed the order of mock decorators in VMAX driver
* Adds SSH communication to HNAS drivers
* Add CHAP support to PureISCSIDriver
* Make objects behave more like our old dictionaries
* Two choices for iscsi\_helper is missing
* Update Datera's Authentication method
* Simplify cxt test\_create\_export() unit test
* CG Modification Support in EMC VNX Cinder Driver
* Dell SC API change fails snapshot creation
* Adding manage/unmanage support for LeftHand driver
* More validation logic for VNX CG creation
* Change default value of gpfs\_images\_share\_mode to None
* Add DB table for driver specific data
* Move oslo.messaging to the oslo\_messaging namespace
* Create Consistency Group from CG Snapshot API
* Modify Consistency Group API
* Remove useless storage\_availability\_zone import
* Failover to alternative iSCSI portals on login failure
* Update volume type name for volume type API
* Add config option to override url for versions
* Snapshot and volume objects
* Cinder objects base
* Dell Storage Center Driver API bug
* Password config options should be marked secret
* Clear migration\_status from a destination volume if migration fails
* RBD: Query volume features from ceph.conf
* i18n Compatibility in VMAX driver
* Correct a few changes in the VMAX driver
* Fix HNAS driver parsing errors
* RBD: remove non-layering support for antiquated versions
* Fixed errors in docstrings in the VMAX driver
* SMBFS: Fix retrieving the volume path and format
* More validation logic for VNX CG creation
* Add flash cache policy to 3PAR driver
* Update v1 deprecation warnings
* Fixes the import for Lefthand driver
* NetApp eseries implementation for manage/unmanage
* Replication status periodic task optimization
* XtreamIO version 4.0 support
* Change max\_over\_subscription\_ratio default value
* Use Unique SCST Group names in SCST cinder helper driver
* Add CHAP persistence to SCST target helper
* Fix for infinity capacity reporting in EQL driver
* Use iscsi\_helper instead of target\_helper on logs
* Import only modules: H302
* Revert "Remove retry\_deactivation directive on lvremove"
* Over subscription for Pure Storage iSCSI driver
* Use oslo\_config choices support
* Custom zone name prefix not being used by brcd driver
* cinder-manage man update
* GET volumes API sorting REST/volume/DB updates
* GET volumes API sorting enhancements common utilities
* FCZM fix reading of cinder config entries
* Sync scheduler.filters module from oslo-incubator
* Limit volume copy bandwidth per backend
* Generic filter support for volume queries
* Remove warnings for long vgs and lvs calls
* Use subunit-trace to enable output during unit test runs
* VMware: Relocate volume to compliant datastore
* VMware:Use datastore selection logic in new module
* VMware: Refactor initialize\_connection unit tests
* Fix exceptions logging in TgtAdm
* Sync 'versionutils' module from oslo-incubator
* Sync 'threadgroup' from oslo-incubator
* Update 'systemd' module from oslo-incubator
* Sync 'service' module from oslo-incubator
* Sync 'loopingcall' module from oslo-incubator
* Sync the 'fileutils' module from oslo-incubator
* Sync 'eventlet\_backdoor' module from oslo-incubator
* Remove unused 'test' module from oslo-incubator
* IBM GPFS Consistency Group Implementation
* Fixed 3PAR driver load balancing during migration
* NetApp E-series: Allow scheduling by disk
* Make Interval and Retries Configurable for VMAX
* Pass region name to Nova client
* Remove retry\_deactivation directive on lvremove
* Manage/unmanage impl for NetApp ONTAP iscsi driver
* Fix argument order in assertEqual: tests/test\_service.py
* Fix some message nits in the ZoneManager
* Implement refresh as kwargs in get\_volume\_stats
* Dell sc driver iscsi multipath enhancement
* Tests: Fix cxt target tests opening files
* LVM: Fix thin provisioning and mirrors stats reporting
* Fix exception error on HNAS drivers
* Fix comments style according to the Hacking Rules
* Passing privileged user to create nova assisted snapshots
* Fix return value inconsistency in VNX Driver
* Fixed typo
* Pool-aware scheduler support in EMC VNX Cinder driver
* Fix extraneous comma that breaks docbook generation
* Sync policy module from oslo-incubator
* Dell Storage Center: Add retries to API calls
* EQLX: Consolidate CHAP config options
* Add support for chiscsi iscsi helper
* Fix logging guideline violations in volume/api.py
* Remove useless requirement on wsgiref
* Snapshot of bootable volume goes in error state
* Sync periodic\_task module from oslo-incubator
* Tests: Don't require binding to port 4444
* Tests: Remove TestWSGIService.test\_reset\_pool\_size\_to\_default
* Tests: Remove randomness from NFS mount tests
* Change exception message in volume api
* Refactoring for export functions in Target object
* Add iSCSI SCST Target support to cinder
* EMC VMAX driver Kilo update
* Fix Scality SRB driver security concerns
* Fixes total\_capacity\_gb value in CloudByte driver
* EMC VNX Cinder Driver iSCSI multipath enhancement
* Add dedup provisioning to 3PAR drivers
* Provided requirements are meant to be immutable
* Remove optional parameter from lun mapping call
* quobyte: remove dependency to xattr
* Don't fail target\_delete if target doesn't exist
* Remove custom lazy loading
* DRBD: Use correct function object after DBus disconnect
* Split volume driver into ABC classes
* Mock out the wait routine in the VMAX driver
* Limit ram and disk used by ceph backup tests
* Fix detach volume from host problem in VMAX driver
* fix typo in config.py
* Update hacking ignore list
* VMware: Delay string interpolation in log messages
* VMware: Integrate VMDK driver with oslo.vmware
* Enhance iSCSI multipath support
* Dell Storage Center Unit Test Updates for Kilo
* Updated from global requirements
* Update eqlx driver help text
* Add extra library oslo.concurrency to oslo.config.generator.rc

2015.1.0b2
----------

* Support over subscription in thin provisioning
* Change oslo.\* to oslo\_\*
* Lefthand driver fails to attach a cloned volume
* Purge deleted rows
* Make PureISCSIDriver iSCSI port discovery more flexible
* EMC VNX Cinder Driver Update
* Make storwize debug log more readable
* Fixes the EQL driver CI tests AttributeError
* Add manage/unmanage methods for Hitachi Block Storage Driver
* RemoteFS: Use nas\_ip and nas\_share\_path options
* Scality SOFS : Use ensure\_tree from fileutils
* Tests: Don't sleep for looping calls (eqlx)
* Enable use of an /etc/cinder/lvm.conf file
* Roll back if VMAX masking view not created
* Tests: Don't sleep for looping calls
* Windows iSCSI driver: Fixes copy disk method exception handling
* VMware: Fix missing target resource pool
* Revert "Implement Huawei SDSHypervisor driver"
* Remove the solaris volume driver
* Fix SSHPoolTestCase to work in parallel
* Drop deprecated namespace for oslo.rootwrap
* Fixes attribute content checking
* Imported Translations from Transifex
* Support iSER driver within the ISCSITarget flow
* HP3Par: Set snapCPG when managing existing volumes
* Fixed misspelling in solidfire.py
* Adds unit tests for HNAS backend
* Failed to discovery when iscsi multipath and CHAP both enabled
* Add retry for tgtadm update when tgt exists
* Add completion logging for snapshots and volumes
* Fix configratuion of rally jobs
* Create SolidFire Template account on init
* Updated from global requirements
* Add debug message for lvremove after udev settle
* IBM Storwize driver Consistency Group Implementation
* Use get\_my\_ipv4 from oslo.utils
* TgtAdm: Fix \_recreate\_backing\_lun logging
* Revert "Create SolidFire Template account on init"
* HP 3PAR modules have bad log messages
* Remove useless and unused request\_utils
* Create SolidFire Template account on init
* Fetch\_to\_volume\_format calls copy\_volume using wrong parameter
* Changed pvs separator from ':' to '|' to support names with ':'
* Raise correct exception when validate\_connector failed
* Add provisioned\_capacity
* Move 3 Fujitsu ETERNUS DX related file
* Add retry to lvm snapshot create
* Add a generic retry decorator to cinder/utils
* Use uuidutils from oslo.utils
* Remove unnecessary method: \_ensure\_iscsi\_targets() in tgt.py
* Raise correct exception if deleting of LIO iSCSI target is failed
* Cleanup unused DB APIs, part I
* Remove argparse from requirements
* Update tests for Quobyte Cinder drv from mox->mock
* Fixes a small issue in find\_autodoc\_modules.sh
* Fix the eqlx driver to retry on ssh timeout
* Add retrying lib from global requirements
* Remove usage of taskflow 'utils.misc' module
* Move oslo.serialization to oslo\_serialization namespace
* HP 3PAR modules do not follow coding guidelines
* Improve debug logging of Dell Storage Center driver
* Fix \_usage\_from\_snapshot in volume.utils
* VMware:Fix error creating vCenter inventory folder
* New Cinder volume driver for openvstorage
* Fix cinder-manage shell ipython
* Shrink down customized logging listener
* Prevent deleting volumes in a consistency group
* Fix bug in rbd driver: the cloned volume size is wrong
* Fix HNAS driver confusing error message (iSCSI driver)
* Updated from global requirements
* Ensure lazy translation is disabled properly
* DRBD: remove a wrong comma, it creates a tuple
* Move oslo.utils to oslo\_utils namespace
* Make test\_create\_delete\_snapshot more robust
* Add policy\_dirs conf fixture
* DRBD: Log an error if libraries can't be loaded
* Fix the iSER legacy usage in the new targets flow
* Move oslo.config to oslo\_config namespace
* Add support for manage/unmanage volume commands to PureISCSIDriver
* Scality: Lock around SOFS mount to avoid a race
* Set 'driver\_volume\_type' to 'gpfs'
* Verify the instance's existance in the VMAX driver
* Updated from global requirements
* Switch the PureISCSIDriver over to using the purestorage pypi module
* Fix zfssa driver volume attach to work with latest zfssa software
* Updated from global requirements
* Move oslo.db to oslo\_db namespace
* Fix eqlx endless loop when server closes the connection
* Increase unit test coverage in hacking test
* Fixed server name being retained after detach in LeftHand
* Fixes misspelled words in Cinder
* Imported Translations from Transifex
* Add mock for cinder-rtstool call in tests.targets.test\_lio\_driver
* Skip LIO target unit tests until mocked
* Fix LOG formatting in api initialize\_connection
* TgtAdm: Don't change CHAP username/password on live migration
* Deal with PEP-0476 certificate chaining checking
* Add hacking check for oslo namespace usage
* Remove locks from LeftHand driver
* Fix bug in tgt conf for volume
* Use is\_valid\_ipv6 from oslo.utils
* Use lockutils.set\_defaults to set lock\_path in test
* Fix bug in sheepdog driver: the wrong volume size
* Add loopingcalls for Huawei storage system driver
* Implement clone\_image caching on SolidFire
* Add migration tests for PostgreSQL
* Garbage Remains when Attached Volume is Migrated with NFS Driver
* Update README.rst to current state
* Remove unused variables from ensure\_export()
* Fix incorrect usage of get\_flow in volume.manager
* Fix iscsi\_write\_cache setting for iscsi targets
* Add debug messaging for tgt already exists
* Clean up QoSSpecManageApiTest setup
* Add more rally benchmarks related to Cinder
* Use cinder.utils.execute directly
* Deal with tgt already exists errors
* Fix drbd driver to load without 3'rd party libs
* i18n fixes for PureISCSIDriver
* cinder-rtstool: should use acl.node\_wwn
* LVM: Add terminate\_connection call for Target Objects
* Add an instance-locality filter
* Adds cinder iscsi driver for CloudByte storage
* Add driver filter and evaluator for scheduler
* Remove import of private \_lazy module
* Fix argument order in assertEqual: tests/test\_nfs.py
* Fix the continuation line indent to pass flake8
* Capitalize the first letter in log messages
* Fix argument order in assertEqual: tests/test\_glusterfs.py
* Use assertRaisesRegexp() in test\_srb.py
* The DRBD(manage) Cinder volume driver
* Make ProphetStor drivers compliant with logging standards
* Transition LVM Driver to use Target Objects
* Replace oslo-incubator with oslo\_context
* Create proxy volume driver
* Fix handling of serialized data in filtering of volumes
* Convert mox to mock: tests/test\_glusterfs.py
* Remove check on db\_exc.DBError
* Add specific docs build option to tox
* Imported Translations from Transifex
* Add a privileged user for OpenStack services
* Add support to PureISCSIDriver for Consistency Groups
* Expand the description of extra\_capabilities
* Fix broken StorPool driver
* Brick LVM: Remove self.lv\_list
* Revert "Outputs the message about failing to bind
* Replace the NetApp driver proxy layer with a proper factory
* Quobyte Driver Exception Cleanup
* Handle the volume not found case in the VMAX driver
* Fix format errors in brick/iscsi LOG messages
* Add unit tests for NetApp do\_setup methods
* Outputs the message about failing to bind to IPv6
* NetApp E-series: Do not log passwords in requests
* Set iet\_conf to nonexistent file in unit test
* Fix issue with passing lists in filters
* Rename oslo.concurrency to oslo\_concurrency
* Add a provider\_id column to Volumes and Snapshots
* Mock leaked \_execute() calls in driver tests
* Sync request\_utils module from oslo-incubator
* Sync periodic\_task module from oslo-incubator
* Persist volume uuid on VMAX array
* Fixed a problem in terminate\_connection in VMAX driver
* Sync the latest middleware module from oslo-incubator
* LVM: Volume is deleted unexpectedly during volume migration
* RBD: use image\_conversion\_dir for image operations
* Sync the latest loopingcall module from oslo-incubator
* Sync install\_venv\_common from oslo-incubator
* Sync latest imageutils from oslo-incubator
* rtstool on Ubuntu installs in /usr/local/bin
* encryption\_id needs to be non-nullable
* Mock calls to rpm and dpkg from NetApp unit tests
* Fix files in Cinder with execute bit set
* Add error handling to \_connect function in PureISCSIDriver
* Fix typo that escaped review in connector.py
* Fix 3PAR host persona mapping to match WSAPI
* Punctuation and Copyright changes
* Make 3PAR drivers compliant with logging standards
* Fixing 3PAR connection name cache error
* Remove redundant args for clone\_image method
* Add Oracle ZFSSA NFS Cinder Driver Support
* Fix HNAS driver initialization

2015.1.0b1
----------

* Make GPFS driver compliant with logging standards
* Updated from global requirements
* Fixed wait for job completion in VMAX driver
* Logging updates to properly use ',' instead of '%'
* Add support for Purity Protection Groups to PureISCSIDriver
* Catch ImageNotFound exception when deleting rbd volume
* Isolate Cinder Attach and Connect in Base Driver
* Uncouple scheduler stats from volume creation
* Fibrechannel and iSCSI for Violin Memory 6000 Series Arrays
* Add Scality SRB driver
* Update volume driver for Huawei storage system
* Implement Huawei SDSHypervisor driver
* Implement Huawei SDSHypervisor connector
* Added volume type description for volume type API
* Added UUID as primary key for Encryption model
* Fix 3PAR driver hang on SSH calls
* Delete default volume size 100M in drivers
* Send the notifications to the Ceilometer for backup service
* Add the StorPool block storage driver
* Update global requirements
* Remove commented out code from cinder/test.py
* Fix HNAS driver confusing error message
* Remove iscsi\_helper calls from base iscsi driver
* Add unit test for commit 22abe9081
* Add Support for Dell Storage Center
* Ensure that lun\_id is an int for NetApp Drivers
* Symantec NFS cinder driver
* DB migration tests
* Convert mox to mock: tests/compute/test\_nova.py
* Correct default service\_name for nova\_catalog\*\_info config option
* FlashSystem Code Cleanup
* FibreChannel drivers for NetApp Data ONTAP storage controllers
* First version of Cinder driver for Quobyte USP
* Fix use of invalid variable in tgt exists check
* Remove an unused variable in volume/manager.py
* Brick: fix bug in tgt conf for volume
* Convert test\_image\_utils tests to mock
* Report better capacity info for a limitless 3par cpg
* VMware: Fix datastore selection with single host
* Add support for backup encryption metadata
* Improve use of temporary\_file and temporary\_dir
* RemoteFS: Move Nova snapshot code into RemoteFSSnapDriver
* Implementing the use of \_L’x’/i18n markers
* Fixes intermittent NFS driver mount failure
* Updated from global requirements
* Use pbr entry\_points to setup the cinder scripts
* ZFSSA iSCSI driver should support extra specs
* Remove the cinder.conf.sample file
* Fix for typo in Purity Host create/delete methods in PureISCSIDriver
* Fix a clone volume problem in VMAX driver
* Updated from global requirements
* Fix 3PAR driver attach error when host name missing
* NetApp fix vol migration unusability
* Updated from global requirements
* Allow HostState to handle empty capabilities
* Inherit RequestContext from oslo
* Imported Translations from Transifex
* Workflow documentation is now in infra-manual
* Remove the check\_uptodate conf checks
* Improve unit tests for cinder/volume/utils.py
* Remove lio\_initiator\_iqns
* Bring cinder up-to-date with new oslo libraries
* VMware: Add missing storage profile requirement
* Use object.property instead of object.dump()['property']
* NetApp 7mode NFS driver doesn't honor netapp\_vfiler option
* Revert "Fix Brocade FC SAN lookup MITM vulnerability"
* Add ability to zfssa driver to create multiple initiator groups
* Improve testing of cinder/utils.py
* Fix rpc initialization of cinder-manager volume
* Fix 3PAR drivers attempt to locate existing host
* Volume type access extension
* Remove driver compatibility in volume manager
* Don't use \_execute directly in brick/iscsi
* Deal with tgt already exists errors
* Fix find\_autodoc\_modules.sh to support OSX
* Raise exception if invalid IP is specified
* Fix check\_ssh\_injection in cinder/utils
* Fix \_get\_disk\_of\_partition edgecase in utils
* Adding volume driver for X-IO ISE
* Remove Python 2.6 backwards compatibility code
* Imported Translations from Transifex
* Get the 'consumer' in a correct way for retyping with qos-specs
* PureISCSIDriver:Handle delete called on already deleted volume
* Add limited retype support for rbd
* Add iSCSI Target objects as independent objects
* Remove Python 2.6 classifier
* Implementing the use of \_L’x’/i18n markers
* Match mock.patch decorator with appropriate param
* Correct misspelled words
* Brick LVM: LV not found logging and error handling
* etc: replace NullHandler by Python one
* Don't use module importutils from oslo-incubator
* Removing locks from 3PAR FC and iSCSI drivers
* Update rally job files
* Fix calls to assert\_called\_once in unit tests
* Refactoring to allow addition of NetApp FibreChannel drivers
* Add ability to create volume from image by image name
* Fix exception message formatting
* VMware: Set target ESX host for backing VM clone
* Create "image\_conversion\_dir" before creating temporary file
* Convert the DateTime into ISO8601 format for Ceilometer
* Imported Translations from Transifex
* Remove module timeutils
* NetApp NFS and iSCSI: move zapi client logic into modules
* Context cleanup
* ProphetStor with pool aware cinder scheduler
* Updated from global requirements
* Imported Translations from Transifex
* Fix messages in EMC VMAX driver with no translation
* Scality SOFS: implement volume backup and restore
* Fixup regressions in PureISCSIDriver log statements
* Implementing the use of \_L’x’/i18n markers
* Remove module jsonutils
* Sync policy from oslo-incubator
* Don't use module excutils from oslo-incubator
* Sync latest versionutils from oslo-incubator
* GlusterFS: Lock on a per-volume basis
* Defining the variable "tmp" before try block
* PureISCSIDriver needs to disconnect hosts before deleting volumes
* context.elevated() should use copy.deepcopy()
* Added missing rules in policy.json
* Fix message translations for MSA common class
* Switch Cinder to use oslo.concurrency
* Use oslo.utils
* Remove code for deprecated extension path
* Imported Translations from Transifex
* Update prerequisite packages in development docs
* Change CHAP secret default length
* Implementing the use of \_L’x’/i18n markers
* Switch to oslo.serialization
* Fix typo in SolidFire xDBVersionMismatch label
* Fix a problem in creating consistency group in ProphetStor driver
* Updated from global requirements
* Disable Cgsnapshot APIs by default
* Invalid GlusterFS share format error
* allow image\_id for imageRef in create volume API v2
* Changing PureISCSIDriver to use % string formatting instead of .format
* Update cinder.conf.sample to fix max db conn retries
* CiscoFCSanLookupService passing command as string
* Documentation Bug fix committed
* Add i18n \_LX tags for relevant log levels in EQLX driver
* Bump Req timeout to 30 seconds in SolidFire Driver
* Remove cinder/compute/aggregate\_states.py
* Remove deprecation warnings relating to api-paste
* Mock isfile in test\_ssh\_missing\_hosts\_key\_file
* Implementing the use of \_L’x’/i18n markers
* Scality driver:use self.configuration instead of CONF
* Mock cinder.wsgi.Server in TestWSGIService
* Explicitly close requests obj in SolidFire Driver
* Remove Mock class monkey patching
* Add volume attribute support to volume created using clone, snapshot
* Stop stacktracing on QuotaErrors
* Stop stacktracing on InvalidInput exceptions
* Add automatic creation and deletion of Purity hosts for PureISCSIDriver
* Mox -> Mock for test\_block\_device.py
* Fix Brocade FC SAN lookup MITM vulnerability
* Implementing the use of \_L’x’/i18n markers
* Imported Translations from Transifex
* Updated from global requirements
* Fix the LV NotFound situation for thin-type LVM
* Fix wrapper to work with barbicanclient 3.0.1
* Retry remove iscsi target
* Adding support for 'source-id' in 3PAR manage
* Remove test\_barbican from keymgr tests
* Implementing the use of \_L’x’/i18n markers
* Capture exception when delete a volume detached
* Add cinder support for IBM FlashSystem
* Use urllib.urlencode instead of dict\_to\_query\_str
* Disable python-barbicanclient 3.0.0 version
* Activate pep8 check that \_ is imported
* LIO: Fix UnboundLocalError in ensure\_export
* Amend unused variables to assist pylint testing
* Brick LVM: Rename get\_all\_volumes, further optimize
* Fix wrong arg number for \_fix\_id\_migration issue
* Cleanly override config in tests
* Add debug output indicating provider\_location
* Use look up service for auto zoning
* Fix for debugging c-vol in PyCharm
* CiscoFCSanLookupSerive uses extra argument in init
* Fix SolidFire inaccurate model on migrated vols
* Eventlet green threads not released back to pool
* Add ability to update migration info on backend
* Reserve 5 migrations for backports
* Verify the full interface of the context object
* IBM Storwize: Improve error message
* Imported Translations from Transifex
* LioAdm: Delete initiator from targets on terminate\_connection
* NFS Security Enhancements: allows secure NFS environment setup
* Brick LVM: Optimize get\_volume
* TgtAdm: Don't change CHAP username/password on live migration
* Update volume-type's quota when extending volume
* Cinder api service doesn't handle SIGHUP properly
* Handle DBConnectionError instead of Exception
* Remove outdated \_ as a builting from pylintrc
* ProphetStor driver consistency group support
* Turn on Flake-8 Complexity Checking
* Log a warning when getting lvs and vgs takes longer than 60 seconds
* Add client\_socket\_timeout option
* IBM Storwize driver: Add local variable assignment to "ctxt"
* Updated from global requirements
* Multipath commands with error messages in stdout fail to parse
* NetApp fix to set non default server port in api
* Correct the message string

2014.2
------

* Fix LVM iSCSI driver tgtadm CHAP authentication
* Export cinder volumes only if the status is 'in-use'
* Fix LVM iSCSI driver tgtadm CHAP authentication
* Export cinder volumes only if the status is 'in-use'
* Revert "Relocate volume to compliant datastore"
* Remove vol\_type\_id cast to str
* Move SolidFire driver from httplib to requests
* check the configuration item glance\_num\_retries
* VMware: Fix initialization of datastore selector
* Imported Translations from Transifex
* Fix exception handling on test\_delete\_nonexistent\_volume
* check the configuration eqlx\_cli\_max\_retries
* Revert "Relocate volume to compliant datastore"
* Remove deprecated use of gettextutils import \_
* Fix NetApp AutoSupport Shortcomings
* HP 3PAR: Don't ignore extra-specs snap\_cpg when missing cpg
* 3PAR migrate without losing type settings
* 3PAR with pool-aware-cinder-scheduler
* Fix display name change during backup restore
* gitignore /.\*
* Fixes docstring typos (Cinder)

2014.2.rc2
----------

* Remove useless sslutils from openstack.common
* Truncate fail\_reason to column length
* Fix eqlx CLI output parsing on bad input
* Eqlx fix NoSuchOptError for volume\_name\_template on clone
* VMware: Bump driver version
* Updated translations
* NetApp fix eseries unit test mock clean
* Make sure device support Direct before setting
* Make sure device support Direct before setting
* Eseries warn if multipath is not set for img xfer
* GlusterFS: Remove unneeded conf import
* ZFSSA iSCSI vol create fails with vol type option
* Handle eqlx SSH connection close on abort
* ZFSSA iSCSI driver cannot add multple initiators to a group
* Fix race condition in ISCSIConnector \_disconnect\_volume\_multipath\_iscsi
* Deprecate / obsolete NetApp volume extra specs
* IBM Storwize driver: Retype the volume with correct empty QoS
* Fixed Typo from modfied to modified
* Updated from global requirements
* Sync latest processutils from oslo-incubator
* Imported Translations from Transifex
* Updated from global requirements
* coraid: allow setting default repository
* Sync latest processutils from oslo-incubator
* Windows SMBFS: Handle volume\_name in \_qemu\_img\_info
* Refuse invalid qcow2 backing files
* Windows SMBFS: Handle volume\_name in \_qemu\_img\_info
* Refuse invalid qcow2 backing files
* Clarify InvalidInput exception when the size is missing
* Handle eqlx SSH connection close on abort
* Deprecate / obsolete NetApp volume extra specs
* Fix race condition in ISCSIConnector \_disconnect\_volume\_multipath\_iscsi
* ZFSSA iSCSI driver cannot add multple initiators to a group
* ZFSSA iSCSI vol create fails with vol type option
* Open Kilo development

2014.2.rc1
----------

* Fix race condition in ISCSIConnector disconnect\_volume
* Adds openSUSE support for developer documentation
* IBM Storwize driver: Retype the volume with correct empty QoS
* VMware:Unquote folder name for folder exists check
* VMware: cinder-volume create\_session fail at retry
* Fixing format for log messages
* Update /etc/cinder/cinder.conf.sample for memcache
* VMware: Relocate volume to compliant datastore
* Fix parameter miss in test\_snapshot\_metadata test case
* Failed to re-detach volume when volume detached
* Imported Translations from Transifex
* IBM Storwize:Failed to retype from non-type to replication enable
* Fix unnecessary WSGI worker warning at API startup
* Remove XenAPI driver
* Add required spaces in log messages
* Fix ssh\_host\_key\_file default in help and config.sample.conf
* Downgrade 'infinite' and 'unknown' capacity in weigher
* Remove unused py33 tox env
* Add unit test to cinder cgsnapshot api
* DB migration 25->24 failed when dropping column
* Allow scheduler pool information to be retrieved
* Increase the 3PAR hostname length
* Timeout triggers failures running tempest for ZFSSA driver
* NetApp fix for default host type in eseries
* HP 3PAR drivers should not claim to have 'infinite' space
* Add tests for consistency groups DB migration
* Verify requested size in volume.api create
* Typo "asscoiated" should be "associated"
* NetApp fix eseries unit test mock clean
* Updated from global requirements
* Set socket options in correct way
* HP 3PAR: Allow retype when the old snapshot CPG (3PAR pool) is None
* NetApp fix for controller preferred path
* VMware: Add storage profile related unit tests
* Check replication status failed for non-replication
* VMware: Implement retype for VMDK driver
* VMware: Improve datastore selection logic
* Sync latest strutils from oslo-incubator for mask\_password fix
* Remove executable bits on various files
* Fix a problem with 'volume list' when 'all\_tenants=0'
* IBMNAS: Remove call to set r/w permissions to all
* Updated from global requirements
* Getting iscsi\_ip\_address from cinder.conf
* Handle config file with newlines and whitespaces
* Volume types need to be specified when creating CG
* Stop using intersphinx
* Netapp drivers support for pool-aware scheduling
* coraid: fix snapshot deletion
* SQL scripts should not manage transactions
* Add reset-state function for backups
* Add test case for volume\_types.py
* Block sqlalchemy-migrate 0.9.2
* Destroy Datera export target after detach
* EMC VNX Direct Driver Consistency Group support
* Update oslo.config and oslo.messaging requirements
* Fixes Windows Volume Driver upload volume fails
* Log an error on nfs mount failure
* Sync service.py and its dependencies to Cinder
* HP 3PAR configurable ssh-host-key-policy
* Fix confusing exception message in NetApp iscsi driver
* Delete consistency group failed
* Fixing leaking sessions in 3PAR on attach/detach
* Add Windows SMB Volume Driver
* Netapp: fix multiple copies of cinder-volume
* Add SMB Volume Driver
* Fix possible race condition for accept transfer
* Imported Translations from Transifex
* Mock glance client object in version unit tests
* Revert iSCSI Target objects as independent objects
* Use right body for test\_create\_missing\_specs\_name
* remove object in wsgi LOG.info
* Don't clear \_mounted\_shares list in remoteFS while updating
* Some tcp configuration paramters are ignored
* Add filter to volume transfer REST api
* Fix help for running specified unit tests
* Deprecate the V1 API
* Set default pool value to system in gpfs driver
* Fixes Cinder fails to upload volume to vhd image
* Unit test for restore with different hosts

2014.2.b3
---------

* During a restore send the restore request to the right host
* Add Datera driver for Cinder
* warn against sorting requirements
* VMware: Remove redundant extend disk API call
* VMware: Implement backup/restore for VMDK driver
* Update the HP 3PAR default persona
* Fixed Typo - from hypens to hyphens
* Fixed typo from 'the the' to 'the'
* Fix running unit tests with coverage
* Support Volume Backup Quota
* Volume Replication implementation for IBM Storwize/SVC
* Add Fujitsu ETERNUS DX support
* Pool-aware Scheduler Support
* Small typos
* Add QoS support to IBM Storwize driver
* Fix unnecessary snap of glance image, with non-raw images
* Driver for Fusion-io ioControl Hybrid array
* Make ssh-host-key-policy configurable
* Add Cisco FC Zoning plugin to the FC ZoneManager
* Typo
* Ignore pylint error 'hashlib' has no shaxxx member
* Update oslo policy and its dependencies
* Avoid using the disk cache on volume initialisation
* Introduce Hitachi storage volume driver
* XtremIO cinder iSCSI & FC volume drivers for Juno
* Consistency Groups
* Add retype method to xiv/ds8k driver interface
* Fixes terminate\_connection live migration issue
* Fixing 3PAR excessive FC port usage
* Sync latest processutils from oslo-incubator
* Sync latest strutils from oslo-incubator
* Mock processutils.execute properly in test\_ibmnas
* VMware: Disable suds caching
* Adds volume replication methods to xiv/ds8k driver interface
* Pass an empty context to the notifier
* Add Oracle ZFS Storage Appliance ISCSI Driver
* Add support in Cinder for volume replication - driver approach
* EMC VMAX Driver Juno Update
* Fix duplicate teardown to allow tox upgrade
* Revert test\_rootwrap\_filter to avoid python2.6 test failure
* Improve Cinder API internal cache interface
* Allow backup-to-swift to take swift URL from service catalogue
* Integrate OSprofiler and Cinder
* Fix variable name in api/v<n>/snapshot.py
* Honor volume:get policy
* Extending IBMNAS driver to support NFS based GPFS storage system
* GlusterFS: Use image\_utils for tempfile creation
* Modify error code compatible with Mac OS
* Cache snapshots in request for extension
* Remove redundant temporary\_chown from IetAdm
* Failed to initialize connection
* Mock out image source file in image\_utils tests
* Provide a quick way to run flake8
* Ignore No value passed for parameter 'dml' message
* Create RemoteFSSnapDriver class
* VMware: Handle exceptions raised by image update
* Adds barbican keymgr wrapper
* Imported Translations from Transifex
* Catch vol not found in SolidFire transfer
* Fix LOG string formatting in image\_utils
* Change the froce delete volume flage to True
* Update ref used for notifications
* HP 3PAR manage\_existing with volume-type support
* Add iSCSI Target objects as independent objects
* Rewrite ionice command filter using ChainingRegExpFilter
* Use abstract class for the backup driver interface
* Put result in quotes
* Fix exception handling in PureISCSIDriver
* Catch DBDuplicateEntry instead of IntegrityError
* Enable import group hacking rule
* Actually encode the SolidFire json dump result
* Sync latest oslo-incubator log for debug fixes
* Enable F402 checks and fix violations
* Prevent tenant viewing volumes owed by another
* VMware: Check snapshot and rename backing
* Fix bad indentation in netapp and san.hp volume drivers
* Ignore HTTP\_PROXY during test requests
* Issue one SQL statement per execute() call
* Add ProphetStor DPL Storage server volume driver for Cinder
* Add timer info for copy operations
* Make manage.py usable
* Enable H104, F841 hacking rule and fix violations
* Adds CA cert file path option for glance connections
* Enable Swift backup driver for auth 2.0
* Updated HACKING.rst so that it is accurate
* Update help strings
* Add hacking check for use of LOG.audit
* Imported Translations from Transifex
* Use oslo.i18n
* Add CHAP support for 3PAR ISCSI
* EMC: Fix minor issue in VNX driver and unit tests
* fix a small typo in development.environment.rst
* Do not translate debug messages
* Fixing LeftHand live migration error
* Improve regex for \_ import hacking check
* General cleanup of unused objects
* RPC client lazy initialization
* Fix snapshot id for snapshot\_destroy
* Use auth\_token from keystonemiddleware
* Fixes wrong usage of mock.assert\_not\_called()
* Fix error log level in restore-backup routine
* Add retry\_on\_deadlock to db update methods
* Fix unit test test\_import\_record\_with\_verify
* Change the exception type for Storwize/SVC driver
* VMware: Update default task\_poll\_interval value
* Change logging level AUDIT to INFO
* Fix solidfire accept\_transfer
* VMware: Volume from non-streamOptimized image
* Enable checks for E711, E712 and E713
* Add note that some checks are disabled on purpose
* VMware:Disk type conversion during clone backing
* VMware:Support for attaching disk to backing
* Change 3PAR delete message when volume is busy
* Move generate\_password into volume utils
* Move SSHPool into ssh\_utils.py
* Fixes migrate\_volume\_completion
* Change corrupted spelling mistakes
* EMC VNX Direct Driver Update for Juno
* Storwize/SVC can not get the right host
* Skip incompatible test on OSX
* Have task/flow logging go to a separate log file
* fix atom link in XML Version API
* Update ref used for notifications
* Fix glance metadata SQL query performance
* Add return of updated object on update from DB
* fixing the iSER transport protocol when using LVMISERDriver
* Add hacking check for vim headers
* Get updated model info on volume transfer
* Introduce iSCSI driver for Pure Storage FlashArray
* Further cleanup of reservations index
* Sync log from oslo-incubator for isEnabledFor fix
* Modify the index migration slightly for backport
* Remove cinder-clear-rabbit-queues
* Remove cinder-rpc-zmq-receiver
* Remove reattach function in cinder-manage
* Set python hash seed to 0 in tox.ini
* HP 3PAR retype implementation
* Add index for reservations on (deleted, expire)
* Remove Hyper-V dependency in the Windows Cinder Volume Driver
* Fix no handlers could be found issue
* Add storageHost content to volume messages
* Add hacking check for explicit import of \_
* Make manage/unmanage admin only
* Avoid OSError in get\_blkdev\_major\_minor with network filesystems
* VMware:Support for create disk and disk descriptor
* Implement import/export for SolidFire Driver

2014.2.b2
---------

* Implements new 'bootable' option for manage existing volume
* Add hacking test
* Fixes Cinder volume upload to image on windows
* Add explicit import of \_ to hp\_3par\_fc and iscsi
* Adds storwize\_svc\_npiv\_compatibility\_mode flag to Storwize/SVC driver
* Switch to use oslo.db
* Add additional explicit imports of \_ where needed
* Fix failure of source volume deletion in migrate\_volume\_completion
* Remove hard coded reference from gettextutils.py
* Enable lazy translation for Cinder
* Explicitly import \_() in Cinder code
* Fix performance issues with brocade zone driver
* Don't leave snapshots on the floor
* Add some log info for NoValidHost
* Use immutable default values for args
* Update cinder generate\_sample script
* XIV volume manage/unmanage support
* Add affinity/anti-affinity filters
* Bump oslo.rootwrap to 1.3.0.0a1 for Cinder
* Mock out time.sleep in storwize unit tests
* Fix the section name in CONTRIBUTING.rst
* Cinder-api service throws error on SIGHUP signal
* Clean up base Volume Driver
* Fixes EqualLogic volume live migration
* Correct misspelled word
* Remove definition of Python Source Code Encodings
* Fixed some typos in the cinder codebase
* Sync gettextutils.py from oslo-incubator
* Use PyCrypto to generate randomness passwords
* Remove $sqlite\_db from default database connection
* Sync processutils and log from oslo
* Configure write cache option of tgtd iscsi driver
* Enhance docstring for iscsi\_helper
* Updated from global requirements
* Ensure FC ZoneManager is called
* Remove cinder.context warning logging
* sync periodic\_task fix from incubator
* Slow down Storwize driver initialization
* Updated from global requirements
* Imported Translations from Transifex
* Imported Translations from Transifex
* volume\_image\_metadata missing from volume list
* Correct lvm\_mirrors help message
* Ceph rbd volume manage/unmanage support
* Enable E121,E122,E123,E126,E128 hacking rules
* Replace tearDown with addCleanup - Part 3
* Fix begin\_detach logic
* Use (# of CPUs) osapi\_volume\_workers by default
* Restore osapi\_volume\_workers config option
* Fix host option isn't set when using multiple backend
* Add optional\_args to fix Volume Import failure
* 3PAR Only remove FC Zone on last volume detach
* Ensure rbd connect exception is properly caught
* Add cinder-manage cmd to update host column
* Add cinder volume driver support for Nimble Storage
* Sync processutils from oslo with deps
* Synced jsonutils from oslo-incubator
* Enable hacking rule E111,E112,E113
* Bump minimum hacking version to 0.9.2
* Only warn about deprecation warnings once
* Fix dropped exception for create\_export in vol manager
* Misuse of i18n log translation to output error message
* Support Volume Num Weighter
* Fix docstring for snapshots API
* Don't use ModelBase.save() inside of transaction
* Fix unsaved exception in backup/drivers
* 3PAR volume manage/unmanage support
* Add cgroups related commands to rootwrap filters
* Use a task subclass instead of a functor + task wrapper
* Fix BrcdFCSANlookupService to iterate multiple switches
* GlusterFS: Handle deletion of snapshot with no backing file
* Fixed data copy issue of volume/driver.py
* Make rbd driver string encoding checks consistent
* Remove check\_volume\_az\_zone functor and associated passing
* Minor cleanups in test\_volume
* Fix retyping attached volumes requiring migration
* Update \_resize\_volume\_file() to support appropriate permissions
* test\_storwize\_vdisk\_copy\_ops fails if green thread context switch
* VMware:Fix params for copy-image-to-volume
* VMware: Optional create backing parameters
* Fixes cinder volume from snapshot on Windows
* Fixes cinder volume create on Windows Server 2012 R2
* Fixes cinder volume from image on Windows
* Use oslo-incubator module units
* Attach log listeners to other engines
* Adding filter options to backup list
* Remove global conf settings from iscsi helper
* Add genconfig tox job for sample config file generation
* Fix nfs\_shares config file parsing of spaces
* GlusterFS: Various unit test improvements
* vmware: Force chunked transfer for upload-to-image
* Sync the latest common db code from oslo
* Fix order dependency of admin metadata
* GlusterFS tests: Mock out compute, don't load novaclient
* Updated from global requirements
* debug level logs should not be translated
* Implement extend volume in NFS driver
* Fixes an issue with 'dd' bug from Illumos repo
* Handle the case where az is disabled/removed
* I/O rate limit for volume copy with qemu-img convert
* I/O rate limit for volume copy with dd
* glusterfs: Honor mount options when restarting cinder service
* Add keyword argument missing at some exc.HTTPError subclass
* Made provision for providing optional arguments
* Removes unecessary call to rbd.Image
* Add task/flow listener support around the volume api flow
* Retry lvremove with ignore\_suspended\_devices
* Allow reset-state on attach and migration fields
* Implements HDS-Cinder HNAS Drivers
* vmware: Fixes VMDK volume incompatibility issue
* Remove unused oslo module and adjust opentstack-common.conf

2014.2.b1
---------

* Copy custom properties to image from volume
* Add strip size support to rbd driver
* Fix log capturing fixture
* Fix Brocade FC driver's use of the fc\_fabric\_names
* LIO: Don't add ACL for local initiator name
* Delete image on upload-to-image failure
* Ensure flushing of IO prior to removing FC device
* Fixed the comment spelling error - voumes to volumes
* Remove Quota Exception Stack Traces from Cinder Logs
* Use os.urandom in volume transfer
* Remove check\_{attach,detach} from volumes API
* Make begin\_detaching fail if volume not "in-use"
* hp\_lefthand\_rest\_proxy no handler for logger during tests
* 3PAR volume detach with host in a host set
* Update cinder.conf
* Sync periodic\_task from oslo-incubator
* Remove second get call to list/show volumes
* Fix a message format error in migration cleanup
* Add support for z/VM driver
* Handle volumes no longer existing in resume delete
* Fix ISER scan retry option
* Only create volume with an active image
* Updated from global requirements
* Ensure metadata is saved before updating volume status
* Add XML deserializer for qos\_manage delete\_keys API
* Use error instead of warning to log mount exc
* Allow host config to be overriden in backend
* Remove all mostly untranslated PO files
* Updated from global requirements
* Remove create\_from\* functor jump table
* SSHPool in utils should allow customized host key missing policy
* Check whether O\_DIRECT is supported to iflag and oflag separately
* Set volume usage audit period to not NoneType
* BrcdFCSanLookupService should allow customize host key and policy
* NetApp fix eseries concurrent vol map failure
* NetApp fix attach fail for already mapped volume
* Imported Translations from Transifex
* Convert SolidFire Capacity response to GiB
* eliminate the need for hplefthandclient in tests
* Fix solaris\_execute in SolarisISCSIDriver
* Fix for solidfire driver to use reserved\_percentage
* Fix retyping volume that has volume type None
* eliminate the need for hp3parclient in tests
* Add missing methods to FakeISCSIDriver
* Add mailmap entry
* Fix wrong exception reference
* Limit formatting routes when adding resources
* Use oslo network utils function to set tcp\_keepalive
* Properly initialize rpc in cinder-volume-usage-audit
* Add exception handling for copy\_volume\_to\_image()
* NetApp NFS: Do not reference dst\_img\_local before assignment
* Remove explicit dependency on amqplib
* Fixes an issue with 3PAR attach
* Ensure that lun\_id is an int
* Implement validate\_connector in FibreChannelDriver
* Fix broken version responses
* Fix double "the" in Cinder quota warning
* CinderException args to strings when exceptions
* Fixed 3PAR driver issue finding correct vlun
* Storwize/SVC driver detach volume failed
* Add disabled kwarg to service\_get\_all\_by\_topic
* Add rally job
* Improve consistency of help strings
* Remove unused volume instance\_uuid methods
* Cinder list does not filter admin metadata
* Specify lld in tgt config backends
* Replace tearDown with addCleanup - Part 2
* Keep volume available if retype fails due to quota
* Remove unused 3PAR driver method
* Fix bad indentation in tests
* Add set-bootable command
* Fix handling multiple WWPNs on preferred FC node
* Fallback to None on missing Glance image attrs
* Remove old driver mappings from Havana
* Adjust sample config for keystoneclient 0.8.0 release
* Remove unused reservation methods from db.api
* Re-raise exceptions in upload-to-image
* Update Cinder dev doc
* vmware: Fix problems with VIM API retry logic
* Create volume fail when image id is ""
* Use cached db object in volume\_mig\_status ext
* Add exception catch if Storwize/SVC driver failed when retyping
* Replace tearDown with addCleanup - Part 5
* Replace tearDown with addCleanup - Part 4
* Enable flake8 H303,H304 checking
* Storwize/SVC driver crashes when check volume copy status
* Switch over to FixedIntervalLoopingCall
* Correct metadata ordering issue in tests
* driver.create/remove\_export() require elevated context
* Inform about instance\_uuid in volume usage notification
* Check for silent failure of tgtadm remove
* GlusterFS: Delete active snapshot file on volume delete
* Fixes HP LeftHand driver with Paramiko 1.13.0
* Fixes cinder error state volume delete on Windows
* Added unit test cases for \_is\_share\_eligible in NFS driver
* Log initialize\_connection error before remove\_export
* Force detach should only be an admin api
* Updated from global requirements
* Change iogrp property when retyping for Storwize/SVC
* Check that all po/pot files are valid
* Allow deprecated volume update keys in v2
* \_translate\_from\_glance() can cause an unnecessary HTTP request
* Adds ionice command permutations to rootwrap filters
* Append nas\_opts to IBMNAS\_NFSDriver configuration
* Enable flake8 F841 checking
* GET details REST API next link missing 'details'
* GlusterFS: Delete volume-<uuid>.info file when volume is deleted
* Fix Jenkins translation jobs
* Fixes HostTestCase failures due to slow test run
* Imported Translations from Transifex
* Updated from global requirements
* Fixes cinder volume delete on Windows
* Fixes cinder volume attach on Windows
* Open Juno development

2014.1.rc1
----------

* Imported Translations from Transifex
* Changes to correct name of missing NetApp license
* NetApp cmode nfs: Fix QOS extra spec
* NetApp cmode iscsi: Fix QOS extra spec
* Fixes a problem in attach volume in EMC driver
* Update config generator from OSLO
* Pass the mirrorlog option as two arguments
* Import request\_id middleware bug fix from oslo
* Netapp iscsi: allow snapshots with unspecified block range
* Serialize the notification payload
* Disable oslo.messaging debug logs
* Updated from global requirements
* Update tests to use CONF.set\_override
* Adds xiv\_chap to xiv/ds8k driver configuration
* vmware: Use SessionIsActive to find stale session
* init\_host should be called before RPC consumer is created
* Add RequestContextSerializer for rpc notifications
* Allow NetApp iSCSI driver to sub-clone large volumes
* Can't force-create snapshot by an non-exist error volume
* Remove rootwrap module
* Simplify test force delete snapshot unit test
* ceph backup driver: improve log messages
* resolve KeyError for IBM Storwize/SVC driver
* vmware: Remove deprecation warning from VC driver
* Remove unused method from NetApp iscsi driver
* vmware: Remove pbm\_default\_policy config option
* VMware: Implement vmdk extend\_volume
* Fix create\_export/remove\_export in driver.py
* Imported Translations from Transifex
* vmware:Ignore inaccessible/inMaintenance datastore
* Ensure name is utf-8 when deleting rbd vol or snap
* Use six.moves.urllib.parse instead of urlparse
* Use the error\_out\_volume from flow common instead
* Revert "Re-enable lazy translation"
* Sync latest Oslo code for imageutils
* Don't send untextified exc to webob
* Imported Translations from Transifex
* Updated from global requirements
* Use debug level logging during unit tests
* Sync log.py from oslo-incubator
* Fixed some FCZM unit tests hacking issues
* Add missing config values for vmwware\_vmdk test
* cinder-rtstool imports a not existing module
* get volumes with limit and filters does not work
* Fixes cinder-volume service startup on Windows
* Fixed nova VM live migration issue with 3PAR
* Adding domain to context
* Switch over to oslosphinx
* Add libffi-dev to list of packages to install in dev env
* VMware: Take the volume size from the user input
* Fix exception message of CoraidESMConfigureError
* vmware: Mark VMware ESX vmdk driver as deprecated
* Fixes ssh-injection error while using chap authentication
* Generate config samples for oslo.messaging
* Add conversion types in some strings
* Port to oslo.messaging
* Updated from global requirements
* get volumes API does not handle limit=0
* EMC SMI-S delete snapshot unit test takes too long
* 3PAR: Support extend volume based on snapshot
* Fixed spelling error - accomodate to accommodate
* GPFS unit tests: increased coverage, uses mock
* Clean Up EMC VNX Direct Driver in Cinder
* gpfs driver: fix logging problems
* Convert cinder utils tests to use mock
* Include next link when default limit is reached
* Re-enable lazy translation
* Sync latest Oslo config code for i18n
* Fix HP LeftHand Performance issue with AO
* NetApp implementation for copy offload in clustered nfs driver

2014.1.b3
---------

* Remove str() from LOG.\* and exceptions
* Storwize volume manage/unmanage support
* Volume manage/unmanage support
* Add user defined extra capabilities
* remove \_check\_container\_exists from Swift backup driver
* Add initiator\_target\_map for IBM Storwize/SVC
* Fix HP LeftHand migration with snapshots
* Updated from global requirements
* Fix docstring ordering
* Typo corrections for test files in cinder
* vmware: PBM wsdl file configuration
* vmware: default global pbm policy configuration
* vmware: check datastore availability during create
* vmware: Storage policy based volume placement
* Add EMC VNX Direct Driver in Cinder
* gpfs volume driver backup file access fixes
* Check if snapshot is deleted cleanly
* Restrict rootwrap find filter for IBM NAS and GPFS
* Add initiator target map in EMC SMI-S FC driver
* GlusterFS: Set permissions on qcow2 snapshot files
* Make EMC SMI-S driver unit tests faster
* change time.sleep to use loopingcall
* Change RBD delete failure log level to warn
* Updated from global requirements
* Update Oslo wiki link in README
* Add versioning output for the FC Zone Manager
* Fix volume stats with multiple LeftHand clusters
* Export and import backup service metadata
* Don't clear host\_state\_map when scheduling
* Add volume metadata backup suport to swift driver
* Add optional ionice to volume clearing process
* Quota delete operation in cinder
* Restrict rootwrap find filter for NetAppNFS driver
* GlusterFS: Increase snapshot delete job timeout to two hours
* Segment LUN clones in NetApp iSCSI
* updating testing readme with more current information
* Remove unused variable
* Python 3: replace "im\_self" by "\_\_self\_\_"
* Update FibreChannel Zone Manager config
* Change warning message in NetApp driver for vsadmin creds
* 3PAR: Fix extend volume GiB to MiB
* TSM backup driver changes to support file backup
* Fix silly error in comment
* 3PAR: Create volume from snapshot with larger size
* Fix free\_capacity reporting in SolidFire driver
* Fix test\_delete\_should\_not\_.. to assert something
* Replace assertEqual(None, \*) with assertIsNone in tests
* Replace tearDown with addCleanup
* Use six.StringIO instead of StringIO.StringIO
* Implement retype in IBM GPFS Driver and refactor
* 3PAR: Delete missing snapshot stuck in error\_del
* Added 3par initiator target map for FCZM
* Fix race in test\_delete\_backup
* Driver for IBM SONAS and Storwize V7000 Unified
* Fix webob.exc.HTTPForbidden parameter miss
* Add snapshot related data to limits api
* Storwize/SVC: Change volume copy task to async
* Fix FC connection handling in the storwize driver
* Sync log.py from oslo
* Replace httplib.HTTPSConnection in unittests
* Add support for FC zone lifecycle management
* Give a way to save why a service has been disabled
* Remove old driver mapping deprecation
* 3PAR: Backend assisted volume migrate
* Add HP MSA Fiber Channel driver
* Ensure return for db api functions
* HP LeftHand Backend assisted volume migrate
* Add support for qos\_specs feature to 3PAR drivers
* Add x-openstack-request-id to cinder responses
* Update 3PAR drivers to pass cert test
* Remove unused function
* Use len instead of for-loop to get the end index
* Ensures NetApp iSCSI driver correctly compares int values for size
* Sync request\_id, request\_utils for cinder
* IBM XIV and DS8000 Driver reorganizing (IBM dir)
* Sync oslo imageutils, strutils to cinder
* GPFS:  Implement volume backup and restore
* Fix missing package dependency for requests
* test\_volume unittest fails if ran only this module
* Fix invalid facilities documented in rootwrap.conf
* Use six.moves cStringIO instead of cStringIO
* NetApp api fix structure conversion methods
* Add support for backing up volume metadata
* Imported Translations from Transifex
* Replace assertEqual(None, \*) with assertIsNone in tests
* Add encrypted flag to volumes
* Implement retype in HP LeftHand driver
* Cast the quota set values to integer before checking their validity
* Remove rabbit\_notifier (Sync notifier with oslo d6e1ba7)
* Remove dependent module py3kcompat
* Add EMC SMI-S FC Driver in Cinder
* Fix wrong example of "nova\_endpoint\_template"
* NetApp eseries iscsi driver implementation
* Update gpfs driver volume creation process
* Deactivate LV before removing
* VMware: changing volumeops tests from mox to mock
* Remove unused exception
* Add searchDepth when getClusterInfo called
* Check type argument on create from source and snap
* Rename Openstack to OpenStack
* Removes use of timeutils.set\_time\_override
* Removed unused context in \_extend\_snapshot method
* Remove unused methods
* Storwize/SVC: Check wwpn not None
* Changes to cast variable as integer as XML API fails
* Ceph backup driver tidyup
* Move create\_, remove\_ and ensure\_export from drivers
* New HP LeftHand array iSCSI driver
* GlusterFS: Fix create/restore backup
* Allow operators to customize max header size
* Fixup persistence file not found on tgt remove
* Remove tox locale overrides
* Add method for unit tests to set logging level
* Brick support for pNFS
* Storwize/SVC: Fix races in host-related functions
* Fix cinder-backup volume restore with ceph driver
* Dont set error\_extending status on API extend call
* Fix misspellings in cinder
* Fixes cinder failed to create/restore a backup with NFS driver
* Brick fix BrickException message formatting
* lvm: unhandled exception when migrating volume
* Implement retype in SolidFire driver
* Validate the quota in the API layer for volume extend
* Rename self.tgtadm to self.target\_helper
* Fix LVM migrate\_volume tests
* Brick connector fix for GlusterFS
* Updated from global requirements
* vmware: intermittent failure in test\_vmware\_vmdk
* RBD unit test improvements
* Move clear\_volume back to it's own method
* Don't use shred for volume\_clear=zero
* Nexenta iSCSI driver: fixed volume\_migration
* Move clear\_volume method to volume.utils
* Add update support to volume type encryption
* LVM: log thin pool name and size upon creation
* Remove create\_export from volume create
* vmdk: To add missing time unit in driver option
* Update SolidFire Driver to use cinder's units
* Update cinder.conf.sample for new keystone client
* LVM: remove redundant casts to float
* On create\_volume flow get rid of host parameter
* Imported Translations from Transifex
* Allow spaces in host names in the storwize driver
* Remove a catching exception during delete\_volume
* Remove SSH code from 3PAR drivers
* Remove unused task from manager create\_volume flow
* Add support for special char in volume metadata
* Brick LVM: Handle space info as numeric types
* Set a sane default for state\_path
* Fixes incorrect key in dictionary
* Stop volume\_type\_encryption creation when in use
* Revert initialize\_connection changes
* Convert ceph backup unit tests from mox to mock
* VolumeManager: initialize even if a volume can't be found
* Add create\_iscsi\_target stub to TargetAdmin
* 3PAR iSCSI volumes attach to single nsp
* Extra\_spec containing '/' can't be deleted
* LVM: Robustify skipactivation detection
* Make sure report\_interval is less than service\_down\_time
* Redundant check in os-migrate\_volume\_completion
* Updated error messages for volume clone
* Imported Translations from Transifex
* Updated from global requirements
* Fix up the way we do iqn variable in unit test
* Catch new iscsi exception
* Delete volume transfer in volume\_destroy function
* Create structure of flows' packages
* Fix docstring and remove unused variable
* GlusterFS: Fix deadlock in volume clone
* Enable multi-process for API service
* Sync RPC module from Oslo
* Sync common modules from Oslo
* Sync py3kcompat, sslutils, versionutils from Oslo
* Sync gettextutils from Oslo
* Storwize driver cleanup
* Add support for retype in Storwize/SVC driver
* Add notifier events to cinder volume rename, reset-state

2014.1.b2
---------

* Convert RBD unit tests to use mock instead of mox
* Fixed inconsistency in iqn
* Update HACKING.rst with regard to mock usage
* Remove unused method 'is\_key\_value\_present()'
* Remove unused config options
* Remove unused exceptions
* Do not show quota of removed volume types in Default Quotas panel
* Fix up calculating space info for mirrored volumes
* Rename \_\_init\_\_.py to create\_volume.py
* Use oslo.rootwrap library instead of local copy
* Fix UnboundLocalError in TgtAdm.update\_iscsi\_target
* Update host on driver retype
* Remove unused variable in restore\_backup method
* Ensure hostnames are converted to IP for comparison
* Add Backup Service to 'cinder-all' script
* Remove env from rootwrap filter
* Allow user to specify audit period
* Fix exception log msg in attach volume method
* Fix import log\_handler error with publish\_errors set
* Use a mirrored mirror log
* Added missing accept\_transfer to FC
* Register EMC config options globally
* Fix os.getlogin() problem with no tty
* Updates for version list to show correct references
* Fix cross-import bug in cinder.db.sqlalchemy.api
* Pull Bug #1263122 fix for service module from Oslo
* Pull latest scheduler change from Oslo
* Use loopingcall from openstack-common
* Use a \*args pass-in instead of a list one
* Remove unused variable in os-extend api
* GlusterFS: Synchronize additional operations
* Move driver initialization check into the method
* Update cinder.conf.sample for keystoneclient change
* Transfer creation doesn't support 'name' via xml
* Change default policy for volume\_extension:volume\_tenant\_attribute
* Print driver exception on retype
* Drop Chance/SimpleScheduler Implementation
* Fix sqlalchemy bug in transfer\_get\_all\_by\_project
* Fix sheepdog copy\_image\_to\_volume method
* NFS/GlusterFS: Skip incorrectly formatted shares
* Remove unused message from iogrp\_data setup
* Remove legacy config option 'connection\_type'
* Modify default prefix for solidfire account
* Add time\_type dictionary to test\_migrations
* 3PAR: Raise Ex when del snapshot with depend vol
* Add bool\_type dictionary to test\_migrations
* Hiding postgresql password in connection string
* Fixed a problem in iSCSI multipath
* Fix the invalid argument of webob.exc.HTTPBadRequest
* Add ability to modify volume type
* Fix downgrade in 002\_quota\_class.py for MySQL
* Removed deprecated config option hp3par\_domain
* Fix Brick LVM test command parsing
* Update V2 API to return detailed volume information on create
* LVM: Fix "intialized" typo in warning msg
* Imported Translations from Transifex
* removed unused context in check\_\*\*\* methods
* add 'force' verification in \_volume\_upload\_image
* Raise max header size to accommodate large tokens
* LVM: update iscsi target on volume attach
* LVM: Activate Thin Pool LV upon initialization
* GlusterFS: Use correct base argument when deleting attached snaps
* Switch to Oslo's config generator
* Removed copyright from empty files
* Remove unused fake\_flags
* Replace Simple/Chance Scheduler with FilterScheduler
* Reduce the redundant variable declarations
* Imported Translations from Transifex
* Remove vim header
* Redundant size check in volume restore api
* Add AllocatedCapacityWeigher
* Imported Translations from Transifex
* Adding helpful URL links to README.rst and HACKING.rst
* Handle terminate\_connection() exception in volume manager
* Empty files shouldn't contain copyright nor license
* Bugfix missing foreign key removal for mysql
* Fix spelling errors
* Imported Translations from Transifex
* Add additional metadata as key-value pairs in 3PAR
* Handle initialize\_connection() exception in volume manager
* Output Strings of bin/\*.py should support i18n
* Add qos\_specs support to solidfire driver
* Service launcher method docstring corrected
* Fix QoS information in initialize\_connection() result
* Fix and enable gating on F401
* Only reverify backing lun when create backing lun
* Set volume\_dd\_blocksize configurable on per-driver basis
* Add exception logging if flow creation fails
* Remove dynamic default on sf\_account\_prefix
* make delete recovery messages debug level
* Remove unused code from volume manager (reset\_stats)
* Pylint fixes for GlusterFS driver
* Pylint fixes for Brick iSCSI/LVM
* 3PAR FC: add ability to add WWNs to host
* Imported Translations from Transifex
* Adjust import order according to PEP8 imports rule
* Do not clone non-raw images in rbd backend
* Adds unit tests for drivers.rbd.RBDImageIOWrapper
* [Netapp/Nexenta] Move registration of config options
* Fix and enable gating on H402
* LVM: Activate source snap LV when cloning from volume
* Remove test that was no longer used for long
* make help text more meaningful for cinder docs
* Switch create volume commands to Taskflow 0.1.1
* Use mock for scheduler tests
* Remove LANG=C from rootwrap invocations
* Add the driver name to get stats log output
* Remove hashbang (#!) at beginning of python modules
* Fix KeyError while generating a WSGI response
* Updated from global requirements
* Lazy log the fixed\_key warnings
* Add disabled\_reason field to services table
* Catch TypeError when new\_size is None on extend
* Sync matchmaker\_ring.py from oslo-incubator
* Add RBD test for volume not existing during delete
* Sync rpc fix from oslo-incubator
* Returns thin pool free space calculated from actual usage
* Brick LVM: Set C locale when gathering PV info
* LVM migration: Check if name is equal to dest\_vg
* Convert lvm\_mirrors to int
* LVM migrate: Use keywords for the brick instance
* LVM: Create thin pools of adequate size
* GlusterFS: Remove glusterfs\_disk\_util option
* Catch ImageBusy exception when deleting rbd volume
* Adds lock for create from vol/snap to avoid race conditions
* Fix docstring for snapshot\_metadata controller
* Fixes case insensitive for resp body
* VMDK:Using host mount info for datastore selection
* Fixes case insensitive for resp body

2014.1.b1
---------

* All API controllers inherit from wsgi.Controller
* delete.start/delete.end notification for hostless
* Fix typo/misspelled words
* Update hacking to hacking>=0.8.0,<0.9
* Add more logging to migrate\_volume\_completion
* Use model\_query() in db.\*\*\*\*\*\_destroy
* Change method name to test\_get\_volume\_stats
* Adjust RBD delete log level
* Bump to sqlalchemy-migrate 0.8.2
* Add unit tests for volume reserve and unreserve
* Don't stop volume service for failed re-export operations
* GlusterFS: Complete snapshot\_delete when info doesn't exist
* Fix typo in cinder
* Imported Translations from Transifex
* Add attach/detach notifications
* Removes dublicated assert from test\_migrations.py
* Use assertAlmostEqual instead of failUnlessAlmostEqual in unit tests
* Fixing check order for empty body in get\_body()
* Updates .gitignore
* Remove unused import and CinderNode sqlalchemy model
* Fix suppressed exceptions for migration downgrade
* Fix the wrong verification for 'readonly'
* Parse out '@' in volume['host'] to do discovery
* Add volume migration code to Nexenta iSCSI volume driver
* Handle NotFound exception in snapshots API code
* Add chance weigher to scheduler
* Redundant body validation for volume\_upload\_image
* Imported Translations from Transifex
* Fix Storwize terminate\_connection with no host
* Fix \_update\_volume\_stats typos
* Remove the redundant judgment for 'restore'
* Make volume\_glance\_metadata\_create compat with DB2
* GlusterFS: Set correct permissions for volume file created via clone
* GlusterFS: Ensure Cinder can write to shares
* The param 'readonly' is incorrect checked
* Fix docstring for Snapshot model
* Make sure report\_interval is less than service\_down\_time
* Ensure 'status' in update\_snapshot\_status
* Update openstack/common/periodic\_task
* Initialize and terminate connection raise 500 err
* Fix docstring for \_migrate\_volume\_completion
* Migrate volume should check para "host" in request
* Continue to delete volumes that DNE in rbd backend
* Pull latest service module from Oslo
* Add greenthread.sleep() to parent wait()
* Fix ./run\_tests.sh -V --virtual-env-name
* Pass the size when fetching image in xenapi driver
* Remove unused code in test\_admin\_actions.py
* Add support for extend volume in GPFS vol driver
* Remove dead code from test\_get\_volume\_stats()
* Remove suffixes from LVM brick test vgs output
* Subclass vendor specific exceptions
* Don't do glance v2 calls when config is set to v1
* LVM: Activate source LV before cloning from it
* Add default quota class into DB during migration
* To fix test\_get\_dss\_rp in test\_vmware\_vmdk.py
* Fix typo in cinder.volume.API
* NetApp fix for vsadmin role failure for ssc
* Create snapshot throws 500 Internal Error
* Fixes inappropriate error message
* NetApp fix free space as zero during 1st vol stats update
* Add valid check and unit tests on quota class
* GlusterFS: Synchronize operations that manipulate qcow2 data
* Check only our VG name when testing if VG exists
* Update quota-set throw 500 error
* Using HttpNfcLease to transfer vmdk files
* Adds extend volume to Dell EqualLogic Driver
* Remove the use of common.uuidutils.gen\_uuid
* Imported Translations from Transifex
* Do not allow bad keys while updating quota
* Use cached volumes in REST API extensions
* Enable object caching in cinder REST API requests
* Nexenta iSCSI driver: extend volume stats of \_update\_volume\_stats
* Fail when image is bigger than the volume
* Update URL for global HACKING document and remove duplicate section
* Retrieve volume image metadata using single query
* Add call to retrieve image metadata for volumes in bulk
* Do not remove volume silently if GPFS is unmounted
* Report zero capacity if GPFS is unmounted
* Nexenta NFS driver refactoring
* RequestContext initialization failed in cinder
* Nexenta: Remove snapshot after volume-clone deletion
* Don't use deprecated module commands
* Remove dup of LVMISCSIDriver in LVMISERDriver
* Remove duplication of ISCSIDriver in ISERDriver
* Support volume\_readonly\_update using XML format
* Fix typo in test\_check\_ssh\_injection\_on error test
* Remove lvm-thin pool\_size config option
* Examine if GPFS is mounted before writing data
* Imported Translations from Transifex
* Remove unused db calls to fetch original metadata
* replace u\2013 char with dash
* Sync log from oslo
* Add tests for LVM -cow clearing
* clean up numeric expressions in test
* Fixes typo in method name \_notify\_voloume\_type\_error
* Allow spaces in quoted SSH command arguments
* Use pipe between ceph backup diff export/import
* Imported Translations from Transifex
* Add missing space to num\_iser\_scan\_tries text
* Add cinder.db.migration.db\_initial\_version()
* remove rundundant lockfile requirement
* Imported Translations from Transifex
* Revert "Brick connector fix for NFS drivers"
* Update my mailmap
* GlusterFS: set correct filename when cloning volume
* Handle NotFound exceptions in API
* Unit test fails in pbuilder environment
* Updated from global requirements
* Check if dir exists before calling listdir
* Rename "rtstool" to "cinder-rtstool", add dep
* Downgrade target create failure mesg to warning
* Nexenta iSCSI driver: Refactor create\_cloned\_volume
* VMware: Registering vmdk opts in global space
* Brick connector revised fix for NFS drivers
* Nexenta drivers ignore "does not exist" exception
* Add openstack/common/crypto from OSLO
* Fix volume transfer href issue
* Remove duplication of brick.iscsi in brick.iser
* Drop auth\_token configs for api-paste.ini
* NetApp unit test fail fix for http\_proxy
* Revert "remove cinder-rtstool because of rtslib dep"
* Let GPFS driver to rename snapshot with root permission
* Imported Translations from Transifex
* NetApp fix for 7mode iscsi volume stats
* Brick connector fix for NFS drivers
* NetApp fix ssc volume filtering inconsistency
* Updated from global requirements
* NetApp fix mirrored stats
* NetApp fix for compression and dedup stats
* Fix generate conf script can't handle multistropt
* Add auth\_token settings to cinder.conf.sample
* Add extend\_volume for Huawei drivers
* Update openstack/common/notifier
* Imported Translations from Transifex
* Apply six for metaclass
* Provide gettext \_ in missing locations
* Nexenta NFS driver: caching for appliance volroot
* Cinder extension to add used resources in absolute limits
* Fix Huawei HVS driver AttributeError
* Storwize: Fix iogrp availability check
* Imported Translations from Transifex
* Uses oslo.imageutils
* Don't zero out thin provisioned LV's on delete
* Fix lvm.extend\_volume to pass Gig suffix
* Nexenta NFS volume driver folder auto sharing
* FK lookup failures during migration
* Initialize shares variables for RemoteFsDriver(s)
* Fix indentation errors in drivers
* Imported Translations from Transifex
* Fix Huawei drivers to support other host OSs
* Fix all occurences of H404 Hacking warning
* Imported Translations from Transifex
* VMware: Fixed upload-to-image for available volume
* Refactor Nexenta iSCSI driver
* Remove unused 'initiator' imports
* Fix tests to work in debug mode
* Updated from global requirements
* Remove whitespace from cfg options
* Remove option count from sample configuration
* improves lvm version parsing for customised builds
* Fix typo in cinder.volume.drivers.nexenta.\_\_init\_\_
* Remove obsolete redhat-eventlet.patch
* long flashcopy operation may block volume service
* Support Huawei driver upgrade from grizzly to havana
* Imported Translations from Transifex
* VMware: Disallow snapshot of attached volume
* Clean up comparison assertions
* Utilizes assertIsNone and assertIsNotNone
* Nexenta volume drivers: refactor NexentaJSONProxy
* remove unused methods in driver.Scheduler
* Imported Translations from Transifex
* Nexenta iSCSI driver fix \_lu\_exists
* Ignore H803 from Hacking
* Drop conf\_key\_mgr warning message!
* VMware: Re-create session for RetrievePropertiesEx
* use cinder utils.get\_root\_helper
* Provide user with more information on quota fail
* Cleanup and more tests for db.api methods
* Fix broken solidfire create-snapshot
* Clean CONF out of brick iser
* Open Icehouse development
* Imported Translations from Transifex
* Add key manager implementation with static key
* Remove need for CONF acces in brick iscsi
* Quotas roll back failure of create volume task
* Remove incorrect class in cinder.conf.sample
* Fixes incorrect class path in logging\_sample.conf
* Storwize SVC driver hostname can't start with number
* After commiting quota we should avoid certain reverts
* Remove CONF from brick remotefs
* Pass through args and kwargs in brick connectors
* Clean CONF out of brick initiator
* Update Babel from Openstack Requirements
* Disable lazy translation
* Improve gpfs config flag help text readability
* Check for backing lun on iscsi target create
* usedevelop in tox
* Fixes ceph backup import errors
* Add XML response tests for qos specs manage ext
* v2 api - return bootable attr value on volume list
* Fixes backup with multiple volume backend
* Dont retry if target creation succeeds
* VMware ESX: Fixes vol clone & clone from snapshot
* Create volume revert fails for non admin user
* VMware: Usng RetrvProprtisEx & does multi ESX scan
* Fix XML serializer for QoS Specs extension
* Fix Huawei HVS driver attaching volume error
* Add debug logging for targets
* Add support for querying the quotas usage
* Validate force\_host\_copy API param for migration
* Imported Translations from Transifex
* Update OpenStack Style Commandments link
* Set vol driver initialized before deleting volumes
* Add error logs for Huawei driver
* Clean CONF out of brick exception
* Fix translation of CinderExceptions in REST API
* Allow upgrade from Grizzly with ThinLVMVolumeDriver
* Use module units for some drivers
* Get host group id when Huawei driver initializing
* Fix mandatory and optional args for create\_volume
* Pass correct args to vol\_rpc create\_volume calls
* Fix processutils.execute errors on windows
* Sync gettextutils from oslo
* LVM volume\_clear: error on unexpected inputs
* Revert "Fix volume\_rpcapi calls for chance/simple scheds"
* Fix finish\_volume\_migration() on SQLAlchemy 0.8.x
* VMware: Handles no datastores case
* Fixes some typos in cinder
* Update rootwrap with code from oslo
* Specific /usr/local/bin/hus-cmd rootwrap filter
* Allow v2 Volume API to create volume with type name
* Imported Translations from Transifex
* Fix volume\_rpcapi calls for chance/simple scheds
* Require assisted\_volume\_snapshots from novaclient
* Fix over-indent in compute/nova
* Add sg\_scan filter to rootwrap
* Add extend to reference LVM driver
* Fix issues with failed lvremove
* GlusterFS: Copy snap from correct source file
* GlusterFS: Use image\_utils for qemu-img calls
* Remove default root\_helper of sudo for remotefs
* Add a retry to create\_iscsi\_target for LVM
* Fix HP3PAR iSCSI path connection
* Added mapper for update\_all on snapshot\_metadata
* Add volume metadata to v2
* Enforce driver is initialized
* Added mapper for snapshot\_metadata
* Fix type change in bootable setting of volume view
* Add logging to prior to raising exceptions
* GPFS Driver missing clone depth limit for snapshots
* remove VolumeNotFoundForInstance class
* Sync gettextutils from oslo
* Use built-in print() instead of print statement
* Fixes vol restore discard final bytes unzeroed
* Fixes call GlanceConnectionFailed in invalid ARG
* Fixes call VolumeNotFound in the invalid argument
* Soft delete tmp migration volume
* Fix \_\_init\_\_ methods of brick initiator connectors
* Fix secure delete for thick LVM snapshots
* assertEquals is deprecated, use assertEqual
* Storwize/SVC: Optional CHAP authentication
* Fix huawei driver test issues
* fix wrong desciption of monkey\_patch config
* Allow display\_name for v2 snapshot-update
* Pass down root\_helper in more cases
* Set rootwrap\_config path to rootwrap.conf
* Do not use qemu-img --backing-chain or --output=json
* VMware driver: Fix for invalid datastore selection
* Fixes ceph volume restore to larger image than source
* Imported Translations from Transifex
* nms.folder.create\_with\_opts not supported on Nexenta 3.1.4.2
* Use $state\_path/conversion for image\_conversion\_dir default
* Improves the parsing way of ssh returns
* Fixes the use of exception.InvalidInput with the wrong arguments
* Remove unused exceptions
* Fix client connection leaks in HP3PAR drivers
* Add default\_availability\_zone configuration option to cinder
* Imported Translations from Transifex
* Turn db model object into a primitive object to avoid error
* Catch generic exceptions
* Add delete support for volume type encryption
* Adds Dell EqualLogic volume driver for Cinder
* Fixing UnicodeEncodeError against volume creating function
* Fix deleting qos specs key
* Move novaclient to requirements.txt
* fix missing unit in log message
* Add check for qemu-img to image\_utils fetch\_to\_raw
* Changed header from LLC to Foundation based on trademark policies
* Fixed erroneous force full copy in ceph backup driver
* Call to\_primitive on volumes.rpcapi.create\_volume
* Fix typo in cinder.tests.test\_create\_volume\_flow
* Fix Qos Specs association corner case
* Fixes pep8 violation in nova
* Fix bug in Nexenta NFS driver \_do\_create\_volume
* Restrict Volume type deletion with volumes assoc
* Replace assertEquals with assertEqual - 2/2
* Check cinder-backup service before "backing-up"
* Do not attempt vg.update on uninitialized vg
* Replace assertEquals with assertEqual - 1/2
* Add support for LocalConnector type in brick
* Remove unused/redundant methods in cinder/test.py
* Fix error casting value to float in lvm.py
* Fixes misuse of assertTrue in test scripts
* Utilizes assertIsNotNone
* Utilize assertIsInstance
* Remove deprecated assert\_() usage
* Fix brick remotefs dependency on cinder
* Remove quota fetch race condition
* Synchronize extend\_volume methods in 3PAR drivers
* Added copy-on-write support for all RBD cloning

2013.2.b3
---------

* fix log string in conversion type
* VMDK copy\_image\_to\_volume and copy\_volume\_to\_image
* Validate VV Set exists in 3PAR drivers
* This adds a README to brick
* Fix tuple usage error
* Fixes brick Nova pep8 violation for lvm.py
* fix inconsistent i18n log message
* QEMU-assisted-snapshots for GlusterFS volumes
* Add view builder to QoS specs API extension
* Add features to Zadara Storage Cinder driver
* Use tempfile and cleanup in windows unit test
* Adds Nexenta NFS driver
* Set vg\_thin\_pool to pool name instead of pool\_path
* Fixes cinder-volume service startup on Windows
* extract 'limits.' to constant for ratelimiting logic
* Send notifications when extending volume
* Fix errors in volume usage audit script
* New update\_snapshot\_status API
* Add volume driver for Huawei HVS storage system
* Increase test coverage for cinder.utils
* Add Fibre Channel drivers for Huawei storage systems
* Refactor huawei Dorado array iSCSI driver
* Refactor Huawei iSCSI driver
* Enable gating on F811
* Add support for Havana missing features in Windows driver
* Add venv wrapper for check\_uptodate.sh
* Clone volume with right size with SolidFire
* Fixes bug to allow for encrypted volume deletion
* Sync rpc fix from oslo-incubator
* Move comment back to right place
* copy\_image\_to\_volume for Nexenta volume driver
* Fix pep8 violation in backup
* Utilizes assertIn and assertNotIn
* Implements APIs for VMDK driver
* Remove \_create\_volume function from several tests
* Don't need to init testr explicitly
* Add missing LH SAN driver features for Havana
* Multi storage backend support for Nexenta driver
* Fix typo in bin/cinder-volume-usage-audit
* Remove unused methods from cinder.utils
* Increase test coverage for cinder.image.image\_utils
* Add kwargs to create\_volume in tests/utils.py
* Update the version for the FC and iSCSI driver
* Pass MB size on copy\_volume\_data call copy\_volume
* Adding Read-Only volume attaching support to Cinder
* Add NFS/GlusterFS support to brick library
* Pass db into driver as constructor's parameter
* Modified 3PAR drives to support 3parclient 2.0.0
* Move create\_volume flow to a subfolder
* Import order cleanup
* Migrate manage script needs import of db session module
* Migration for attached volumes
* Add optimized volume migration to Storwize/SVC
* Fix quota update validation for non-int types
* Imported Translations from Transifex
* Removes exception instance creation on execute()
* Fix except in lvm.py
* Add automated check of conf sample
* Remove deprecated code from Nexenta Exception class
* Sync up with global requirements
* Extend volume for GlusterFS
* Offline snapshots for GlusterFS volumes
* Ensure that qpid connection is closed (from oslo)
* Imported Translations from Transifex
* Test WWNs with basestring
* Imported Translations from Transifex
* Remove print statement in db api test
* Ignore stmf target must be offline exception
* Sync execute() related exceptions with oslo
* The DB migration shouldn't populate types table
* Use a new rest client for every Coraid ESM command
* Remove unused methods from LVM driver
* Storwize/SVC: allow setting of I/O group
* Implement QoS support for volumes
* Move the frequently injection task to the base folder
* Move root task class to base file
* Backup driver for IBM Tivoli Storage manager (TSM)
* Dont crash service if sf cluster isnt available
* 3PAR driver add missing domain check on QOS cmd
* Remove unused methods from cinder.utils
* Refactor cinder/tests/test\_volume.py
* Unified Volume Driver for IBM XIV and IBM DS8K
* Adds brick helpers to cinder utils
* Fix python 3 pep8 errors for print
* Fix incorrect msgstr's to avoid translation errors
* GPFS use clone\_image for creating volumes
* 3PAR driver terminate connection host validation
* Re-enable a lot of cinder scheduler tests
* emit warning while running flake8 without virtual env
* Set bootable flag for volume cloned from image
* Remove unused methods from cinder.utils
* Clean up the sqlalchemy migrate manage.py script
* Allow to delete a volume in error\_extending status
* Update Brick to use executor
* flake8 H202 error in test\_image\_utils.py
* Removes ssh\_execute in utils.py
* Fix volume\_glance\_metadata deletion
* Use system locale when Accept-Language header is not provided
* Generic backup\_volume and restore\_backup functions
* Relax policy so owner can access encryption info
* Fix Fibre Channel attach for single WWN
* Make the SolidFire driver api port configurable
* Add accept\_transfer to solidfire driver
* Added need info to accept\_transfer
* Allow volume create from source unless in error status
* Avoid serializing CinderExceptions before they are translated
* Add root\_helper param to get\_connector\_properties
* Standardize on ID for log messages
* Reduce hidden effects of sqlalchemy objects
* Removed need for domain in 3PAR drivers
* Allow Cinder to call Nova client
* Use FakeLoopingCall instead of the real one
* Fix some pylint error in Coraid Driver
* Storwize/SVC: More error logging
* Remove strcmp\_const\_time
* Refactor LVM driver to use Brick VG utility
* Added missing import
* Fixes SSH injection threat in 3PAR driver
* Implement missing Coraid Driver functionality for Havana
* Increase test coverage brick/initiator/connector
* Fix SSH injection threat in 3PAR driver
* refactor/unify driver version strings
* Refactor Nexenta driver
* Update Nexenta ISCSI volume driver authors
* Extract ISCSI tries option into connector module
* Externalize error messages in the v2 API
* Add more asserts to the limiter unit tests to test the RateLimit
* Replace os.unlink with delete\_if\_exists
* No need to declare the exception conf
* Add support for encrypted volumes
* Add tests for cinder/brick/initiator/connector
* Tidy up the SSH call to avoid injection attacks for HP's driver
* Raise exception when Glance metadata not found
* Interprete scoped key as nested tags
* Adding the -online option to the 3PAR clone
* Fixes some unseen flake8 violations
* Fixes volume clone from volume
* Fixes docstring formats in connector.py
* Fixes files with wrong bitmode
* Add unit tests for cinder/api/contrib/quotas
* remove Brick deps on cinder.exception
* Remove Brick iser dependency on cinder
* Fix handling ImageUnacceptable in create\_volume
* Use native methods for list manipulation
* Fix signature of \_create\_volume() in ThinLVMVolumeDriver
* Add H233 to ignores in tox.ini
* Imported Translations from Transifex
* Add support for volume cloning to Nexenta driver
* Fix ratelimiting
* GPFS support for various volume attributes
* Upgrade Scality driver to match minimum features
* Ignore purge\_props for v2 Glance api and fix upload
* Add support for API message localization
* 3PAR drivers creating incorrect comment data
* Imported Translations from Transifex
* Use utils.safe\_minidom\_parse\_string in extensions
* Move resource usage sync functions to db backend
* Imported Translations from Transifex
* Refactoring of create\_volume to use taskflow
* Add minimum features in HDS driver (for Havana & Icehouse)
* Ignore stmf target must be offline exception
* Added glance\_request\_timeout config option
* Set lock\_path in tests
* 3PAR volumes created from snaps failed to attach
* Add test for brick.local\_dev.lvm
* Imported Translations from Transifex
* Remove Brick's iscsi dependency on cinder
* Remove locals() from iser
* Move volume\_clear and clear\_size opts up to driver
* Imported Translations from Transifex
* Set the concurrent connections on the 3PAR array
* Create key manager interface
* Remove usage of obsolete oslo.exception
* Fixes create rbd volume from image v1 glance api
* Imported Translations from Transifex
* Remove Storage Manager from cinder-manage
* Remove cinder.exception from Brick
* Add bin directory to flake8 when not in venv
* Add support for volume extension to Nexenta Systems volume driver
* GPFS Verify min release level for mmclone command
* Sync gettextutils from oslo
* Add eclipse project files to .gitignore
* Remove unnecessary metadata from the 3PAR drivers
* Adding support for iSER transport protocol
* NetApp fix clone image compatibility issue with ssc
* Set bootable flag for volume serializer
* Fix chown fail for nfs file without necessary permission
* Add new persona value in the 3PAR driver
* Update driver version to 1.1
* Fix NetApp iscsi drivers for cinder backup
* Fix pep8 and pylint violation in Nexenta volume driver
* Test tools barfs on reusage of 'id' attribute
* Ignore "volume does not exist error"
* Call get\_session() only when necessary
* Fix volume\_create()/snapshot\_create() DB methods
* Execute DB API methods in a single transaction
* Improve DB API test coverage
* Fix check for mount.nfs helper installation
* Imported Translations from Transifex
* Remove xen storage manager tables
* Remove unused migration\_\* methods from db api
* Factorize code between nfs.py and glusterfs.py
* NetApp fix create vol different size than snapshot
* LVM / Block Device Drivers: Fix duplicated flags
* tox.ini: Change sitepackages to False
* Tidy up the SSH call to avoid injection attacks in storwize\_svc
* NetApp check for 7 mode controller version
* Storwize/SVC: Use reserved percentage from conf
* Imported Translations from Transifex
* Pop out 'offset' and 'limit' before use for filter
* Imported Translations from Transifex
* Fix running of migrations tests by Jenkins gate
* Update to latest oslo rootwrap
* Make unicode-to-utf8 conversion universal in ceph backup driver
* Add more info to delete error message
* Update references with new Mailing List location
* Allow connect by FC-only or iSCSI-only systems
* NetApp NFS efficient clone\_image impl
* Removed the dep on cinder.utils
* Fix the multi-backend storge issue for ZMQ
* NetApp storage service feature support
* Imported Translations from Transifex
* Create volume from snapshot must be in the same AZ as snapshot
* Using volume name property instead of using template and id
* Fix unit suffix and add no\_suffix option
* GPFS stub calls to truncate and dd in unit tests
* Storwize/SVC: Use VolumeDriver's copy vol<->image
* Implements extend volume feature in HP 3PAR driver
* use encode('utf8') instead of str()
* Imported Translations from Transifex
* Migration for detached volumes with no snaps
* Fix cinder error for deprecated Netapp drivers
* get\_snapshot should populate the snapshot metadata
* Adding driver minimum features and volume stats to dev doc
* Update RBD driver to be compliant with HACKING
* GPFS convert glance image to raw only when needed
* Fix oslo.config.cfg.NoSuchOptError when running individual tests
* Fixes RBD driver docstring format issues
* fix name 'update\_volume\_status' to 'update\_volume\_stats'
* use 'exc\_info=1' instead of import traceback
* Fix further Hacking 0.6.x warnings
* Add create & attach times to SolidFire attributes
* Implement extend volume for Storwize/SVC
* Cleanup README.rst
* Fix volumes search by metadata
* Add test for volume status check when extending
* 3PAR Driver modifications to support QOS
* Make Storwize/SVC tests work without simulator
* Revert hardening of Storwize/SVC SSH commands
* Clone\_image method added image\_id as parameter
* Added incremental backup support to Ceph backup driver
* Sync gettextutils from oslo
* Imported Translations from Transifex
* Fix duplicate config options
* Move copy\_volume function to volume/utils.py
* Fixes default value of use\_default\_quota\_class
* Imported Translations from Transifex
* Delete snapshot metadata when snapshot is deleted
* Tidy up the SSH call to avoid injection attacks in storwize\_svc
* Fix extend\_volume error handling
* Fixes race condition in LVMVolumeDriver create\_cloned\_volume method
* Checks the volume\_clear flag and just return if it is none

2013.2.b2
---------

* Fixes Opt type of use\_multipath\_for\_image\_xfer
* Fixes Opt types in cinder/backup/drivers/ceph.py
* Fix indent in cincer/volume/configuration.py
* Implement validate\_connector for Storwize/SVC
* Fix error when QuotaUsage.updated\_at is NULL
* Rename SolidFire driver for consistency
* Add Brick Fibre Channel attach/detach support
* Increase timeout period for clone volume
* Be sure to check deleted types on quota update
* CoraidDriver: Allow volumes in error state to be deleted
* Adds multiple iSCSI port support to 3PAR
* Implement extend volume functionality in Sheepdog
* Mark methods used in class only with prefix "\_"
* Add te field user\_id into the volume detailed information
* Catch additional connect fail cases
* Clean up Huawei tmp files from tests
* Add flag argument to 'cinder-manage config list'
* Imported Translations from Transifex
* Add generic block device driver
* Use base ISCSI driver to fulfill some driver requirements
* Cleanup and make HACKING.rst DRYer
* Clone\_image should return dict of vol properties, clone status
* Update requirements from openstack/requirements
* Refactor SSHPool.get() to use Pool.get()
* Enable zero the snapshot when delete snapshot in LVMVolumeDriver
* Fixes ceph-backup failure if original volume deleted
* Implement extend volume functionality in Rbd
* Handle errors raised by extend\_volume
* Minor reorg for (array resource usage and backend options naming)
* Check enabled backup service before rpc request
* Fixed Ceph backup librbd segfault
* Add support to import images into sheepdog volumes
* Add tests for cinder/api/urlmap.py
* remove improper assert usage
* Enable setting blocksize on volumes
*     cinder.api: Replace 'locals()' with explicit values
* Update upper bound of keystoneclient version
* Fix missing volume\_name\_template flag
* Change check-detach to reject more states
* Implement extend volume functionality in SolidFire
* Add unit tests for cinder/api/versions
* Make String column creation compatible with SQLAlchemy 0.8
* Remove suds requirement
* Add support for storing volumes on GPFS
* Consist terminate\_connection function signature
* SolidFire API RequestID is useless
* Add ability to specify SolidFire API version
* Refactor reschedule in exception handling of volume manager
* Don't pass 'session' arg to public DB API methods
* Add interface class for backup drivers
* Prevent wrongly privilege escalation of a context
* Move brick initiator tests to brick subdirectory
* Fix extent size issue when creating thin pool
* Sync install\_venv\_common from oslo
* Fix a few Sphinx warnings
* Ignore files created by Sphinx build
* Use oslo.sphinx and remove local copy of doc theme
* Add unit tests for cinder/api/contrib/volume\_actions
* Scheduler should not select down volume managers
* Add check for snapshot to Brick LVM
* Fix typo 'Flase' -> 'False'
* Rename cinder.flags to cinder.common.config
* Add execute wrapper to brick LVM code
* Imported Translations from Transifex
* CoraidDriver: Create\_volume\_from\_snapshot of a different size
* Make os-services API extension consistent
* Imported Translations from Transifex
* Removes 3PAR domain option from cinder config file
* Skip brick\_initiator test in virtual environments
* Added Cinder volume backup to Ceph support
* Handle ECONNREFUSED exception in SolidFire driver
* Add os-availability-zone extension
* Run flake8 also on cinder/\*/openstack
* Imported Translations from Transifex
* Quotas by Volume Type
* xenapi: implement xenserver image to volume
* Save some more image attributes to volume\_glance\_metadata
* Fix check\_for\_setup\_error for sheepdog driver
* Add Brick iSCSI attach/detach
* Added volume backup and restore to Ceph RBD driver
* Fix service alive information in os-services extension
* Calculate count for customized dd blocksize
* Content-length missing in put\_object
* Replace glance\_metadata check with bootable column
* Imported Translations from Transifex
* Avoid winning the useless use of cat award
* Fix up trivial H103 license check mismatches
* Register used CONF entries in cinder.api.common.py
* Fix and enable gating on H401
* Do not raise NEW exceptions
*         cinder.[brick,db,image] Replace 'locals()'
* Update kombu requirement
* Remove usage of locals() for formatting from cinder.tests.\*
* Adds create\_from\_volume test cases
* Use list comprehensions when possible
* NetApp:iSCSI drivers reserved percent need to change to 0
* Add support for swift user/key authentication
* Refactor the backup method of SwiftBackupService
* Imported Translations from Transifex
* NetApp unified driver implementation
* Add \_create\_volume to ThinLVMVolumeDriver
* Add the project name into CinderKeystoneContext
* Add build directory to flake8 ignore dirs
* Add missing extend volume test (rpcapi)
* fix error class path in logging sample
* Modify check for volume-type-id to a get w/default
* Don't perform retry\_execute in certain cases
* Adding host attaching support to Cinder
* Update attach status when instance id invalid
* Fix and enable gating on H403
* Use Python 3.x compatible except construct
* cinder.backup: Replace 'locals()' with explicit values
* cinder/.: replace 'locals()' with explicit values
* Editable default quota support for cinder
* Imported Translations from Transifex
* Use common.processutils.execute
* Remove usage of locals() for formatting from cinder.volume.\*
* cinder.schedule: Replace 'locals()' with explicit values
* Imported Translations from Transifex
* Remove the 'migrate' option from cinder-manage
* Use Python 3.x compatible octal numbers
* Use Python 3.x compatible except: construct
* Update and add notifiers in create volume
* Imported Translations from Transifex
